Attribute VB_Name = "mod_LL_USB"

'recent updates
'2-6-15, 4-9-15, 4-9-15c, 4-10-15, 4-13-15b
'7-27-15 to 7-27-15f
'7-28-15 to 7-28-15g
'7-29-15 to 7-29-15g
'8-28-15
'9-1-15 fixed averaging. There is a flag used to fill the average array with the first point during the first scan.
'  however, the flag was being cleared after the first point, rather than the first scan off all points so only
'  the first point of the first scan was averaged correctly during the first scan.
'10-14-15 added message box that appears at startup if another instance of app is running. Fixed chan color disabled
'  when channel count is changed.
'10-19-15 start work on cal-scans
'10-20-15 more work on cal-scans
'10-21-15 more work on cal-scans
'10-21-15b '10-21-15c '10-21-15d '10-21-15e
'10-22-15 '10-22-15b '10-22-15c  '10-22-15c various things - fixed sec/scrn was min 10, lost pixels at 600 sec/scrn
'10-22-15e removed 201 fudge where screen width is made different by subtracting 105

'10-23-15 '10-23-15b '10-23-15c prevent loss of pixesl at 600 sec/scrn and autoscale fix
'10-23-15d autoscale fix use only data being displayed.
'10-23-15e fixed channel check boxes so in multi-chan mode all channels below high-checked channel check when saved.
'10-23-15f  fixed txtPosFullScale > 5.0000 on startup

'1-14-16 put handling of autoscale back in (was commented) and added the lines:
'    dblGraphVoltsMax = -5
'    dblGraphVoltsMin = 5
'    If dVoltage_EMF16(bMainChan, bSubChanIndex) > dblGraphVoltsMax Then dblGraphVoltsMax = dVoltage_EMF16(bMainChan, bSubChanIndex)
'    If dVoltage_EMF16(bMainChan, bSubChanIndex) < dblGraphVoltsMin Then dblGraphVoltsMin = dVoltage_EMF16(bMainChan, bSubChanIndex)
'1-14-16 also added in BtnAutoCenter_Click, but it MAY NOT be needed. Didn't remove it since Tom is testing it with it in
'    Dim bRetVal As Byte
'    bRetVal = DoPlotWrap(bMainChan, dblX - dblActualGraphRightEdge)

'1-20-16 fixed problem with wrapping of plot was overwriting green line at bottom of graph:
'replaced: frmGraph_EMF16.Line (dblLastX, 0)-Step(dblPixPerPoint_local + 60#, frmGraph_EMF16.Height), RGB(255, 0, 0), BF
'    with: frmGraph_EMF16.Line (dblLastX, 0)-Step(dblPixPerPoint_local + 60#, frmGraph_EMF16.Height - 2500), RGB(0, 0, 0), BF
'NOTE: plot line goes down to bottom of screen and there is a problem, the "- 2500" may need tweaked.
'11-23-16 modified handling of rate which even though the DLL recalculates the rate, it doesn't share that information with this
' app. So I copied the "actual rate" calculation code from the DLL and put it into this app so I can display that actual rate in
' the rate box and also use it for calculating the plotting parameters.
'11-28-16, '11-29-16: added functionality for optimizing based on 60/50Hz. Required some new variables, new form, and procedures.
'12-1-16 lots of changes involving line frequency adjustment code
'12-2-16 lots of changes involving handling of rate - adjusted and requested
'12-2-16b, '12-2-16c more fixing of rate handling including allowing 1050Hz, but had to do it calling EX_Connect since EX_SendRate only
'  allows rate up to 1000Hz inside the DLL.
'12-5-16 added handling for error resulting from pressing 50 or 60 "optimize" button with log interval box empty
'12-6-16 channges made to multi-chan scan averaging. Added calls to EX_GetRequestedRate(...) and  EX_GetCalculatedRate(...)
'  in order to update current rate correctly. Had to do some modifications to handling of user "requested" rate and "actual" rate
'  to make it all work so that anytime a sending of the rate is done, the requested rate is used to avoid it being modified each
'  time by the DLL.
'12-7-16 some changes from 12-6-16 undone and new ones made concerning the handling of multi-chan scan averaging also reset
' scan average array index in single-chan scan averging procedure to 0. the same time bVoltAvgArrayFirstTimeInFlag is cleared
'12-8-16 more changes to auto-optimize for 50/60 Hz, and improving error handling when a scan is halted for some reason, or
' when board is disconnected.
'12-9-16 more error handling fixes/changes.
'12-9-16b fixed error associated with now CHOffset.ini nor CHOffset.cal. I now create a CHOffset.cal in that scenario with all
' entries set to 0.000000
'2-10-17 fixed error handling and error message associated with
'   "If Scan_EMF16_Setup(m30x.usDevId) = 0 Then"
' now try to signon again, and if that fails display the message:
'  "Scan Run Startup failed"  instead of  "LL_USBS_Graphics Setup failed"
'2-13-17 and 2-14-17  many things implemented to recover from cable disconnect while scanning followed by quick signon attempt
' problems were associated with scan thread not really having time to exit correctly since once the cable is disconnected, there is
' no longer an id associated with it to do the proper cleanup. Then to signon again quickly, the device may not have even been enumerated
' at the time of the new signon.
'4-7-17 NOTE: Problem shown when Tom was scanning, would leave room then return later. Sometimes without turning no the monitor, he'd
' switch a switch connected to the hardware and then noticed that the plot was no longer plotting. There was no indication on the screen
' that the scan had stopped. When he pressed the scan stop button, the plot would then plot a period of data.
' What seemed to me to be happening is when scanning and scan stop button was pressed, was falling through, past data-taking loop, ending
' scan, and then exiting without waiting for the actual loop to complete. Tried adding a flag to wait for the loop to complete, but
' that seemed to pause the loop since I was re-entrant within this procedure. So, just set the flag for the loop to end, and
' return, allowing it to reset the button on the start/stop scan button.
' Also now checking the return value:     bRetVal = EX_CheckScanStatus(usDevId, uiNumScansRemainingInBuff, fStillScanning, uiErrCode)
'  if 0 then it's no longer scanning but may not return either HALTED or DISCONNECT
'6-23-17 lots of new code to fix the problem with plot stopping when monitor is shut off in power-saving mode, then turns back on,
' specifically with the "Alt" key but could be in other turn-back-on scenarious as well. Search on this date to see the changes.
'2-20-18 moved chkSimplifiedMode and chkXtraDbg out of view on main panel to out of site to make room for digital I/O
'  seatch date to see changes to allow digital I/O
'2-20-18 moved some more things around and added analog output via a new frame that appears as with the rate change frame
'3-19-18 added a sleep after creating M30x_grf.ini when it didn't originally exist because it seems WinXP is a little slow creating
'  it and so without the sleep, the code was attempting to read from it before WinXP had finished creating it, throwing an exception.

Option Explicit

'2-20-18
Public bDigOutVal As Byte
Public bDiginVal As Byte



'6-23-17
Public mainFormHasFocus As Boolean

'4-7-17 following just moved to here from elsewhere so it could be used more globally, as in returning from the
' data-taking call made by the data-taking loop within the scan procedure
Public fEMF16_IsRunning As Boolean

'2-14-17
Public timerCntr As Long

'12-5-16f
Public fDontShowRateChangeSave As Boolean

'12-2-16b
Public fSignonRateSendFailed As Boolean

'11-28-16 variable names as used by Tom's sample code
' kept same to make it easy for him to review my code
Public li As Double
Public lf As Double
Public reqr As Double
Public actr As Double
Public minli As Double
Public adjscanrate As Double
Public adjscaninterval As Double
Public dblAutoOptimizeUserInput As Double


'11-23-16
Public dblUserRequestedRateSave As Double

'10-23-15
Public dblGraphVoltsMax As Double
Public dblGraphVoltsMin As Double

'9-1-15
Public bFirstScanAvgLoadPointCnt As Byte

Public Const SCAN_STILL_RUNNING = 0
Public Const NOT_SCANNING = &H1
Public Const HALTED = &H2
Public Const DISCONNECT = &H4
Public Const NO_SCANS = &H8
Public Const MISSING_DIGIN_BUFF = &H10
Public Const BUFF_TOO_SMALL = &H20
Public Const MICRO_BUFF_WRAP = &H40
Public Const MEM1_BUFF_WRAP = &H80
Public Const MEM2_BUFF_WRAP = &H100
Public Const NO_DATA = &H200

'8-1-15b start ####
Public dblDRF_STA As Double                  'Data Reduction Factor ScansToAverage
Public dDRF_ChanVoltageArray(6) As Double
'8-1-15b end ######

'10-21-15c
Public dDRF_ChanVoltageOffset As Double
Public calScanOffsetVal_global As Double

Public fComingFromTextScreen As Boolean
Public dblGlobalScreenWidth As Double
Public fScanStartupBusy As Boolean
Public dblScanStartTime As Double
Public dblScanEndTime As Double
Public fFirstScan As Boolean
Public fIsloading As Boolean    'prevents notification that config parameters need saved when they are changed during app loading
Public bDisplayChan As Byte
Public doDbgDLL As Boolean
Public scanDataRedimSize As Integer
Public scanDataRedimSize_Last As Integer
Public Const SCAN_USE_DATA_LOG_FILE = 1
Public Const SCAN_USE_DATA_ARRAY = 2
Public Const SCAN_STOP_ON_DATA_ARRAY_WRAP = 4
Public Const SCAN_LIMIT_LOG_FILE_SIZE = 8
Public Const MAX_PATH = 260     'for windows path to copy .ini to windows folder if not already there
Public noIniNoRun As Boolean
Public scanRateForDllRead As Single
Public bChanCntDoneCnt As Byte
Public bMainChanCnt As Byte
Public bLogScanVal As Byte
Public strScanLogfileComment As String
Public dVoltage_EMF16_LOG(6, 16) As Double
Public iScanAvg As Integer
Public fMainFormDoneLoad As Boolean
Public fScanTimerOkToRun As Boolean

'START OF EMF16 variables
Public fSignedOnThisDev(32) As Boolean
Public bCurMainChan_Global_EMF16 As Byte
Public dVoltage_EMF16(6, 16) As Double
Public dVoltageValid_EMF16(6, 16) As Double
Public fGraphicScreenClearPending_EMF16 As Boolean
Public scanCnt As Double
Public dblScanCntTemp As Double
Public fRecordOffsetsNow As Boolean
Public bLocalAvg As Byte
Public fVoltageAvgArraysNeedsInit_Pending As Boolean
Public dblScanNum As Double
Public dblAutoScaleVoltages(16) As Double
Public dPrevVoltages(6, 16) As Double
Public LYPixTotal As Long
Public LXPixTotal As Long
Public LLastY(16) As Long
Public fClearGraphicScreenNow As Boolean
Public dblActualGraphRightEdge As Double
Public LDotCol As Long
Public dVoltageValid(6, 16) As Double
Public bCurGraphSubChan_Global As Byte
Public lngScanChanColors(15) As Long
Public bChanCnt As Byte
Public dblMaxFullScale As Double
Public dblMinFullScale As Double
Type M_30x
    '8-12-11 comPort As Integer           'Serial port COM 1 through 4
    usDevId As Integer           'M30x device Id
    scanInterval As Double       'Scan Interval in seconds
    numChannels As Integer       'Number of channels for multi-channel scan
    tScan As Integer             '0=single chan, 1=normal scan, 2=cal scan
    chan(0 To 5) As Integer      'channel selection codes for multi-chan scan
    singleChan As Integer        'channel selection code for single-chan scan
    lastDigInp As Integer        'last valid digital input word
    version As Integer           'microcode Version, read from Model 201
    channel As Integer           'Current selected channel 0-7
    subChan As Integer           'Current selected sub-channel 0-15
    rawCount As Long             'unscaled A/D count 0 to 16,777,215
    voltage As Double            'voltage in MV
    digOutWord As Long           'digital output word
    wordCnt As Integer           'A/D word count. 2= 16-bit mode, 3= 24-bit
    biPolar As Integer           'Unipolar/bipolar flag. 0= bi, 1= uni
    errorType As Long            'error code from dll GetOneScan function
    filter As Integer            'filter freq. 2= 400Hz, 1= 40, 0= 4Hz
    gain As Integer              'power of 2 for gain. 1=x1, 2=x2, 4=x4, etc
    rate As Single               'internal data rate for A/D
    modeRegLo As Integer         'low byte of compacted A/D mode
    modeRegMid As Integer        'mid byte of compacted A/D mode
    modeRegHi As Integer         'high byte of compacted A/D mode
    BAUD As Integer              '0= 9600, 1= 4800, 2= 2400 . . . 5 = 300
    sleeping As Integer          'Flag. 1= asleep, 0= awake
    standBy As Integer           'Flag. 1= in standby, 0= operating
    timeBaseCnt As Long          'not used(placeholder only), for Model 202 only
    average As Long              'digital averaging in 201 (powers of 2)
    TXQUEUESIZE As Long          'transmit buffer size (not used).
    RXQUEUESIZE As Long          'receive buffer size. 16 to 32767
End Type
'the above structure will need changed. Just using it as-is now while transferring code from 201 to this app.
Public m30x As M_30x             'M30x structure to match m201 structured data shared with DLL
Public Const MAX_DEV_CNT = 32
Public sLLABS_DeviceIDList(MAX_DEV_CNT) As Integer
Public m30x_list(MAX_DEV_CNT) As M_30x
Public bFragmentedGraphChanSelectList(16) As Byte
Public bGraphFullScalePosIsNeg As Byte
Public bGraphFullScaleNegIsPos As Byte
Public bCurMainChan_Global As Byte
Public fGraphicScreenClearPending As Boolean
Public dblMinMaxSubVolts(16) As Double
Public dblPixsPerSecond As Double
Public bAutoScale As Byte
Public fIsEMFapp As Boolean
Public Const CONFIG_COM = 0
Public Const CONFIG_BAUD = 1
Public Const CONFIG_RATE = 2
Public Const CONFIG_REMOTE_AVG = 3
Public Const CONFIG_LOCAL_AVG = 4
Public Const CONFIG_GAIN = 5
Public Const CONFIG_SAVE_LOG = 6
Public Const CONFIG_GRAPH_AUTOSCALE = 7
Public Const CONFIG_GRAPH_SCALE_MAX = 8
Public Const CONFIG_GRAPH_SCALE_MIN = 9
Public Const CONFIG_GRAPH_SEC_PER_SCRN = 10
Public Const CONFIG_MISC_USE_OFFSET_VOLTS = 11
Public Const CONFIG_tSCAN = 12
Public Const CONFIG_SCAN_CHANS = 13
Public Const CONFIG_SCAN_INTERVAL = 14
Public Const CONFIG_DEVICE_ID = 15
Public Const CONFIG_DRF_STA = 16        '8-1-15d

Public Const CONFIG_ARRAY_SIZE = 16     '8-1-15d was 15

Public bConfigChanges(CONFIG_ARRAY_SIZE + 1) As Byte
Public bUseOffsetVoltages As Byte
Public fSetOffsetsToZero As Boolean
Public dblOffsetVoltages(6, 16) As Double
Public dblOffsetVoltages_TEMP(6, 16) As Double
Public dblScanRate_EMF16 As Double
'tim note, this is temporary until .ini file is in place
'  and m30x.chan can be used instead
Public bScanChn0_save(15) As Byte
Public bScanChn1_save(15) As Byte
Public bScanChn2_save(15) As Byte
Public bScanChn3_save(15) As Byte
Public bScanChn4_save(15) As Byte
Public bScanChn5_save(15) As Byte
Public dblMaxTime As Double
Public dblMinTime As Double
Public iSingleChan_SAVE As Integer
Public bScanType_SAVE As Byte
Public iAverage_TEMP As Long
Public bLogScanVal_EMF16 As Byte
Public fIsEMF_Scan As Boolean


Public dblScanDigoutWaitStartSRI(32) As Double
Public fScanDigoutWaitBusySRI(32) As Boolean
Public fUseNewConfig As Boolean
Public vScanDigIOdup_Timer(32) As Variant
Public bUseInHouseAutoConfig As Byte
Public bDigoutShopTest As Byte

'from config.ini
'[301]
Public CC_bScanType As Byte
Public CC_iScanAvg As Integer
Public CC_bScanDoDiginScan  As Byte
Public CC_bScanDoCalScan As Byte
Public CC_bScanNumChans As Byte
Public CC_bScanChanForSingleChanScan  As Byte

Public CC_dblInternalDataRate As Double

Public CC_dblDAC0_Volts As Double
Public CC_dblDAC1_Volts As Double
Public CC_dblDAC2_Volts As Double

'========================================
'======= START IN-HOUSE testing =========
'#define SCAN_END_REQUEST           0x01
'#define SCAN_END_REQUEST_ACK       0x02
'#define SCAN_END_REQUEST_SENT      0x04
'#define SCAN_END_REQUEST_PENDING   0x08
'#define SCAN_END_REQUEST_FAILED    0x10
'#define SCAN_END_REQUEST_SUCCEEDED 0x20
'#define SCAN_DRIVER_THREAD_EXITED  0x40
Public Const SCAN_END_REQUEST = &H1
Public Const SCAN_END_REQUEST_ACK = &H2
Public Const SCAN_END_REQUEST_SENT = &H4
Public Const SCAN_END_REQUEST_PENDING = &H8
Public Const SCAN_END_REQUEST_FAILED = &H10
Public Const SCAN_END_REQUEST_SUCCEEDED = &H20
Public Const SCAN_DRIVER_THREAD_EXITED = &H40

Public bReadCfgCalled As Byte
Public bIsJusticeBoard As Byte
Public fDebugFileExists As Boolean
Public TimerTime As Double
Public L_TimerInterval As Long
Public bDoScanDigoutTesting As Byte
Public bTestDigOutValToSend As Byte
Public fScanDigoutErr(32) As Boolean
Public bScanDigout(32) As Byte
Public bScanDigoutOld(32) As Byte
Public bScanDigoutSameTwoTest_Val(32) As Byte
Public bScanDigoutSameTwoTest_Flag(32) As Byte
Public bScanDigout_AnyTwoSameErr(32) As Boolean
'9-17-02 END IN-HOUSE testing ============
'========================================

Public usProgressBar2Val As Integer

'NOTE: Variable prefixing convention:
'f = Boolean(flag - True/False), b = Byte,
's = 16-bit integer(short), i = 32-bit integer(long)
'Constants are ALL CAPS
Public Const ARG_IGNORED = 0
Public usNewScanBuffWrap(32) As Integer
Public usNewMicroBuffWrap(32) As Integer
Public usNewScanPackErr(32) As Integer
Public usStatDevList(MAX_DEV_CNT) As Integer
Public usStatDevFlags(MAX_DEV_CNT) As Long

'============================= CODE BLOCKS =============================
'====    Use with EDIT/FIND to find similiar function and code     =====
'====             groupings within the source code file.           =====
'=======================================================================
'**** External functions from LL_USB2k.DLL ******************************
'**** R E A D / W R I T E   C O N F I G U R A T I O N   F I L E ********
'**** C O N T R O L   V I S I B I L I T Y   H A N D L I N G  ***********
'**** S Y S T E M    C A L I B R A T I O N  ****************************
Public bTotalScanChans As Byte
Public usModelNum As Integer
Public fSkipModelChk As Boolean
Public bNumScanChansRequested As Byte
Public bMultiScanActiveChans(8) As Byte
Public bCurMultiScanChan As Byte
Public sCurMultiOffsetIndex As Integer
Public dblScanChan0_SAVE As Double
Public bDAC As Byte
Public dblDAC_VOLTS As Double

'#######################################################
' START Graphics variables
'#######################################################
Public dblDotCol    'HR
Public sLastY As Integer
Public sVFrame As Integer
Public sHFrame As Integer
Public sDotCol As Integer
Public sYPixTotal As Integer
Public sXPixTotal As Integer
Public sDotColorChange As Integer
Public iY As Long
Public dblX As Double
Public dblYFS As Double
Public dblLastX As Double
Public dblYRange As Double
Public dblYIndex As Double
Public dblXRange As Double
Public dblXIndex As Double
Public dblPixsPerS As Double
Public dblPixPerDP As Double
Public dblYIndexPix As Double
Public dblXIndexPix As Double
Public dblPixsPerVolt As Double
Public dblCurScanRate(MAX_DEV_CNT) As Double
Public dblZoomFactor As Double
Public dblPercentFullScale As Double
Public fCenterGraph As Boolean
Public fGraphIsDisplayed As Boolean
Public bCurrentChanForGraph(MAX_DEV_CNT) As Byte
'#######################################################
'END  Graphics variables
'#######################################################


'====================>


'#######################################################
' START Scan Voltage Averaging variables
'#######################################################
Public dblVoltAvgTotal_MULTI(8) As Double
'Public dblVoltAvgArray_MULTI(8, 32) As Double
Public dblVoltAvgArray_MULTI(8, 128) As Double

Public sVoltAvgArrayIndex_MULTI(8) As Integer
Public iVoltAvgArrayIndex_MULTI As Integer  '12-6-16d



Public bVoltAvgArrayFirstTimeInFlag_MULTI(8) As Integer
Public bVoltAvgArrayFirstTimeInFlag As Byte
Public usVoltAvgArrayIndex As Integer
Public dblVoltAvgTotal As Double
'5-12-14e temp Public dblVoltAvgArray() As Double
Public dblVoltAvgArray(256) As Double '5-12-14e temp

'#######################################################
'END  Scan Voltage Averaging variables
'#######################################################


'====================>


'#######################################################
' START Scanning variables (non graphic)
'#######################################################
Public bScanBoostVal As Byte
Public bThisScanDevIndex As Byte
Public bStopScanDevIndex As Byte
Public fScanEndInProgress(32) As Boolean
Public fTimerEndScanCallEntered As Boolean
Public fScanEndNeeded() As Boolean
Public fNeedToUpdateCurScanDevIndex As Boolean
Public bSDGroup As Integer
Public bCurScanDevIndex As Byte
Public bDevicesCurrentlyScanning() As Byte
Public bScanDynaDiginBuff() As Byte
Public bScanLastDigin(MAX_DEV_CNT) As Byte
Public iScanNum(MAX_DEV_CNT) As Long
Public iDynaVoltageBuff() As Long
Public fScanEnd As Boolean
Public fAnyScanRunning As Boolean
Public fDoScanDataFile As Boolean
Public fScanDataFileOpened As Boolean
Public dblEffectiveBits As Double
Public dblStandardDeviation() As Double
Public dblStandardDeviationTotal As Double
Public dblScanRate(MAX_DEV_CNT) As Long
Public dblStandardDeviationCount  As Long

Type SCAN_OBJECT
    SO_bScanType As Byte        '1 = single-chan scan, 2 = multi-chan, 3 = multi-chan with offset calibration
    SO_dblInternalDataRate As Double
    SO_iTotalPointsReadByDrvr As Long
    SO_iPointsInBuffer As Long
    SO_iStatus As Long
    SO_iSizeVoltageArray As Long
    SO_iCurHead As Long
    SO_iCurTail As Long
    SO_bDigitalInput As Byte
    SO_bChecksum As Byte
    SO_DeviceDisconnect As Byte     'no longer used - see SCAN_DEVICE_DISCONNECTED flag for SO_iStatus
    SO_iScanStartTime As Long       'clock_t SO_ScanStartTime not used by app;
    SO_iScanEndTime As Long         'clock_t SO_ScanEndTime not used by app;
    SO_bScanArg As Byte             'argument to scan
End Type
Public ScanObjectArray() As SCAN_OBJECT
'#######################################################
'END  Scanning variables (non graphic)
'#######################################################


'====================>


'#######################################################
' START DeviceID Related variables
'#######################################################
'Description of individual devices
Type DEVICE_OBJECT
    DEV_sID As Integer
    DEV_bChan As Byte
    DEV_dblRate As Double
    DEV_bStat As Byte
End Type
Public DeviceObject As DEVICE_OBJECT
Public DeviceObjectArray(MAX_DEV_CNT) As DEVICE_OBJECT
Public bNumDevicesLocal As Byte
Public bNumDevicesShared As Byte
Public bCurIndexOfSelectedDev As Byte
Public bDeviceRemovedOrInstalled As Byte
Public fOkToChangeComboWhichDevice As Boolean   'Required to allow contents of this  box to only be changed by application but not directly by user.
Public fDevRemovedReloadCfg As Boolean
Public strSetupComboDeviceNum As String
'#######################################################
'END  DeviceID Related variables
'#######################################################


'====================>


'#######################################################
' START chan and digout variables
'#######################################################
Public bCurChan As Byte
Public bChanToSend As Byte
'2-20-18 moved Public bDigOutVal As Byte
Public bChangeDefCfgStat As Byte
Public fDigOutPending As Boolean
Public fChanChangePending As Boolean
Public pbLastDigin As Byte
'#######################################################
'END  chan and digout variables
'#######################################################


'====================>


'#######################################################
' START voltage and rawcount (non scan) variables
'#######################################################
Public iRawCount As Long
Public dVoltage(MAX_DEV_CNT) As Double
Public dVoltageSingConv As Double
'#######################################################
'END   voltage and rawcount (non scan) variables
'#######################################################


'====================>


'#######################################################
' START misc variables
'#######################################################
Public bRetVal As Byte

Public bScreenMode As Byte
Public bCurrentEndpoint As Byte
Public bFuncArgIgnored(MAX_DEV_CNT) As Byte
Public bHostClientDataBuf() As Byte
Public sDLLDebug As Integer
Public sRateCmdLow As Integer
Public sRateCmdHigh As Integer
Public dblCurrentRateToSend As Double
Public iRetVal As Long
Public iNumDbgFiles  As Long
Public iNumBytesToReadWrite As Long
Public fAnySignon As Boolean
Public fSignOn As Boolean
Public fRetVal As Boolean
Public fMsgStat As Boolean
Public fTimerStat As Boolean
Public fRetValMisc As Boolean
Public fDLLReadWrite As Boolean

'Most of the following used by the Configuration Setup code
Public strMsg As String
Public szLogFileName As String
Public strCfgFileSpec As String
Public strHostClientMsgBuf As String

'HANDLES to required DLL's and log file
Public hLibCheck As Long
Public hLibLL_USB As Long
Public hValIgnored As Long
Public hLogFile As Long
'#######################################################
'END  misc variables
'#######################################################


'====================>


'#######################################################
' START CONSTANT Definitions
'#######################################################



Public Const INIT_DEV_NO_ERR = &H0
Public Const INIT_DEV_NOT_FOUND = &H1
Public Const INIT_DEV_FAILED_ENUMERATION = &H2
Public Const INIT_DEV_DLL_INIT_ERR = &H4
Public Const INIT_DEV_OTHER_OWNER = &H8
Public Const INIT_DEV_NO_PWR_ERR = &H10             'Not yet used
Public Const INIT_DEV_NO_PWR_RECOVERED = &H20       'Not yet used
Public Const INIT_DEV_FAILED_READ = &H40            'Not yet used
Public Const INIT_DEV_READ_RECOVERED = &H80         'Not yet used
Public Const INIT_DEV_FAILED_WRITE = &H100          'Not yet used
Public Const INIT_DEV_WRITE_RECOVERED = &H200       'Not yet used
Public Const INIT_DEV_SYS_CAL_ERR = &H400           'Not yet used
Public Const INIT_DEV_SYS_CAL_RECOVERED = &H800     'Not yet used
Public Const INIT_DEV_RESET_IOCTL_TRIED = &H1000    'Not yet used
Public Const INIT_DEV_RESET_IOCTL_SUCCESS = &H2000  'Not yet used
Public Const INIT_DEV_RESET_CMD_TRIED = &H4000      'Not yet used
Public Const INIT_DEV_RESET_CMD_SUCCESS = &H8000    'Not yet used
Public Const INIT_DEV_SIGNON_SUCCESS = &H10000
Public Const INIT_DEV_SIGNING_ON = &H20000
Public Const INIT_DEV_FAILED_SYSCAL = &H40000       'Not yet used
Public Const INIT_DEV_DONE_INIT = &H80000           'Not yet used



Public Const FLAG_INPUT_RANGE = 0

Public Const COMMAND_SIGN_ON = &H0
Public Const COMMAND_DIG_OUT = &H2
Public Const COMMAND_CHAN_CHG = &H4
Public Const COMMAND_ANALOG_OUT = &HA
Public Const COMMAND_GET_CONVERSION = &H81
Public Const COMMAND_SYS_CAL = &H85
Public Const SCAN_BUFFSIZE_MAX = 32768

Public Const SCAN_IDLE = &H0
Public Const SCAN_RUN = &H1

Public Const DO_READ = True
Public Const DO_WRITE = False
Public Const ENDPOINT_0 = 0
Public Const ENDPOINT_1 = 1
Public Const TIMER_DONE = True
Public Const TIMER_START = False
Public Const POLLED_SCREEN = &O0
Public Const SCAN_SCREEN = &O1
Public Const DEF_CFG_SAVE = 1
Public Const DEF_CFG_CANCEL = 2
Public Const NO_DEVICE = 0
Public Const DEVICE_AVAILABLE = 1
Public Const DEVICE_IN_USE = 2
Public Const DEVICE_CONNECT_REMOVED = 1
Public Const DEVICE_CONNECT_NOCHANGE = 0

Public Const FREE_ANY_DEV = True
Public Const FREE_ONLY_APP_OWNED_DEVICES = False

Public Const MSG_BOX_OK = 0  'vbOk is actually ok/cancel

Public Const DO_DISPLAY_LISTS = True
Public Const DONT_DISPLAY_LISTS = False

Public Const SCANFILE_CREATE = 1
Public Const SCANFILE_CLOSE = 3

Public Const REDUCE_THREAD_PRIORITY = 1

'Following are possible values for SO_bScanType (scanning)
Public Const SINGLE_CHAN_SCAN = 1
Public Const MULTI_CHAN_SCAN = 2
'10-19-15 LOOK
Public Const MULTI_CHAN_CAL_SCAN = 3
Public Const SINGLE_CHAN_DIGIN_SCAN = 4
Public Const MULTI_CHAN_DIGIN_SCAN = 5
Public Const MULTI_CHAN_CAL_DIGIN_SCAN = 6

'Following are possible values for SO_iStatus (scanning)
Public Const SCAN_RUNNING = &H1
Public Const SCAN_DATA_REQUEST_SUCCEEDED = &H2
Public Const SCAN_ENDING = &H4
Public Const SCAN_HALTED = &H8
Public Const SCAN_CHECKSUM_ERROR = &H10
Public Const SCAN_VOLTAGE_BUFFER_WRAP = &H20
Public Const SCAN_MICRO_CODE_BUFF_WRAP = &H40
Public Const SCAN_DEVICE_IO_ERROR = &H80
Public Const SCAN_DEVICE_DISCONNECTED = &H100
Public Const SCAN_DEVICE_NOT_FOUND = &H200
Public Const SCAN_DIGIN_CHANGE = &H400      'Applies only with calls to DLL_ReadScanDataWithDigin(). DLL will set this flag when digital input has changed since start of scan. You must call the function (even if you just set iNumPointsToTransfer = 0) for DLL to update this flag.
'12-31-03
Public Const SCAN_DEVICE_POWER_LOSS = &H1000

'==========================================
'10-8-02 START OF ADDED ====================
Public Const SCAN_WRITE_DO_WRITE = &H1
Public Const SCAN_WRITE_PENDING = &H2
Public Const SCAN_WRITE_SUCCESS = &H4
Public Const SCAN_WRITE_FAILED = &H8
Public Const SCAN_WRITE_CANCEL = &H10
Public Const SCAN_WRITE_RET_STATS = &H20
Public Const SCAN_WRITE_DEVICE_UNKNOWN = &H40
Public Const SCAN_WRITE_DEVICE_NOT_SCANNING = &H80
Public Const SCAN_WRITE_MEMORY_ERR = &H100
Public Const FUNC_RET_FAIL = 0
Public Const FUNC_RET_SUCCESS = 1
'10-8-02 END OF ADDED ======================
'==========================================

'#######################################################
'END  CONSTANT Definitions
'#######################################################





' API Declaration
'6-23-17
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

' Constants declarations

Public Const GWL_WNDPROC = -4
Public Const SC_MONITORPOWER = &HF170&
Public Const WM_SYSCOMMAND = &H112

' Variable to hold ID of old Wnd Proc

Public oldWndProc As Long












'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'**** External functions from LL_USB2k.DLL ******************************
'Shown with C++ DLL function prototypes================================\
'=======================================================================
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'=======================================================================
'======================================================================/

'2-20-18
'BOOLEAN EX_SendDigout(USHORT usDevID, BYTE bDigOut)
Declare Function EX_SendDigout Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByVal bDigOut As Byte) As Byte
'BOOLEAN EX_GetDigin(USHORT usDevID, BYTE* bDigIn)
Declare Function EX_GetDigin Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByRef bDigIn As Byte) As Byte
'BOOLEAN EX_SendDAC(USHORT usDevID, DOUBLE dblVoltage, BYTE bDAC)
Declare Function EX_SendDAC Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByVal dblVoltage As Double, ByVal bDAC As Byte) As Byte
'SP_SendDAC(usDevID, dblVoltage, bDAC, &bReserved);
Declare Function SP_SendDAC Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByVal dblVoltage As Double, _
                                        ByVal bDAC As Byte, ByVal bReserved As Byte) As Byte

'======================================================================
'START NEW for EMF16 4-24-2014 - not using McKenzie thermscan functions
'======================================================================
'BOOLEAN EX_SendRate ( USHORT usDevID , double* pdblRate );


'BOOLEAN EX_SetScanType ( USHORT usDevID, BYTE bScanType );
'following defined further up in this module
'1   SINGLE_CHAN_SCAN
'2   MULTI_CHAN_SCAN
'3   MULTI_CHAN_CAL_SCAN
'4   SINGLE_CHAN_DIGIN_SCAN
'5   MULTI_CHAN_DIGIN_SCAN
'6   MULTI_CHAN_CAL_DIGIN_SCAN
Declare Function EX_SetScanType Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByVal bScanType As Byte) As Byte


'BOOLEAN EX_SetMultiChanScanChans ( USHORT usDevID, BYTE bChanCnt );
Declare Function EX_SetMultiChanScanChans Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByVal bChanCnt As Integer) As Byte

'NOTE: put in place just in case, but logging will be done locally as with the 201 EMF16
'BOOLEAN EX_SetDataLogOptions ( USHORT usDevID, UINT uiDataLogMethod, UINT uiLogFileMaxSize, UINT uiMisc );
Declare Function EX_SetDataLogOptions Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByVal uiDataLogMethod As Long, _
                 ByVal uiLogFileMaxSize As Long, ByVal uiMisc As Long) As Byte
                 
                 
'BOOLEAN EX_SetPolledModeChan ( USHORT usDevID, BYTE bChan );
Declare Function EX_SetPolledModeChan Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByVal bChan As Byte) As Byte
                 
'BOOLEAN EX_Run ( USHORT usDevID );
Declare Function EX_Run Lib "LL_USB2k.DLL" (ByVal usDevId As Integer) As Byte

'BOOLEAN EX_CheckScanStatus ( USHORT usDevID, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiStatusCode) );
'&H1 NOT_SCANNING
'&H2 HALTED
'&H4 DISCONNECTED
'&H8 SCAN_COMPLETED
'&H10 MISSING_DIGIN_BUFF
'&H20 BUFF_TOO_SMALL
'&H40 MICRO_BUFF_WRAP
'&H80 MEM1_BUFF_WRAP
'&H100 MEM2_BUFF_WRAP
'&H200 NO_DATA
Declare Function EX_CheckScanStatus Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByRef puiNumScansRemainingInBuff As Long, _
                 ByRef pfStillScanning As Byte, ByRef puiStatusCode As Long) As Byte

'NOTE: the following function uses the same constants as above function
'BOOLEAN EX_GetScanDataDbl ( USHORT usDevID, double* pdblDataBuff, UINT uiNumScansToReturn, BOOLEAN fGetAllRequested,
'        UINT* puiNumScansReturned, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiStatusCode);
Declare Function EX_GetScanDataDbl Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByRef pdblDataBuff As Double, ByVal uiNumScansToReturn As Long, _
                ByVal fGetAllRequested As Byte, ByRef puiNumScansReturned As Long, ByRef puiNumScansRemainingInBuff As Long, _
                ByRef pfStillScanning As Byte, ByRef puiTotalBuffSize As Long, ByRef puiErrCode As Long) As Byte
'SAME AS ABOVE but with digital input
'BOOLEAN EX_GetScanDataDblDigin ( USHORT usDevID, double* pdblDataBuff, BYTE* pbDiginBuff,
'                                UINT uiNumScansToReturn, BOOLEAN fGetAllRequested, UINT* puiNumScansReturned,
'                                UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiErrCode);
Declare Function EX_GetScanDataDblDigin Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByRef pdblDataBuff As Double, ByRef pbDiginBuff As Byte, _
                 ByVal uiNumScansToReturn As Long, ByVal fGetAllRequested As Byte, ByRef puiNumScansReturned As Long, ByRef puiNumScansRemainingInBuff As Long, _
                 ByRef pfStillScanning As Byte, ByRef puiTotalBuffSize As Long, ByRef puiErrCode As Long) As Byte


'BOOLEAN EX_Stop ( USHORT usDevID );
Declare Function EX_Stop Lib "LL_USB2k.DLL" (ByVal usDevId As Integer) As Byte

'BOOLEAN EX_StopComplete ( USHORT usDevID );
Declare Function EX_StopComplete Lib "LL_USB2k.DLL" (ByVal usDevId As Integer) As Byte
'====================================================================
'END NEW for EMF16 4-24-2014 - not using McKenzie thermscan functions
'====================================================================


'======================================
'NEW for EMF16 2011
'======================================

'9-12-11 added - prior to this is was automatic during scan startup
'BOOLEAN Th_ScanDbg(BYTE level, BOOLEAN fOn);
Declare Function Th_ScanDbg Lib "LL_USB2k.DLL" (ByVal dbgLevel As Byte, ByVal dbgOnOff As Byte) As Byte


'BOOLEAN EX_SendRate(USHORT usDevID, double* dblRate)
Declare Function EX_SendRate Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByRef dblRate As Double) As Byte

'BOOLEAN EX_Connect(USHORT* usDevID)
Declare Function EX_Connect Lib "LL_USB2k.DLL" (ByRef usDevId As Integer) As Byte

'BOOLEAN EX_ReConnectOneDev(USHORT usDevID)
Declare Function EX_ReConnectOneDev Lib "LL_USB2k.DLL" (ByVal usDevId As Integer) As Byte

'BOOLEAN EX_ConnectOneDevice(USHORT usDevID, double dblRate, BYTE bChan)
Declare Function EX_ConnectOneDevice Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByVal dblRate As Double, ByVal bChan As Byte) As Byte


'======================================
'LL_LABS IN-HOUSE TESTING ONLY - START.
'======================================
'BOOLEAN SP_GetCalculatedRate(double* dblRate, USHORT usDevID)
Declare Function SP_GetCalculatedRate Lib "LL_USB2k.DLL" (ByRef dblRate As Double, ByVal usDevId As Integer) As Byte

Declare Function SPx_SendRate Lib "LL_USB2k.DLL" (ByRef pdblRate As Double, ByVal usDeviceID As Integer) As Byte

'BOOLEAN SP_SendToDebug_AllDevInfoThisApp(void)
Declare Function SP_SendToDebug_AllDevInfoThisApp Lib "LL_USB2k.DLL" () As Byte

'BOOLEAN SP_GetAppDevListInfo(USHORT usAppDevID, USHORT* usDLLDevID, BYTE* bDisonnected,
'                   BYTE* bFound, BYTE* bDevIndex)
Declare Function SP_GetAppDevListInfo Lib "LL_USB2k.DLL" _
            (ByVal usAppDevID As Integer, ByRef usDLLDevID As Integer, ByRef bDisonnected As Byte, _
            ByRef bFound As Byte, ByRef bDevIndex As Byte) As Byte

'BOOLEAN SP_InitOneDev(USHORT usDevID, DOUBLE* dblRate)
Declare Function SP_InitOneDev Lib "LL_USB2k.DLL" _
            (ByVal usDevId As Integer, ByRef dblRate As Double, ByVal bChan As Byte) As Byte

'2-19-04
Declare Function SP_SetDebugLevel_ALL Lib "LL_USB2k.DLL" _
            (ByVal bDbgLvl As Byte) As Byte
'2-19-04
Declare Function SP_CreateNewDebug Lib "LL_USB2k.DLL" _
            (ByVal bDbgLvl As Byte, ByVal bUseOld As Byte) As Byte

'BOOLEAN DLL_DoMiscDevIOWrite(USHORT usDevID)
Declare Function DLL_DoMiscDevIOWrite Lib "LL_USB2k.DLL" _
            (ByVal usDevId As Integer) As Byte

Declare Function DLL_ReturnDeviceStringsInfo Lib "LL_USB2k.DLL" _
            (ByVal pDynamicArray As String, ByVal usDevId As Integer) As Byte

'BOOLEAN DLL_ResetPipe(USHORT usDevID, BYTE bReserved, BOOLEAN fRead)
Declare Function DLL_ResetPipe Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer, _
                    ByVal bReserved As Byte, ByVal fRead As Byte) As Byte

'BOOLEAN DLL_ResetDevice(USHORT usDevID, BYTE bReserved);
Declare Function DLL_GetDrvrTimings Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer) As Byte
Declare Function GetCurrentThreadId Lib "kernel32" () As Long
Declare Function SetThreadPriority Lib "kernel32" (ByVal hThread As Long, ByVal nPriority As Long) As Long
Declare Function GetThreadPriority Lib "kernel32" (ByVal hThread As Long) As Long
'Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As LARGE_INTEGER) As Long
'===================================
'LL_LABS IN-HOUSE TESTING ONLY - END.
'===================================





'======================================
'NEW STUFF NOT YET CATEGORIZED
'======================================
'BOOLEAN SP_SendEndScanToken(USHORT usDevID);
Declare Function SP_SendEndScanToken Lib "LL_USB2k.DLL" _
            (ByVal usDevId As Integer) As Byte

'BOOLEAN SP_GetEndScanStatus(USHORT usDevID, UINT* puiEndScanFlags);
Declare Function SP_GetEndScanStatus Lib "LL_USB2k.DLL" _
            (ByVal usDevId As Integer, ByRef puiEndScanFlags As Long) As Byte

'BOOLEAN SP_WriteWhileScanning(USHORT usDevID, BYTE bCmnd, BYTE bArg, UINT* uiCurStat);
Declare Function SP_WriteWhileScanning Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, _
    ByVal bCmnd As Byte, ByVal bArg As Byte, ByRef puiCurWriteStat As Long) As Byte

'BOOLEAN DLL_DoNothingFunc(BYTE bVal, USHORT usVal, DOUBLE* dblArray)
Declare Function DLL_DoNothingFunc Lib "LL_USB2k.DLL" (ByVal bval As Byte, _
    ByVal usVal As Integer, ByRef dblArray As Double) As Byte
'===================================
'LL_LABS IN-HOUSE TESTING ONLY - END.
'===================================



'=======================================================================
'---------------->              INITIALIZATION
'=======================================================================
'1-12-02
'BOOLEAN SP_DrvrDebugOutput(USHORT usDevID, UINT uiDbgFlags, char* pszMsg, USHORT usMsgLngth)
Declare Function SP_DrvrDebugOutput Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, _
    ByVal uiDbgFlags As Long, ByVal pszMsg As String, ByVal usMsgLngth As Integer) As Byte

'Need to use the following to set app's device cnt to that of DLL's since the
' pointer is never passed in SP_InitAllDevices like it once was with older
' DLL_Init function call. It's still safe to use this call with older init call.
'BOOLEAN SP_GetAppDevCnt(BYTE* bDevCnt)
Declare Function SP_GetAppDevCnt Lib "LL_USB2k.DLL" (ByRef pbNumDevices As Byte) As Byte

'BOOLEAN SP_DisableDialog()
Declare Function SP_DisableDialog Lib "LL_USB2k.DLL" () As Byte

'BOOLEAN SP_InitAllDevices(USHORT* pDevList, BYTE* pbNumDevices_LV, DOUBLE* pdblInternalDataRate, BOOLEAN fShowDevList)
Declare Function SP_InitAllDevices Lib "LL_USB2k.DLL" (ByRef pusaLLABS_DeviceIDList As Integer, _
            ByRef pbNumDevices As Byte, ByRef padblInternalDataRate As Double, ByVal fShowList As Byte) As Byte

'BOOLEAN SP_InitAllDevices_Thread(USHORT* pDevList, DOUBLE* pdblInternalDataRate, BOOLEAN fShowDevList)
Declare Function SP_InitAllDevices_Thread Lib "LL_USB2k.DLL" (ByRef pusaLLABS_DeviceIDList As Integer, _
            ByRef padblInternalDataRate As Double, ByVal fShowList As Byte) As Byte
            
'BOOLEAN SP_GetInitThreadStat (void)
Declare Function SP_GetInitThreadStat Lib "LL_USB2k.DLL" () As Byte
           
'BOOLEAN SP_CancelInitThread (void)
Declare Function SP_CancelInitThread Lib "LL_USB2k.DLL" () As Byte

'BOOLEAN SP_GetLastInitDevAndRates(USHORT* pDevList, double* pdblRates);
Declare Function SP_GetLastInitDevAndRates Lib "LL_USB2k.DLL" (ByRef pusaLLABS_DeviceIDList As Integer, _
            ByRef padblInternalDataRate As Double) As Byte
            
'BOOLEAN SP_GetLastInitStat(USHORT* pDevList, UINT* puiFlags);
Declare Function SP_GetLastInitStat Lib "LL_USB2k.DLL" _
        (ByRef pausDevIDList As Integer, ByRef pausDevStatList As Long) As Byte

'BOOLEAN SP_GetOneConversion(USHORT usDevID, UINT* uiConvRawCount, BYTE bCurChan, BYTE* pbLastDigin);
Declare Function SP_GetOneConversion Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer, _
            ByRef puiConvRawCount As Long, ByVal bCurChan As Byte, ByRef pbDigInput As Byte) As Byte

'BOOLEAN SP_SendRate(DOUBLE* dblRate, USHORT usDevID);
Declare Function SP_SendRate Lib "LL_USB2k.DLL" (ByRef pdblRate As Double, ByVal usDeviceID As Integer) As Byte


'BOOLEAN EX_GetRequestedRate(USHORT usDevID, double* dblRate)
Declare Function EX_GetRequestedRate Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer, ByRef pdblRate As Double) As Byte
'BOOLEAN EX_GetCalculatedRate(USHORT usDevID, double* dblRate)
Declare Function EX_GetCalculatedRate Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer, ByRef pdblRate As Double) As Byte


'BOOLEAN SP_SendChan(USHORT usDevID, BYTE bCurChan, BYTE* pbLastDigin)
Declare Function SP_SendChan Lib "LL_USB2k.DLL" _
        (ByVal usDeviceID As Integer, ByVal bCurChan As Byte, ByRef pbDigInput As Byte) As Byte

'BOOLEAN DLL_Init(HANDLE hParentWindow, HANDLE hLibSETUPAPI, HANDLE hLibUSER32,
'           SHORT fDebugLevel, BYTE* bpNumDevices, BYTE *bpDeviceStatusShared,
'           SHORT *sLLABS_DeviceIDList);
Declare Function DLL_Init Lib "LL_USB2k.DLL" (ByVal hMainWin As Long, _
            ByVal hValIgnored As Long, ByVal hValIgnored As Long, _
            ByVal fDebugLevel As Integer, ByRef numDevices As Byte, _
            ByRef bDeviceStatusShared As Byte, _
            ByRef sLLABS_DeviceIDList As Integer) As Byte
            
'BOOLEAN DLL_SetSpecialDebugOptions(USHORT* usDeviceIdsToEnableDisable,
'        BYTE* bPerDevDbgLvl, BYTE _bDefaultDbgLvl, UINT uiFlags)
Declare Function DLL_SetSpecialDebugOptions Lib "LL_USB2k.DLL" ( _
            ByRef sDeviceIDList As Integer, _
            ByRef bDbgLvlPerDev As Byte, _
            ByVal bDbgDefault As Byte, ByVal fFlags As Long) As Byte
'Note bDbgDefault sets the value for non-device specific entries
' within the DLL's debug output file. For example, during enumeration
' or other times when a specific device ID doesn't apply or hasn't
' yet been establised.

            
            
'=======================================================================
'---------------->              DEVICE HANDLING
'=======================================================================
'FACTORY USE ONLY!

'BOOLEAN DLL_ResetDevice(USHORT usDevID, BYTE bReserved);
Declare Function DLL_ResetDevice Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer, ByVal bReserved As Byte) As Byte

'BOOLEAN DLL_ShowSharedDevArray(void);
Declare Function DLL_ShowSharedDevArray Lib "LL_USB2k.DLL" () As Byte

'BOOLEAN DLL_ZeroSharedDevArray(void);
Declare Function DLL_ZeroSharedDevArray Lib "LL_USB2k.DLL" () As Byte

'BOOLEAN DLL_ShowSharedGUIDStringArray(void);
Declare Function DLL_ShowSharedGUIDStringArray Lib "LL_USB2k.DLL" () As Byte

'BOOLEAN DLL_GetDeviceIDList(void);
Declare Function DLL_GetDeviceIDList Lib "LL_USB2k.DLL" () As Byte

'BOOLEAN DLL_InstanceInitDeviceList(BOOLEAN fDisplayLists);
Declare Function DLL_InstanceInitDeviceList Lib "LL_USB2k.DLL" _
        (ByVal fDisplayLists As Byte) As Byte

'BOOLEAN DLL_ReleaseDeviceFromIDList(USHORT* LLABSDeviceIDList, BOOLEAN fAnyHandle);
Declare Function DLL_ReleaseDeviceFromIDList Lib "LL_USB2k.DLL" _
            (ByRef sLLABS_DeviceIDList As Integer, fAnyHandle As Byte) As Byte
            
'BOOLEAN DLL_ReInitOneDev(USHORT usDevID);
Declare Function DLL_ReInitOneDev Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer) As Byte

'DLL_MarkOneDevAsInUse(USHORT usDevID);
Declare Function DLL_MarkOneDevAsInUse Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer) As Byte

'2-13-17
'BOOLEAN SP_GetDevStat(USHORT usDevID, UINT* _uiDevStat)
Declare Function SP_GetDevStat Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByRef uiDevStat As Long) As Byte
'2-14-17
'BOOLEAN SP_GetDevStatEx(UINT* _uiDevStat, USHORT* _pusAllDevList, BYTE* bNumDevices)
Declare Function SP_GetDevStatEx Lib "LL_USB2k.DLL" (ByRef uiDevStat As Long, ByRef usDevId As Integer, ByRef bNumDevices As Byte) As Byte


           
'=======================================================================
'---------------->              DEVICE READ/WRITE
'=======================================================================
'BOOLEAN DLL_ReadWriteOneDevice(BOOLEAN fReadWrite, BYTE* DynamicDataArray, _
                    USHORT usDevID, UINT* numBytes, BYTE* pbDigIn, UINT uiReserved)
            
Declare Function DLL_ReadWriteOneDevice Lib "LL_USB2k.DLL" _
            (ByVal bReadWrite As Byte, ByRef pDynamicArray As Byte, _
            ByVal usDevId As Integer, ByRef uiNumBytes As Long, _
            ByRef pDigInput As Byte, ByVal iReserved As Long) As Byte
            
'=======================================================================
'---------------->              RATE (special)
'=======================================================================
'BOOLEAN DLL_SetRate(USHORT usDevID, DOUBLE dblRate);
Declare Function DLL_SetRate Lib "LL_USB2k.DLL" _
            (ByVal usDevId As Integer, ByVal dblRate As Double) As Byte
'=======================================================================
'---------------->              SCANNING
'=======================================================================
'BOOLEAN DLL_StartScan_DIO(USHORT usDeviceID, _
                        PSCAN_OBJECT_DIO pScanObj_DIO, BYTE bStartMode)
Declare Function DLL_StartScan_DIO Lib "LL_USB2k.DLL" _
           (ByVal usDeviceID As Integer, ByRef ScanObject As SCAN_OBJECT, _
                        ByVal bStartMode As Byte) As Byte

'BOOLEAN DLL_ReadScanData_DIO(USHORT usDevID, UINT* DynaVoltageBuff, _
                        USHORT numPointsToRead, PSCAN_OBJECT_DIO pScanObj_DIO)
Declare Function DLL_ReadScanData_DIO Lib "LL_USB2k.DLL" _
           (ByVal usDevId As Integer, ByRef iDynaVoltageBuff As Long, _
            ByVal numPointsToRead As Integer, ByRef ScanObject As SCAN_OBJECT) _
            As Byte
            
'BOOLEAN DLL_ReadScanDataWithDigin(USHORT usDevID, UINT* DynaVoltageBuff, BYTE* bDiginBuff, _
                        USHORT numPointsToRead, PSCAN_OBJECT_DIO pScanObj_DIO);
Declare Function DLL_ReadScanDataWithDigin Lib "LL_USB2k.DLL" _
           (ByVal usDevId As Integer, ByRef iDynaVoltageBuff As Long, _
           ByRef bDynaDiginBuff As Byte, ByRef bCurScanChan As Byte, _
           ByVal numPointsToRead As Integer, _
           ByRef ScanObject As SCAN_OBJECT) As Byte
            
'BOOLEAN DLL_EndScan_DIO(USHORT usDevID, BOOLEAN fEmptyBuffer, _
                     UINT uiTimeOut, BYTE bScanPauseOrTerminate)
' currently used. Their values are ignored by the DLL.
Declare Function DLL_EndScan_DIO Lib "LL_USB2k.DLL" _
            (ByVal uiDevId As Integer, ByVal fEmptyBuffer As Byte, _
            ByVal uiTimeOut_NOT_CURRENTLY_USED As Long, _
            ByVal bScanPauseOrTerminate_NOT_CURRENTLY_USED As Byte) As Byte
            
'BOOLEAN DLL_GetEndOfScanBuffSize(USHORT usDevID,UINT* uiNumPoints)
Declare Function DLL_GetEndOfScanBuffSize Lib "LL_USB2k.DLL" _
            (ByVal uiDevId As Integer, ByRef uiNumPoints As Long) As Byte
            
'BOOLEAN DLL_ReadEndOfScanData(USHORT usDevID, UINT* DynaVoltageBuff, USHORT numPointsToRead)
Declare Function DLL_ReadEndOfScanData Lib "LL_USB2k.DLL" _
           (ByVal usDevId As Integer, ByRef iDynaVoltageBuff As Long, _
            ByVal iNumPointsToRead As Integer) As Byte
            
            
            
'2-13-16
'BOOLEAN EX_EndScan(USHORT usDevID)
Declare Function EX_EndScan Lib "LL_USB2k.DLL" (ByVal usDevId As Integer) As Byte
           
            
'=======================================================================
'---------------->          MESSAGING AND MISC DEVICE INFO
'=======================================================================
'BOOLEAN SP_GetRegDevList(USHORT* usCompleteDevList, UINT uiUnused)
Declare Function SP_GetRegDevList Lib "LL_USB2k.DLL" _
            (ByRef sCurDevList As Integer, ByVal iUnused As Long) As Byte
'2-19-04
'BOOLEAN SP_GetAppDevList(USHORT* usCompleteDevList, UINT uiUnused)
Declare Function SP_GetAppDevList Lib "LL_USB2k.DLL" _
            (ByRef sCurDevList As Integer, ByVal iUnused As Long) As Byte
           
'2-20-04
'BOOLEAN SP_GetDevOwnershipList(USHORT* usCompleteDevList, HANDLE* puiAppHandleList)
Declare Function SP_GetDevOwnershipList Lib "LL_USB2k.DLL" _
            (ByRef sCurDevList As Integer, ByRef puiAppHandleList As Long) As Byte


'BOOLEAN DLL_ShowDeviceDescriptor(char*  pDynamicDeviceDescArray, USHORT usDevID);
Declare Function DLL_ShowDeviceDescriptor Lib "LL_USB2k.DLL" _
            (ByVal pDynamicArray As String, ByVal usDEV_ID As Integer) As Byte

'BOOLEAN DLL_ShowConfigurationDescriptor(char* pDynamicConfigArray, USHORT usDevID);
Declare Function DLL_ShowConfigurationDescriptor Lib "LL_USB2k.DLL" _
            (ByVal pDynamicArray As String, ByVal usDEV_ID As Integer) As Byte

'BOOLEAN DLL_ShowInterfaceDescriptors(BYTE* pDynamicArray, USHORT usDevID);
Declare Function DLL_ShowInterfaceDescriptors Lib "LL_USB2k.DLL" _
            (ByVal pDynamicArray As String, ByVal usDEV_ID As Integer) As Byte

'BOOLEAN DLL_ShowEndpointDescriptors(BYTE* pDynamicEndpointDescArray,
'                 USHORT usDevID, SHORT usWhichEndpoint);
Declare Function DLL_ShowEndpointDescriptors Lib "LL_USB2k.DLL" _
            (ByVal pDynamicArray As String, ByVal usDEV_ID As Integer, _
            ByVal whichEndpoint As Integer) As Byte
            
'BOOLEAN DLL_GetDevVersion(USHORT usDevID, USHORT* usDevVersion, BOOLEAN fDisplayVersion);
Declare Function DLL_GetDevVersion Lib "LL_USB2k.DLL" _
             (ByVal usDevId As Integer, ByRef usDevVer As Integer, ByVal fDispVer As Boolean) As Byte

'BOOLEAN DLL_GetDevVersion(USHORT usDevID, BOOLEAN fDisplayVersion, USHORT* usDevVersion, char* cpDLLVersion, char* cpDrvrVersion)
Declare Function DLL_GetVersionInfo Lib "LL_USB2k.DLL" _
            (ByVal usDevId As Integer, ByVal fDispVer As Byte, ByRef usDevVer As Integer, _
            ByVal pDLLVersion As String, ByVal pDrvrVersion As String) As Byte
            
'======================================================================\
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'======================================================================/
                    
                    
'=======================================================================
'---------------->              WINAPI FUNCTIONS
'=======================================================================
Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hWnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WriteProfileString Lib "kernel32" Alias "WriteProfileStringA" (ByVal lpszSection As String, ByVal lpszKeyName As String, ByVal lpszString As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long) '4-16-13
Declare Function GetWindowsDirectory Lib "kernel32" Alias _
    "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal _
    nSize As Long) As Long '4-28-14

'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################
'##############################################################################################################

'6-23-16 all below, down to LoadLibraries sub is new
Public Const MOUSEEVENTF_ABSOLUTE = &H8000
Public Const MOUSEEVENTF_MOVE = &H1 ' mouse move
Public Const MOUSEEVENTF_LEFTDOWN = &H2 'left button down
Public Const MOUSEEVENTF_LEFTUP = &H4 'left button up
Public Const MOUSEEVENTF_RIGHTDOWN = &H8 ' right button down
Public Const MOUSEEVENTF_RIGHTUP = &H10 ' right button up

Declare Sub mouse_event Lib "user32" (ByVal dwFlags As Integer, ByVal dx As Integer, ByVal dy As Integer, ByVal cButtons As Integer, ByVal dwExtraInfo As Integer)
' this function mimics a WindowsProc accepting the same parameters so we can custom handle windows messages
Type POINTAPI
        x As Long
        y As Long
End Type
Public m_CursorPos As POINTAPI
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hWnd As Long, _
    lpPoint As POINTAPI) As Long
Declare Function SetCursorPos Lib "user32" _
      (ByVal x As Long, ByVal y As Long) As Long
Public Function MyWndProc(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
' check to see if the message is a system command and it's a change to the monitor power
' as indicated by the wParam passed to the procedure
    If mainFormHasFocus = False Then
        MyWndProc = CallWindowProc(oldWndProc, hWnd, wMsg, wParam, lParam)
        Exit Function
    End If
    If wMsg = WM_SYSCOMMAND Then
        'Dim strSecPerScren As String:   strSecPerScren = frmGraph_EMF16.SecPerScrn.Text
        'frmGraph_EMF16.Text24.Text = wParam
        'frmGraph_EMF16.Text24.Text = frmGraph_EMF16.Left / Screen.TwipsPerPixelX & ", " & _
            frmGraph_EMF16.Top / Screen.TwipsPerPixelX
        'frmGraph_EMF16.Text24.Text = Screen.TwipsPerPixelX
        
        If (wParam = 61808) Or (wParam = 61696) Then '61696 is ALT key, 61808 is monitor screen coming back on
            SetCursorPos (frmGraph_EMF16.Left / Screen.TwipsPerPixelX) + (frmGraph_EMF16.Width / Screen.TwipsPerPixelX) - 30, _
                (frmGraph_EMF16.Top / Screen.TwipsPerPixelY) + (frmGraph_EMF16.Height / Screen.TwipsPerPixelX) - 150
            'SetCursorPos (frmGraph_EMF16.Left / Screen.TwipsPerPixelX) + 80, (frmGraph_EMF16.Top / Screen.TwipsPerPixelY) + 50

            mouse_event _
                MOUSEEVENTF_MOVE + _
                MOUSEEVENTF_LEFTDOWN + _
                MOUSEEVENTF_LEFTUP, _
                10, 0, 0, 10
        End If
    End If
    ' as we don't want to ignore the message (we want it to execute properly and any other messages we're sent also),
    ' we use CallWindowProc passing the old procedure's handle and the params
    ' so that windows will process this message as normal
    MyWndProc = CallWindowProc(oldWndProc, hWnd, wMsg, wParam, lParam)
End Function



Public Sub LoadLibraries()
    hLibLL_USB = LoadLibrary("LL_USB2k.DLL")
    If hLibLL_USB = 0 Then GoTo NO_LL_USBLib
    fRetVal = True
    GoTo EXIT1
NO_LL_USBLib:
    fRetVal = MsgDisplay("ERROR finding LL_USB2k.DLL" _
        & Chr(10) _
        & Chr(10) _
        & Chr(10) _
        & "Locate and place file in Windows directory, or" _
        & Chr(10) _
        & Chr(10) _
        & "same directory as application and try again." _
        & Chr(10) _
        & Chr(10), _
         "error")
    fRetVal = False
EXIT1:
    On Error GoTo 0
End Sub
Public Sub UnLoadLibraries()
    On Error GoTo EXIT1
    fRetVal = FreeLibrary(hLibLL_USB)
    hLibLL_USB = 0
EXIT1:
    On Error GoTo 0
End Sub
Public Sub CheckLibFuncs()
'PURPOSE: Checks for presence of required functions in LL_USB2k.DLL

'=====================================================================\
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'=====================================================================/
'---------------->              INITIALIZATION
'* DLL_Init
'---------------->              DEVICE HANDLING
'* DLL_ResetDevice
'* DLL_GetDeviceIDList
'* DLL_ZeroSharedDevArray
'* DLL_ShowSharedDevArray
'* DLL_InstanceInitDeviceList
'* DLL_ReleaseDeviceFromIDList
'---------------->              DEVICE READ/WRITE
'* DLL_ReadWriteOneDevice
'---------------->              RATE (special)
'* DLL_SetRate
'---------------->              SCANNING
'* DLL_StartScan_DIO
'* DLL_ReadScanData_DIO
'* DLL_ReadScanDataWithDigin
'* DLL_EndScan_DIO
'---------------->              DEVICE INFO
'* DLL_ShowDeviceDescriptor
'* DLL_ShowConfigurationDescriptor
'* DLL_ShowInterfaceDescriptors
'* DLL_ShowEndpointDescriptors
'* DLL_GetDevVersion
'=====================================================================\
'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'=====================================================================/
'On Error GoTo MISSING_DLL_FUNC
'=======================================================================
'---------------->              INITIALIZATION
'=======================================================================
'DLL_Init
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_Init")
    If hLibCheck = 0 Then
        MsgBox "DLL_Init not found"
        GoTo MISSING_DLL_FUNC
    End If

'=======================================================================
'---------------->              DEVICE HANDLING
'=======================================================================
'DLL_ResetDevice(USHORT usDevID, BYTE bReserved);
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ResetDevice")
    If hLibCheck = 0 Then
        MsgBox "DLL_ResetDevice not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_ShowSharedDevArray
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ShowSharedDevArray")
    If hLibCheck = 0 Then
        MsgBox "DLL_ShowSharedDevArray not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_ZeroSharedDevArray
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ZeroSharedDevArray")
    If hLibCheck = 0 Then
        MsgBox "DLL_ZeroSharedDevArray not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_GetDeviceIDList
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_GetDeviceIDList")
    If hLibCheck = 0 Then
        MsgBox "DLL_GetDeviceIDList not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_InstanceInitDeviceList
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_InstanceInitDeviceList")
    If hLibCheck = 0 Then
        MsgBox "DLL_InstanceInitDeviceList not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_ReleaseDeviceFromIDList
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ReleaseDeviceFromIDList")
    If hLibCheck = 0 Then
        MsgBox "DLL_ReleaseDeviceFromIDList not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_ReInitOneDev
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ReInitOneDev")
    If hLibCheck = 0 Then
        MsgBox "DLL_ReInitOneDev not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_MarkOneDevAsInUse
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_MarkOneDevAsInUse")
    If hLibCheck = 0 Then
        MsgBox "DLL_MarkOneDevAsInUse not found"
        GoTo MISSING_DLL_FUNC
    End If
    
'=======================================================================
'---------------->              DEVICE READ/WRITE
'=======================================================================
'DLL_ReadWriteOneDevice
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ReadWriteOneDevice")
    If hLibCheck = 0 Then
        MsgBox "DLL_ReadWriteOneDevice not found"
        GoTo MISSING_DLL_FUNC
    End If
'=======================================================================
'---------------->              RATE (special)
'=======================================================================
'DLL_SetRate
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_SetRate")
    If hLibCheck = 0 Then
        MsgBox "DLL_SetRate not found"
        GoTo MISSING_DLL_FUNC
    End If
'=======================================================================
'---------------->              SCANNING
'=======================================================================
'DLL_StartScan_DIO
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_StartScan_DIO")
    If hLibCheck = 0 Then
        MsgBox "DLL_StartScan_DIO not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_ReadScanData_DIO
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ReadScanData_DIO")
    If hLibCheck = 0 Then
        MsgBox "DLL_ReadScanData_DIO not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_ReadScanDataWithDigin
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ReadScanDataWithDigin")
    If hLibCheck = 0 Then
        MsgBox "DLL_ReadScanDataWithDigin not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_EndScan_DIO
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_EndScan_DIO")
    If hLibCheck = 0 Then
        MsgBox "DLL_EndScan_DIO not found"
        GoTo MISSING_DLL_FUNC
    End If
    
'=======================================================================
'---------------->    DLL MESSAGING AND MISC DEVICE INFO
'=======================================================================
'DLL_ShowDeviceDescriptor
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ShowDeviceDescriptor")
    If hLibCheck = 0 Then
        MsgBox "DLL_ShowDeviceDescriptor not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_ShowConfigurationDescriptor
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ShowConfigurationDescriptor")
    If hLibCheck = 0 Then
        MsgBox "DLL_ShowConfigurationDescriptor not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_ShowInterfaceDescriptors
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ShowInterfaceDescriptors")
    If hLibCheck = 0 Then
        MsgBox "DLL_ShowInterfaceDescriptors not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_ShowEndpointDescriptors
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_ShowEndpointDescriptors")
    If hLibCheck = 0 Then
        MsgBox "DLL_ShowEndpointDescriptors not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_GetDevVersion
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_GetDevVersion")
    If hLibCheck = 0 Then
        MsgBox "DLL_GetDevVersion not found"
        GoTo MISSING_DLL_FUNC
    End If
'DLL_GetVersionInfo
    hLibCheck = GetProcAddress(hLibLL_USB, "DLL_GetVersionInfo")
    If hLibCheck = 0 Then
        MsgBox "DLL_GetVersionInfo not found"
        GoTo MISSING_DLL_FUNC
    End If
    
    GoTo EXIT1
    
MISSING_DLL_FUNC:
    On Error GoTo 0
    UnLoadLibraries
    fRetVal = MsgDisplay("CRITICAL ERROR" _
        & Chr(10) _
        & Chr(10) _
        & Chr(10) _
        & "Could not locate one or more of the required" _
        & Chr(10) _
        & "functions the LL_USBLib.DLL module." _
        & Chr(10) _
        & Chr(10) _
        & Chr(10) _
        & "Please contact Lawson Labs, Inc. For more trouble suggestions" _
        & Chr(10) _
        & Chr(10), _
         "error")
    End
    On Error GoTo 0
    fRetVal = False
    Return
EXIT1:
    fRetVal = True
End Sub
Public Sub Wait(dWaitTime)
    Dim dblEndTime As Double
    dblEndTime = Timer + dWaitTime
    Do While dblEndTime > Timer
        DoEvents
    Loop
End Sub
Public Function MsgDisplay(strMsg As String, mLabel As String)
    Const MB_OK = 0
    'MsgBox strMsg, vbOK       'this box has no title control
    '2-14-11 iRetVal = MessageBox(frmLL_USB.hwnd, strMsg, mLabel, MB_OK)
End Function
Public Function ScrollText(Direction As String)
    If Direction = "down" Then
        frmGraph_EMF16.txtMsgDisplay.SelStart = Len(frmGraph_EMF16.txtMsgDisplay) & vbCrLf
    ElseIf Direction = "end" Then
        frmGraph_EMF16.txtMsgDisplay.SelStart = Len(frmGraph_EMF16.txtMsgDisplay)
    End If
End Function
Public Sub MainPnlCtrlDisable()
    'no longer used
End Sub
Public Sub DoSysCal()
    'no longer used
End Sub
Public Function DoChanChange() As Boolean
    'no longer used
End Function
Public Sub CalcAndLoadRateCodes()
    'no longer used
End Sub
Public Sub UpdateLocalDevice()
    'no longer used
End Sub
Public Sub UpdateAvailDevListAndControls()
    'no longer used
End Sub
Public Sub ReadIniFileDebugLevel()
    'no longer used
End Sub
Public Sub ReadIniFileScanBoostLevel()
    'no longer used
End Sub
Public Sub ReadIniFileInHouseConfig()
    'no longer used
End Sub
Public Function copyM30x_grfToWinFolder()
    Dim strFolder As String
    Dim lngResult As Long
    On Error GoTo EXIT_ERR
    strFolder = String(MAX_PATH, 0)
    lngResult = GetWindowsDirectory(strFolder, MAX_PATH)
    If lngResult <> 0 Then
        Shell ("CopyIni.bat")
        copyM30x_grfToWinFolder = True
    Else
        copyM30x_grfToWinFolder = False
    End If
    Exit Function
    
EXIT_ERR:
    MsgBox vbCrLf & "Could not copy M30x_grf.ini to Windows folder." _
        & vbCrLf & vbCrLf & "M30x_grf.ini should be in current application folder but doesn't seem to be.  " _
        & vbCrLf & vbCrLf & "Please redownload archive from our website" & vbCrLf & vbCrLf
    copyM30x_grfToWinFolder = False
End Function
Public Function CheckIniExist_MAIN() As Boolean
    '.ini file check
    If Dir(Environ$("windir") & "\M30x_grf.ini") <> "" Then
        CheckIniExist_MAIN = True
        Exit Function
    Else
        Dim copySuccess As Boolean
        If copyM30x_grfToWinFolder() = False Then
            MsgBox vbCrLf & "Could not copy M30x_grf.ini to Windows folder." _
            & vbCrLf & vbCrLf & "M30x_grf.ini should be in current application folder." _
            & vbCrLf & vbCrLf & "Please redownload archive from our website" & vbCrLf & vbCrLf
            CheckIniExist_MAIN = False: Exit Function
        End If
    End If
    CheckIniExist_MAIN = True
    Exit Function
End Function
'Public Sub ReadIniFileSpecs_MAIN()
Public Function ReadIniFileSpecs_MAIN()
    Dim lRetVal_LOCAL As Long
    Dim strIniString As String: strIniString = String(32, vbNullChar)

    dblDRF_STA = 1 '8-1-15 temp

    If CheckIniExist_MAIN = False Then
        GoTo EXIT_ERR
    End If
    On Error GoTo EXIT_ERR
    
    'MsgBox "#2"
    '3-19-18 was an exception thrown here since the file was being read before WinXP was finished
    ' creating it. Discovered the fix when I started adding message boxes to determine where the error
    ' was happening. With all message boxes, there was no error, so began removing them one by one. With
    ' just the one at this location remaing, there was no exception being thrown. So removed
    ' the message box and add the sleep below.
    Sleep (1500)
    
    lRetVal_LOCAL = GetPrivateProfileString("MISC", "IsEMF", "1", strIniString, 2, "M30x_grf.ini")
    Dim bval As Byte
    bval = Val(strIniString)
    If bval Then fIsEMFapp = True Else fIsEMFapp = False
    
'MsgBox "#1"

    lRetVal_LOCAL = GetPrivateProfileString("MISC", "noSubs", "1", strIniString, 2, "M30x_grf.ini")
    bval = Val(strIniString)
    If bval Then
        frmGraph_EMF16.chkSimplifiedMode.Value = vbChecked
    Else
        frmGraph_EMF16.chkSimplifiedMode.Value = vbUnchecked
    End If
    
    lRetVal_LOCAL = GetPrivateProfileString("MISC", "doLogDLL", "1", strIniString, 2, "M30x_grf.ini")
    bval = Val(strIniString)
    If bval Then
        doDbgDLL = True
    Else
        doDbgDLL = False
    End If
    
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "LastDevID", "0", strIniString, 8, "M30x_grf.ini")
    Dim ival As Integer
    ival = Val(strIniString)
    If ival Then
        m30x.usDevId = Val(strIniString)
        frmGraph_EMF16.txtDevID.Text = m30x.usDevId
    End If
    
'8-1-15d start new #######
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "DRF_STA", "1", strIniString, 8, "M30x_grf.ini")
    '11-29-16 bval = Val(strIniString)
    '11-29-16 If bval Then
    Dim dblDRF_STA_temp As Double '11-29-16
    dblDRF_STA_temp = Val(strIniString) '11-29-16
    If dblDRF_STA_temp Then '11-29-16
        dblDRF_STA = Val(strIniString)
        frmChanSelect.intervalReductionText.Text = dblDRF_STA
    End If
'8-1-15d end new #########
    
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "localAvg", "4", strIniString, 8, "M30x_grf.ini")
    ival = Val(strIniString)
'10-22-15d    If (ival = 1) Or (ival = 2) Or (ival = 4) Or (ival = 8) Or (ival = 16) Or (ival = 32) Or (ival = 64) Or (ival = 128) Then
        iScanAvg = Val(strIniString)
        frmGraph_EMF16.comboAvg_emf16.Text = iScanAvg
'10-22-15d    Else
'10-22-15d        frmGraph_EMF16.comboAvg_emf16.Text = "4"
'10-22-15d    End If
    
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "tScan", "1", strIniString, 8, "M30x_grf.ini")
    m30x.tScan = Val(strIniString)
    
    If (m30x.tScan <> 1) And (m30x.tScan <> 2) And (m30x.tScan <> 3) And (m30x.tScan <> 4) And (m30x.tScan <> 5) And (m30x.tScan <> 6) Then m30x.tScan = 1
    
'1   SINGLE_CHAN_SCAN
'2   MULTI_CHAN_SCAN
'3   MULTI_CHAN_CAL_SCAN
'4   SINGLE_CHAN_DIGIN_SCAN
'5   MULTI_CHAN_DIGIN_SCAN
'6   MULTI_CHAN_CAL_DIGIN_SCAN
'10-19-15 LOOK
    If (m30x.tScan = MULTI_CHAN_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_SCAN) _
        Or (m30x.tScan = MULTI_CHAN_DIGIN_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
        '10-21-15d frmChanSelect.comboChanSelectScanType.Text = "multi-chan cal"
        frmChanSelect.comboChanSelectScanType.Text = "multi-chan scan"  'this may not exist anymore?
        
        frmChanSelect.txtScanType.Text = "MULTI_CHAN_SCAN" '10-21-15d
        
        '10-21-15d START ############
        ' this overides lines above
        If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
            frmChanSelect.chkEnableCalScan.Value = vbChecked
            frmChanSelect.comboChanSelectScanType.Text = "multi-chan cal scan" 'this may not exist anymore?
            frmChanSelect.txtScanType.Text = "MULTI_CHAN_CAL_SCAN"
        End If
        '10-21-15d END ############
        
    Else
        frmChanSelect.comboChanSelectScanType.Text = "single-chan"
        lRetVal_LOCAL = GetPrivateProfileString("MAIN", "singleChanScanMainChan", "0", strIniString, 8, "M30x_grf.ini")
        
        '7-27-15b start ######
'        If fIsEMFapp Then
'            lRetVal_LOCAL = GetPrivateProfileString("MAIN", "singleChanScanMainChan", "1", strIniString, 8, "M30x_grf.ini")
'        Else
'            lRetVal_LOCAL = GetPrivateProfileString("MAIN", "singleChanScanMainChan", "0", strIniString, 8, "M30x_grf.ini")
'        End If
        '7-27-15b end ######
        
        bDisplayChan = Val(strIniString) '5-9-14c
        
        '7-27-15b start ######
        If fIsEMFapp Then
            bDisplayChan = bDisplayChan - 1
        End If
        '7-27-15b end ######
        
    End If
    
'MsgBox "#3"

    
    '7-27-15f moved this down here but left bDisplayChan = bDisplayChan - 1 above for single chan
    '7-27-15b start ######
    If fIsEMFapp Then
        frmGraph_EMF16.txtChanLabel(0).Text = "Chan 1"
        frmGraph_EMF16.txtChanLabel(1).Text = "Chan 2"
        frmGraph_EMF16.txtChanLabel(2).Text = "Chan 3"
        frmGraph_EMF16.txtChanLabel(3).Text = "Chan 4"
        frmGraph_EMF16.txtChanLabel(4).Text = "Chan 5"
        frmGraph_EMF16.txtChanLabel(5).Text = "Chan 6"
        
        frmGraph_EMF16.txtSubLabel(0).Text = "sub 1"
        frmGraph_EMF16.txtSubLabel(1).Text = "sub 2"
        frmGraph_EMF16.txtSubLabel(2).Text = "sub 3"
        frmGraph_EMF16.txtSubLabel(3).Text = "sub 4"
        frmGraph_EMF16.txtSubLabel(4).Text = "sub 5"
        frmGraph_EMF16.txtSubLabel(5).Text = "sub 6"
        frmGraph_EMF16.txtSubLabel(6).Text = "sub 7"
        frmGraph_EMF16.txtSubLabel(7).Text = "sub 8"
        frmGraph_EMF16.txtSubLabel(8).Text = "sub 9"
        frmGraph_EMF16.txtSubLabel(9).Text = "sub 10"
        frmGraph_EMF16.txtSubLabel(10).Text = "sub 11"
        frmGraph_EMF16.txtSubLabel(11).Text = "sub 12"
        frmGraph_EMF16.txtSubLabel(12).Text = "sub 13"
        frmGraph_EMF16.txtSubLabel(13).Text = "sub 14"
        frmGraph_EMF16.txtSubLabel(14).Text = "sub 15"
        frmGraph_EMF16.txtSubLabel(15).Text = "sub 16"
    End If
        '7-27-15b end ######
    
'10-19-15 LOOK
    If (m30x.tScan = MULTI_CHAN_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_SCAN) _
        Or (m30x.tScan = MULTI_CHAN_DIGIN_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
        frmChanSelect.chkEnableMultiChan.Value = vbChecked
        frmChanSelect.txtScanType.Text = "scanType : MULTI_CHAN_SCAN"
        frmGraph_EMF16.lblScanDataTitle = "Multi-Channel  Scan Data"
        
        '10-20-15 START #############
        If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
            frmChanSelect.chkEnableMultiChan.Value = vbChecked
            frmGraph_EMF16.lblScanDataTitle = "Multi-Channel Cal-Scan Data"
            If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Then
                frmChanSelect.txtScanType.Text = "scanType : MULTI_CHAN_CAL_SCAN"
            Else
                frmChanSelect.txtScanType.Text = "scanType : MULTI_CHAN_CAL_DIGIN_SCAN"
            End If
        End If
        '10-20-15 END ###############

        
        
    Else
        frmChanSelect.chkEnableMultiChan.Value = vbUnchecked
        frmChanSelect.txtScanType.Text = "scanType : SINGLE_CHAN_SCAN"
        frmGraph_EMF16.lblScanDataTitle = "Single-Channel Scan Data"
    End If
    
    bScanType_SAVE = m30x.tScan
    
    Dim dblRate As Double
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "Rate", "100.0", strIniString, 8, "M30x_grf.ini")
    m30x.rate = CDbl(Val(strIniString))
    
    frmGraph_EMF16.ComboRate.Text = Format$(m30x.rate, "###.00")
    dblCurrentRateToSend = m30x.rate '12-2-16d
    
    Dim tempDbl As Double
    tempDbl = CDbl(frmGraph_EMF16.ComboRate.Text)
    
'MsgBox "#4"

    
'4-9-15c added the IF
'10-19-15 LOOK
    If (m30x.tScan = MULTI_CHAN_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_SCAN) _
        Or (m30x.tScan = MULTI_CHAN_DIGIN_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
    
        lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "0", "1", strIniString, 8, "M30x_grf.ini")
        m30x.chan(0) = Val(strIniString)
        lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "1", "0", strIniString, 8, "M30x_grf.ini")
        m30x.chan(1) = Val(strIniString)
        lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "2", "0", strIniString, 8, "M30x_grf.ini")
        m30x.chan(2) = Val(strIniString)
        lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "3", "0", strIniString, 8, "M30x_grf.ini")
        m30x.chan(3) = Val(strIniString)
        lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "4", "0", strIniString, 8, "M30x_grf.ini")
        m30x.chan(4) = Val(strIniString)
        lRetVal_LOCAL = GetPrivateProfileString("SubChannels", "5", "0", strIniString, 8, "M30x_grf.ini")
        m30x.chan(5) = Val(strIniString)
        
    Else
        m30x.chan(bDisplayChan) = 1
    End If
    
    m30x.numChannels = 0
    
    Dim bIndex As Byte
    
'MsgBox "#5"

    
    If frmGraph_EMF16.chkSimplifiedMode.Value = vbUnchecked Then '4-29-14 no subs for non-thermscan
        Dim bLowVal As Byte
        Dim bHiVal As Byte
        For bIndex = 0 To 5
            If m30x.chan(bIndex) <> 16 Then
                If ((m30x.chan(bIndex) And &HF0) \ 16) > (m30x.chan(bIndex) And &HF) Then
                    m30x.chan(bIndex) = m30x.chan(bIndex) + ((m30x.chan(bIndex) And &HF0) \ 16)
                End If
            End If
        Next bIndex
        For bIndex = 0 To 5
            If m30x.chan(bIndex) <> 16 Then
                bLowVal = (m30x.chan(bIndex) And &HF0) \ 16
                bHiVal = (m30x.chan(bIndex) And &HF)
                m30x.numChannels = m30x.numChannels + (bHiVal - bLowVal) + 1
            End If
        Next bIndex
    'this is for making use of graphing feature without the 201 style channel/subchannel as with DLL thermscan functions
    ' for use with no sub channels and keep compatible with ini with sub channels any channel set to 16 still idicates it's not
    ' active, any non-zero channel remains set, if a channel is set then all lower channels must also be set
    Else    'no subs for non-thermscan
        frmChanSelect.chkChan0Subs(0).Value = vbUnchecked: frmChanSelect.chkChan1Subs(0).Value = vbUnchecked: frmChanSelect.chkChan2Subs(0).Value = vbUnchecked
        frmChanSelect.chkChan3Subs(0).Value = vbUnchecked: frmChanSelect.chkChan4Subs(0).Value = vbUnchecked: frmChanSelect.chkChan5Subs(0).Value = vbUnchecked
        For bIndex = 0 To 15
            frmGraph_EMF16.btnChans(bIndex).BackColor = &H8000000F
            frmGraphTextVolts.txtGrTextVolts(bIndex).Enabled = False
            frmGraphTextVolts.lblGraphSubChan(bIndex).Enabled = False
            frmGraph_EMF16.btnChans(bIndex).Enabled = False
        Next
        
        Dim bPrevChanEnabledWatch As Byte: bPrevChanEnabledWatch = 0
        
        If ((m30x.chan(0) > 0) And (m30x.chan(0) <> 16)) Then
            m30x.numChannels = m30x.numChannels + 1
            If (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Or (m30x.tScan = SINGLE_CHAN_SCAN) Then
                m30x.numChannels = 1 '6-3-14
                m30x.chan(1) = 0: m30x.chan(2) = 0: m30x.chan(3) = 0: m30x.chan(4) = 0: m30x.chan(5) = 0 '6-3-14
                GoTo DONE_CHAN_CNT '5-13-14 only one channel allowed
            Else
                bPrevChanEnabledWatch = bPrevChanEnabledWatch + 1
            End If
        End If
        If ((m30x.chan(1) > 0) And (m30x.chan(1) <> 16)) Then
            m30x.numChannels = m30x.numChannels + 1
            'only one channel allowed single channel, only sequental for multi-chan
            If (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Or (m30x.tScan = SINGLE_CHAN_SCAN) Then
                m30x.numChannels = 1 '6-3-14
                m30x.chan(0) = 0: m30x.chan(2) = 0: m30x.chan(3) = 0: m30x.chan(4) = 0: m30x.chan(5) = 0 '6-3-14
                GoTo DONE_CHAN_CNT '5-13-14 only one channel allowed
            Else
                If bPrevChanEnabledWatch < 1 Then
                    m30x.numChannels = m30x.numChannels - 1
                    m30x.chan(1) = 0: m30x.chan(2) = 0: m30x.chan(3) = 0: m30x.chan(4) = 0: m30x.chan(5) = 0 '6-3-14
                    GoTo DONE_CHAN_CNT
                End If
                bPrevChanEnabledWatch = bPrevChanEnabledWatch + 1
                frmGraphTextVolts.lblGraphSubChan(0).Enabled = True '6-3-14
            End If
        End If
        If ((m30x.chan(2) > 0) And (m30x.chan(2) <> 16)) Then
            m30x.numChannels = m30x.numChannels + 1
            If (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Or (m30x.tScan = SINGLE_CHAN_SCAN) Then
                m30x.numChannels = 1
                m30x.chan(0) = 0: m30x.chan(1) = 0: m30x.chan(3) = 0: m30x.chan(4) = 0: m30x.chan(5) = 0 '6-3-14
                GoTo DONE_CHAN_CNT
            Else
                If bPrevChanEnabledWatch < 2 Then
                    m30x.numChannels = m30x.numChannels - 1
                    m30x.chan(2) = 0: m30x.chan(3) = 0: m30x.chan(4) = 0: m30x.chan(5) = 0 '6-3-14
                    GoTo DONE_CHAN_CNT
                End If
                bPrevChanEnabledWatch = bPrevChanEnabledWatch + 1
            End If
        End If
        If ((m30x.chan(3) > 0) And (m30x.chan(3) <> 16)) Then
            m30x.numChannels = m30x.numChannels + 1
            
            If (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Or (m30x.tScan = SINGLE_CHAN_SCAN) Then
                m30x.numChannels = 1
                m30x.chan(0) = 0: m30x.chan(1) = 0: m30x.chan(2) = 0: m30x.chan(4) = 0: m30x.chan(5) = 0 '6-3-14
                GoTo DONE_CHAN_CNT
            Else
                If bPrevChanEnabledWatch < 3 Then
                    m30x.numChannels = m30x.numChannels - 1
                    m30x.chan(3) = 0: m30x.chan(4) = 0: m30x.chan(5) = 0
                    GoTo DONE_CHAN_CNT
                End If
                bPrevChanEnabledWatch = bPrevChanEnabledWatch + 1
            End If
        End If
        If ((m30x.chan(4) > 0) And (m30x.chan(4) <> 16)) Then
            m30x.numChannels = m30x.numChannels + 1
            'only one channel allowed single channel, only sequental for multi-chan
            If (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Or (m30x.tScan = SINGLE_CHAN_SCAN) Then
                m30x.numChannels = 1
                m30x.chan(0) = 0: m30x.chan(1) = 0: m30x.chan(2) = 0: m30x.chan(3) = 0: m30x.chan(5) = 0
                GoTo DONE_CHAN_CNT 'only one channel allowed
            Else
                If bPrevChanEnabledWatch < 4 Then
                    m30x.numChannels = m30x.numChannels - 1
                    m30x.chan(4) = 0: m30x.chan(5) = 0
                    GoTo DONE_CHAN_CNT
                End If
                bPrevChanEnabledWatch = bPrevChanEnabledWatch + 1
            End If
        End If
        If ((m30x.chan(5) > 0) And (m30x.chan(5) <> 16)) Then
            m30x.numChannels = m30x.numChannels + 1
            'only one channel allowed single channel, only sequental for multi-chan
            If (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Or (m30x.tScan = SINGLE_CHAN_SCAN) Then
                m30x.numChannels = 1
                m30x.chan(0) = 0: m30x.chan(1) = 0: m30x.chan(2) = 0: m30x.chan(3) = 0: m30x.chan(4) = 0
                GoTo DONE_CHAN_CNT
            Else
                If bPrevChanEnabledWatch < 5 Then
                    m30x.numChannels = m30x.numChannels - 1
                    m30x.chan(5) = 0
                    GoTo DONE_CHAN_CNT
                End If
                bPrevChanEnabledWatch = bPrevChanEnabledWatch + 1
            End If
        End If
    End If
DONE_CHAN_CNT:
    
'MsgBox "#6"

    
    If m30x.numChannels = 0 Then
        MsgBox "No active channels." & vbCrLf & vbCrLf & "M30x_grf.ini shows either single-channel scan with no channels" & vbCrLf & _
         "selected or multi-channel scan and channels are not subsequent. " & vbCrLf & "For example channel 2 may be set active but 1 is not."
        ReadIniFileSpecs_MAIN = False  '4-28-14
        Exit Function
    End If
    
    
    '10-20-15 START #############
    If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
        m30x.numChannels = m30x.numChannels + 1
    End If
    '10-20-15 END ###############
    
    
'MsgBox "#7"

    
    
    
'1   SINGLE_CHAN_SCAN
'2   MULTI_CHAN_SCAN
'3   MULTI_CHAN_CAL_SCAN
'4   SINGLE_CHAN_DIGIN_SCAN
'5   MULTI_CHAN_DIGIN_SCAN
'6   MULTI_CHAN_CAL_DIGIN_SCAN
    If (m30x.tScan <> SINGLE_CHAN_DIGIN_SCAN) And (m30x.tScan <> SINGLE_CHAN_SCAN) Then
        m30x.scanInterval = 1# / (m30x.rate / (m30x.numChannels * 5))
    Else
        m30x.scanInterval = 1# / m30x.rate
    End If
    
    dblMinTime = m30x.scanInterval
    dblMaxTime = m30x.scanInterval
    frmChanSelect.txtValScanIntMin.Text = Format$(dblMinTime, "###.000")
    frmChanSelect.txtValScanIntMax.Text = Format$(dblMinTime, "###.000")
    frmChanSelect.txtUserReqScanInterval.Text = Format$(m30x.scanInterval, "##.00000")
    '8-1-15 line below is new
    frmChanSelect.textActualScanInterval.Text = CDbl(frmChanSelect.txtUserReqScanInterval.Text) * CDbl(frmChanSelect.intervalReductionText.Text) '8-1-15d
    frmChanSelect.txtScanDataRate.Text = Format$(1# / m30x.scanInterval, "###.000")
    frmChanSelect.txtScanDataRate.Text = Format$(1# / m30x.scanInterval, "###.000")
    
    'just for testing
    Dim bvall As Byte
    bvall = m30x.chan(0)
    bvall = m30x.chan(1)
    
    Dim iChanVal, subChanTemp, mainChanTemp As Integer
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "singleChanScanMainChan", "0", strIniString, 2, "M30x_grf.ini")
    
    mainChanTemp = Val(strIniString)
    If mainChanTemp > 5 Then mainChanTemp = 5
    
    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "singleChanScanSubChan", "0", strIniString, 3, "M30x_grf.ini")
    subChanTemp = Val(strIniString)
    If subChanTemp > 15 Then subChanTemp = 15
    m30x.channel = mainChanTemp
    m30x.subChan = subChanTemp
    m30x.singleChan = (mainChanTemp * 16) + subChanTemp
    iSingleChan_SAVE = m30x.singleChan
    
    
'MsgBox "#8"

    
    
    
'    '## G R A P H I C S  ###########
    lRetVal_LOCAL = GetPrivateProfileString("Graphics", "autoscale", "1", strIniString, 2, "M30x_grf.ini")
    bAutoScale = Val(strIniString)
    If bAutoScale > 1 Then bAutoScale = 1
    If bAutoScale = 1 Then
        frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)"
    Else
        bAutoScale = 0
        frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (off)"
    End If

    lRetVal_LOCAL = GetPrivateProfileString("Graphics", "SecPerScrn", "60", strIniString, 7, "M30x_grf.ini")
    dblXRange = Val(strIniString)
    
    dblXIndex = dblXRange

    frmGraph_EMF16.SecPerScrn.Text = dblXRange
    DoEvents
    bConfigChanges(CONFIG_GRAPH_SEC_PER_SCRN) = 0

    lRetVal_LOCAL = GetPrivateProfileString("Graphics", "MaxRange", "5.0", strIniString, 7, "M30x_grf.ini")
    dblMaxFullScale = Val(strIniString)
    
'MsgBox "#9"

    
    Dots
    
    
'MsgBox "#10"

    
    
    
    lRetVal_LOCAL = GetPrivateProfileString("Graphics", "MinRange", "-5.0", strIniString, 7, "M30x_grf.ini")
    dblMinFullScale = Val(strIniString)
    If bAutoScale = 0 Then
        frmGraph_EMF16.txtPosFullScale.Text = Format$(dblMaxFullScale, "##.00000")
        frmGraph_EMF16.txtNegFullScale.Text = Format$(dblMinFullScale, "##.00000")
        'these were changed by us not user
        bConfigChanges(CONFIG_GRAPH_SCALE_MAX) = 0
        bConfigChanges(CONFIG_GRAPH_SCALE_MIN) = 0

    End If

    lRetVal_LOCAL = GetPrivateProfileString("MAIN", "LogScans", "1", strIniString, 2, "M30x_grf.ini")
    bLogScanVal_EMF16 = Val(strIniString)
    
'MsgBox "#11"
    
    If bLogScanVal_EMF16 Then
        frmGraph_EMF16.CheckLogData.Value = vbChecked
    Else
        frmGraph_EMF16.CheckLogData.Value = vbUnchecked
    End If
    
    If bLogScanVal_EMF16 > 1 Then bLogScanVal_EMF16 = 1

    '11-30-16 If ReadIniFileSpecs_CHoffsets = False Then
    On Error GoTo CREAT_CAL_FILE
    
'MsgBox "#12"
    
    
    If ReadAppDirOffsetFile = False Then
        'Need to cover this in case the call completes with error (for example the file doesn't exist)
        frmGraphTextVolts.txtUsingOffsetVoltage.Text = "NOT using offset voltage"
        bUseOffsetVoltages = 0
    Else
        frmGraphTextVolts.txtUsingOffsetVoltage.Text = "USING offset voltage"
        bUseOffsetVoltages = True
    End If
    
    GoTo EXIT1

'12-9-16b start new
CREAT_CAL_FILE:
    If WriteNewAppDirOffsetFile = False Then GoTo FAIL_CREAT_OFFSET_CAL
    ReadIniFileSpecs_MAIN = True
    Exit Function
    
FAIL_CREAT_OFFSET_CAL:
    MsgBox vbCrLf & "Could not create CHOffset.cal" & vbCrLf & vbCrLf & "You may need administrator writes to create this file" & vbCrLf
    ReadIniFileSpecs_MAIN = False
    Exit Function
'12-9-16b end new
    
    

EXIT_ERR:
    MsgBox vbCrLf & "Failed to read  M30x_grf.ini" & vbCrLf & vbCrLf & "Locate file and place in  Windows  directory." & vbCrLf & vbCrLf & "Or inspect for incorrect data format" & vbCrLf & vbCrLf
    ReadIniFileSpecs_MAIN = False  'if here, we can't go any further in the app or divide by zero can happen from uninitialized variables
    Exit Function
EXIT1:
    On Error GoTo 0
    ReadIniFileSpecs_MAIN = True
End Function
Public Sub InitVars_DEFAULT()
   'Need to load this from M301_grf.ini
    
    m30x.scanInterval = 0.00001
    m30x.average = 1
    bLocalAvg = 1
'1   SINGLE_CHAN_SCAN
'2   MULTI_CHAN_SCAN
'3   MULTI_CHAN_CAL_SCAN
'4   SINGLE_CHAN_DIGIN_SCAN
'5   MULTI_CHAN_DIGIN_SCAN
'6   MULTI_CHAN_CAL_DIGIN_SCAN
    m30x.tScan = SINGLE_CHAN_SCAN
    
    If frmGraph_EMF16.chkSimplifiedMode.Value = vbUnchecked Then '4-29-14
        m30x.chan(0) = 15
        m30x.chan(1) = 16
        m30x.chan(2) = 16
        m30x.chan(3) = 16
        m30x.chan(4) = 16
        m30x.chan(5) = 16
    Else
        m30x.chan(0) = 1
        m30x.chan(1) = 0
        m30x.chan(2) = 0
        m30x.chan(3) = 0
        m30x.chan(4) = 0
        m30x.chan(5) = 0
    End If
    
    m30x.singleChan = 64
    m30x.channel = 4
    m30x.subChan = 0
    m30x.rate = 60
    m30x.numChannels = 0
    
    If frmGraph_EMF16.chkSimplifiedMode.Value = vbUnchecked Then  '4-29-14
        Dim bIndex As Byte
        Dim bLowVal As Byte
        Dim bHiVal As Byte
        
        For bIndex = 0 To 5
            If m30x.chan(bIndex) <> 16 Then
                If ((m30x.chan(bIndex) And &HF0) \ 16) > (m30x.chan(bIndex) And &HF) Then
                    m30x.chan(bIndex) = m30x.chan(bIndex) + ((m30x.chan(bIndex) And &HF0) \ 16)
                End If
            End If
        Next bIndex
        For bIndex = 0 To 5
            If m30x.chan(bIndex) <> 16 Then
                bLowVal = (m30x.chan(bIndex) And &HF0) \ 16
                bHiVal = (m30x.chan(bIndex) And &HF)
                m30x.numChannels = m30x.numChannels + (bHiVal - bLowVal) + 1
            End If
        Next bIndex
    Else
        m30x.numChannels = 1
    End If
    
    'GRAPHICS #######################
    dblXRange = 60#     ' sec per screen
    dblXIndex = dblXRange
    dblMaxFullScale = 5#
    dblMinFullScale = -5#
    bAutoScale = 1
    bLogScanVal_EMF16 = 1
    
    If bAutoScale = 0 Then
        frmGraph_EMF16.txtPosFullScale.Text = Format$(dblMaxFullScale, "##.00000")
        frmGraph_EMF16.txtNegFullScale.Text = Format$(dblMinFullScale, "##.00000")
        'these were changed by us not user
        bConfigChanges(CONFIG_GRAPH_SCALE_MAX) = 0
        bConfigChanges(CONFIG_GRAPH_SCALE_MIN) = 0
    End If
    '################################
    
End Sub
Public Sub SaveConfigParam()
    Dim strChangedParams As String: strChangedParams = String(256, vbNullChar)
    strChangedParams = ""
    
    Dim bIndex As Byte: Dim fGotChangedParam As Boolean: fGotChangedParam = False
    
'    CONFIG_COM = 0
'    CONFIG_BAUD = 1
'    CONFIG_RATE = 2
'    CONFIG_REMOTE_AVG = 3
'    CONFIG_LOCAL_AVG = 4
'    CONFIG_GAIN = 5
'    CONFIG_SAVE_LOG = 6
'    CONFIG_GRAPH_AUTOSCALE = 7
'    CONFIG_GRAPH_SCALE_MAX = 8
'    CONFIG_GRAPH_SCALE_MIN = 9
'    CONFIG_GRAPH_SEC_PER_SCRN = 10
'    CONFIG_MISC_USE_OFFSET_VOLTS = 11
'    CONFIG_tSCAN = 12
'    CONFIG_SCAN_CHANS = 13
'    CONFIG_SCAN_INTERVAL = 14
'    CONFIG_DEVICE_ID= 15
    
    
    For bIndex = 0 To CONFIG_ARRAY_SIZE
        If bConfigChanges(bIndex) = 1 Then
            If Len(strChangedParams) > 60 Then strChangedParams = strChangedParams + vbCrLf
        
            Select Case bIndex
                Case 2: strChangedParams = strChangedParams + "RATE, "
                Case 4: strChangedParams = strChangedParams + "Local Avg, "
                Case 6: strChangedParams = strChangedParams + "Log Save, "
                Case 7: strChangedParams = strChangedParams + "Auto-Scale, "
                Case 8: strChangedParams = strChangedParams + "Scale Max, "
                Case 9: strChangedParams = strChangedParams + "Scale Min, "
                Case 10: strChangedParams = strChangedParams + "Sec/Scrn, "
                Case 11: strChangedParams = strChangedParams + "Use offset volts, "
                Case 12: strChangedParams = strChangedParams + "Scan Type, "
                Case 13: strChangedParams = strChangedParams + "Scan Channels, "
                Case 14: strChangedParams = strChangedParams + "Scan Interval, "
                Case 15: strChangedParams = strChangedParams + "Device ID, "  '5-14-14
                '8-10-15 Case 16: strChangedParams = strChangedParams + "DRF_STA, "  '8-1-15
                Case 16: strChangedParams = strChangedParams + "Data Reduction, "  '8-11-15
                
            End Select
        
            fGotChangedParam = True
        End If
    Next bIndex
    If fGotChangedParam = False Then
        Exit Sub
    End If
    
    If MsgBox(vbCrLf & _
        "The following configuration options have changed:      " & vbCrLf & vbCrLf & strChangedParams & _
        vbCrLf & vbCrLf & vbCrLf & _
        "Update M30x_grf.ini?" & vbCrLf & vbCrLf & vbCrLf, vbQuestion Or vbSystemModal Or vbYesNo, "  Save Configuration?") <> vbYes Then
        Exit Sub
    End If

    Dim strIniString As String: strIniString = String(32, vbNullChar)
    Dim subChStr As String
    Dim bArg As Byte
    Dim dblArg As Double
    Dim lRetVal_LOCAL As Long
        
'CONFIG_COM = 0,  CONFIG_BAUD = 1,  CONFIG_RATE = 2,  CONFIG_REMOTE_AVG = 3,  CONFIG_LOCAL_AVG = 4
'CONFIG_GAIN = 5,  CONFIG_SAVE_LOG = 6,  CONFIG_GRAPH_AUTOSCALE = 7,  CONFIG_GRAPH_SCALE_MAX = 8
'CONFIG_GRAPH_SCALE_MIN = 9,  CONFIG_GRAPH_SEC_PER_SCRN = 10,  CONFIG_ARRAY_SIZE = 10
'Public bConfigChanges(10) As Byte

    On Error GoTo EXIT_ERR
    If CheckIniExist_MAIN = False Then GoTo EXIT_ERR
    
'------------------ 2
    If bConfigChanges(CONFIG_RATE) Then
        '11-23-16 strIniString = CDbl(frmGraph_EMF16.ComboRate.Text)
        strIniString = dblUserRequestedRateSave  '11-23-16 if ComboRate.Text, it would be adjusted next app load/signon
        lRetVal_LOCAL = WritePrivateProfileString("MAIN", "Rate", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
    End If
'------------------ 4
    If bConfigChanges(CONFIG_LOCAL_AVG) Then
        bArg = CByte(frmGraph_EMF16.comboAvg_emf16.Text)
        strIniString = bArg
        lRetVal_LOCAL = WritePrivateProfileString("MAIN", "localAvg", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
    End If
'------------------ 6
    If bConfigChanges(CONFIG_SAVE_LOG) Then
        If frmGraph_EMF16.CheckLogData.Value = vbChecked Then
            strIniString = "1"
        Else
            strIniString = "0"
        End If
        lRetVal_LOCAL = WritePrivateProfileString("MAIN", "LogScans", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
    End If
'------------------ 7
    If bConfigChanges(CONFIG_GRAPH_AUTOSCALE) Then
        strIniString = bAutoScale
        lRetVal_LOCAL = WritePrivateProfileString("Graphics", "autoscale", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
    End If
'------------------ 8
    If bConfigChanges(CONFIG_GRAPH_SCALE_MAX) Then
        strIniString = frmGraph_EMF16.txtPosFullScale
        lRetVal_LOCAL = WritePrivateProfileString("Graphics", "MaxRange", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
    End If
'------------------ 9
    If bConfigChanges(CONFIG_GRAPH_SCALE_MIN) Then
        strIniString = frmGraph_EMF16.txtNegFullScale
        lRetVal_LOCAL = WritePrivateProfileString("Graphics", "MinRange", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
    End If
'------------------ 10
    If bConfigChanges(CONFIG_GRAPH_SEC_PER_SCRN) Then
        strIniString = frmGraph_EMF16.SecPerScrn.Text
        lRetVal_LOCAL = WritePrivateProfileString("Graphics", "SecPerScrn", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
    End If
'------------------ 11
'------------------ 12
'1   SINGLE_CHAN_SCAN
'2   MULTI_CHAN_SCAN
'3   MULTI_CHAN_CAL_SCAN
'4   SINGLE_CHAN_DIGIN_SCAN
'5   MULTI_CHAN_DIGIN_SCAN
'6   MULTI_CHAN_CAL_DIGIN_SCAN
    If bConfigChanges(CONFIG_tSCAN) Then
        '5-7-14b strIniString = "1"
        '5-7-14b If m30x.tScan = 2 Then strIniString = "2"
        '5-7-14b If m30x.tScan = 0 Then strIniString = "0"
        If m30x.tScan = SINGLE_CHAN_SCAN Then strIniString = "1"
        If m30x.tScan = MULTI_CHAN_SCAN Then strIniString = "2"
'10-19-15 LOOK
        If m30x.tScan = MULTI_CHAN_CAL_SCAN Then strIniString = "3"
        If m30x.tScan = SINGLE_CHAN_DIGIN_SCAN Then strIniString = "4"
        If m30x.tScan = MULTI_CHAN_DIGIN_SCAN Then strIniString = "5"
        If m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN Then strIniString = "6"
        lRetVal_LOCAL = WritePrivateProfileString("MAIN", "tScan", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
    End If
    
'------------------ 13
'    CONFIG_SCAN_CHANS = 13
'    CONFIG_SCAN_INTERVAL = 14
    If bConfigChanges(CONFIG_SCAN_CHANS) Then
        strIniString = m30x.chan(0)
        lRetVal_LOCAL = WritePrivateProfileString("SubChannels", "0", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
        strIniString = m30x.chan(1)
        lRetVal_LOCAL = WritePrivateProfileString("SubChannels", "1", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
        strIniString = m30x.chan(2)
        lRetVal_LOCAL = WritePrivateProfileString("SubChannels", "2", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
        strIniString = m30x.chan(3)
        lRetVal_LOCAL = WritePrivateProfileString("SubChannels", "3", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
        strIniString = m30x.chan(4)
        lRetVal_LOCAL = WritePrivateProfileString("SubChannels", "4", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
        strIniString = m30x.chan(5)
        lRetVal_LOCAL = WritePrivateProfileString("SubChannels", "5", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
        
        
        '10-17-07 start ============================================
        Dim iTempChanInfo As Integer
        lRetVal_LOCAL = GetPrivateProfileString("MAIN", "singleChanScanMainChan", "0", strIniString, 2, "M30x_grf.ini")
        iTempChanInfo = CInt(strIniString)
        Dim iTextBoxChan As Integer
        
'7-27-15        iTextBoxChan = CInt(frmGraph_EMF16.comboMainChan.Text) - 1
        
        '7-27-15 start ########
        If fIsEMFapp Then
                iTextBoxChan = CInt(frmGraph_EMF16.comboMainChan.Text)
        Else
                iTextBoxChan = CInt(frmGraph_EMF16.comboMainChan.Text) - 1
        End If
        '7-27-15 end ##########
        
        If iTempChanInfo <> iTextBoxChan Then
            strIniString = CStr(iTextBoxChan)
            lRetVal_LOCAL = WritePrivateProfileString("MAIN", "singleChanScanMainChan", strIniString, "M30x_grf.ini")
            If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
        End If
        
        lRetVal_LOCAL = GetPrivateProfileString("MAIN", "singleChanScanSubChan", "0", strIniString, 2, "M30x_grf.ini")
        iTempChanInfo = CInt(strIniString)
        If iTempChanInfo <> m30x.subChan Then
            strIniString = CStr(m30x.subChan)
            lRetVal_LOCAL = WritePrivateProfileString("MAIN", "singleChanScanSubChan", strIniString, "M30x_grf.ini")
            If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
        End If
        '10-17-07 start ============================================
        
    End If
'------------------ 14
    If bConfigChanges(CONFIG_DEVICE_ID) Then
        strIniString = CInt(frmGraph_EMF16.txtDevID.Text)
        lRetVal_LOCAL = WritePrivateProfileString("MAIN", "LastDevID", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
    End If
    
    
'8-1-15d
'------------------ 15 new 8-1-15
    If bConfigChanges(CONFIG_DRF_STA) Then
        strIniString = CInt(frmChanSelect.intervalReductionText.Text)
        lRetVal_LOCAL = WritePrivateProfileString("MAIN", "DRF_STA", strIniString, "M30x_grf.ini")
        If lRetVal_LOCAL = 0 Then GoTo EXIT_ERR
    End If
    
        
    GoTo EXIT1
         
EXIT_ERR:
    MsgBox vbCrLf & "Failed to write  M30x_grf.ini" & vbCrLf & vbCrLf & "Locate file and place in  Windows  directory." & vbCrLf & vbCrLf & "Or inspect for incorrect data format" & vbCrLf & vbCrLf
EXIT1:
    On Error GoTo 0
End Sub
Public Function LogScan(ByVal bFileStat As Byte) As Boolean
    szLogFileName = Month(Date) & "-" & Day(Date) & "-" & Year(Date) _
        & "_" & Hour(Time) & "." & Minute(Time) & "." & Second(Time) & ".txt"

    If bFileStat = SCANFILE_CREATE Then GoTo DO_CREATE
    If bFileStat = SCANFILE_CLOSE Then GoTo DO_CLOSE

DO_CREATE:
    If fScanDataFileOpened = True Then
        LogScan = True
        Exit Function
    End If
    
    hLogFile = FreeFile(3)
    On Error GoTo FILE_ERROR
    Open szLogFileName For Output As #hLogFile
    fScanDataFileOpened = True
    
    Dim str As String
    str = "Time / s" & vbTab  '5-14-14c
    
    Dim bIndexSub As Byte
    
    If frmGraph_EMF16.chkSimplifiedMode.Value = vbChecked Then
        If frmChanSelect.chkChan0Subs(0).Value = vbChecked Then
            If fIsEMFapp Then
                str = str & "[chan  1] " & "   " & vbTab
            Else
                str = str & "[chan  0] " & "   " & vbTab '5-16-14b
            End If
        Else
            GoTo DONE_SIMPLE
        End If
        If frmChanSelect.chkChan1Subs(0).Value = vbChecked Then
            If fIsEMFapp Then
                str = str & "[chan  2] " & "   " & vbTab
            Else
                str = str & "[chan  1] " & "   " & vbTab
            End If
        Else
            GoTo DONE_SIMPLE
        End If
        If frmChanSelect.chkChan2Subs(0).Value = vbChecked Then
            If fIsEMFapp Then
                str = str & "[chan  3] " & "   " & vbTab
            Else
                str = str & "[chan  2] " & "   " & vbTab
            End If
        Else
            GoTo DONE_SIMPLE
        End If
        If frmChanSelect.chkChan3Subs(0).Value = vbChecked Then
            If fIsEMFapp Then
                str = str & "[chan  4] " & "   " & vbTab
            Else
                str = str & "[chan  3] " & "   " & vbTab
            End If
        Else
            GoTo DONE_SIMPLE
        End If
        If frmChanSelect.chkChan4Subs(0).Value = vbChecked Then
            If fIsEMFapp Then
                str = str & "[chan  5] " & "   " & vbTab
            Else
                str = str & "[chan  4] " & "   " & vbTab
            End If
        Else
            GoTo DONE_SIMPLE
        End If
        If frmChanSelect.chkChan5Subs(0).Value = vbChecked Then
            If fIsEMFapp Then
                str = str & "[chan  6] " & "   " & vbTab
            Else
                str = str & "[chan  5] " & "   " & vbTab
            End If
        Else
            GoTo DONE_SIMPLE
        End If
    End If
    
    If frmGraph_EMF16.chkSimplifiedMode.Value = vbUnchecked Then  '7-16-15
        If fIsEMFapp Then
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan0Subs(bIndexSub).Value = vbChecked Then
                    str = str & "1 - " & bIndexSub + 1 & "   " & vbTab
                End If
            Next bIndexSub
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan1Subs(bIndexSub).Value = vbChecked Then
                    str = str & "2 - " & bIndexSub + 1 & "   " & vbTab
                End If
            Next bIndexSub
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan2Subs(bIndexSub).Value = vbChecked Then
                    str = str & "3 - " & bIndexSub + 1 & "   " & vbTab
                End If
            Next bIndexSub
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan3Subs(bIndexSub).Value = vbChecked Then
                    str = str & "4 - " & bIndexSub + 1 & "   " & vbTab
                End If
            Next bIndexSub
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan4Subs(bIndexSub).Value = vbChecked Then
                    str = str & "5 - " & bIndexSub + 1 & "   " & vbTab
                End If
            Next bIndexSub
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan5Subs(bIndexSub).Value = vbChecked Then
                    str = str & "6 - " & bIndexSub + 1 & "   " & vbTab
                End If
            Next bIndexSub
        Else
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan0Subs(bIndexSub).Value = vbChecked Then
                    str = str & "0 - " & bIndexSub & "   " & vbTab
                End If
            Next bIndexSub
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan1Subs(bIndexSub).Value = vbChecked Then
                    str = str & "1 - " & bIndexSub & "   " & vbTab
                End If
            Next bIndexSub
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan2Subs(bIndexSub).Value = vbChecked Then
                    str = str & "2 - " & bIndexSub & "   " & vbTab
                End If
            Next bIndexSub
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan3Subs(bIndexSub).Value = vbChecked Then
                    str = str & "3 - " & bIndexSub & "   " & vbTab
                End If
            Next bIndexSub
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan4Subs(bIndexSub).Value = vbChecked Then
                    str = str & "4 - " & bIndexSub & "   " & vbTab
                End If
            Next bIndexSub
            For bIndexSub = 0 To 15
                If frmChanSelect.chkChan5Subs(bIndexSub).Value = vbChecked Then
                    str = str & "5 - " & bIndexSub & "   " & vbTab
                End If
            Next bIndexSub
        End If
    End If  '7-16-15
    
DONE_SIMPLE:

    '10-21-15c
    If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
        str = str & "[offset]"
    End If


    
    Print #hLogFile, str
    
    GoTo DO_RETURN

DO_CLOSE:

    If fScanDataFileOpened = True Then
        Print #hLogFile, ""
        Print #hLogFile, "Averaging: " & vbTab & CByte(frmGraph_EMF16.comboAvg_emf16)

        Dim iRet As Integer
        Dim minTime As Double
        Dim maxTime As Double
        Print #hLogFile, "Internal Data Rate: " & vbTab & CInt(frmGraph_EMF16.ComboRate)  '5-14-14
        Print #hLogFile, "Number Of Scans: " & vbTab & scanCnt  '5-14-14
        Print #hLogFile, "Started: " & vbTab & Format(dblScanStartTime, "m/d/yy") & ", ";
        '7-16-15 Print #hLogFile, Format(dblScanStartTime, "h:mm:ss a/p")
        Print #hLogFile, Format(dblScanStartTime, "h:mm:ss am/pm")
        Print #hLogFile, "Finished: " & vbTab & Format(dblScanEndTime, "m/d/yy") & ", ";
        '7-16-15 Print #hLogFile, Format(dblScanEndTime, "h:mm:ss a/p")
        Print #hLogFile, Format(dblScanEndTime, "h:mm:ss am/pm")
    End If

    Close #hLogFile
    fScanDataFileOpened = False
    GoTo DO_RETURN

DO_RETURN:
    LogScan = True
    GoTo EXIT1

FILE_ERROR:
    fDoScanDataFile = False
    On Error GoTo 0
    LogScan = False
EXIT1:
End Function
Public Function WriteLogFileSubChanOnly(ByVal bMainChan As Byte) As Boolean

    '8-10-15 start ###############################################
    'block below moved up from below at first printing to log file
    
    '8-1-15c start #####
    'dblDRF_STA As Integer                  'Data Reduction Factor ScansToAverage
    'dDRF_ChanVoltageArray(6) As Double
    Dim bSTA_index As Byte: bSTA_index = 0
    
    For bSTA_index = 0 To 5
            dDRF_ChanVoltageArray(bSTA_index) = dDRF_ChanVoltageArray(bSTA_index) + dVoltage_EMF16_LOG(bSTA_index, 0)
    Next bSTA_index
    
    
    '10-21-15c
    If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
        dDRF_ChanVoltageOffset = dDRF_ChanVoltageOffset + calScanOffsetVal_global
    End If
    
    
    
    
    If scanCnt Mod dblDRF_STA <> 0 Then
    'If 3 Mod 0.3333 <> 0 Then
        Exit Function
    Else
        For bSTA_index = 0 To 5
            dDRF_ChanVoltageArray(bSTA_index) = dDRF_ChanVoltageArray(bSTA_index) / dblDRF_STA
        Next bSTA_index
    End If
    'fall through and log DRF
    
    '8-1-15c end ########
    
    If frmGraph_EMF16.CheckLogData.Value = vbUnchecked Then
    
        'following from bottom prior to 8-10-15 and still needs to be done if log file not written
        For bSTA_index = 0 To 5
            dDRF_ChanVoltageArray(bSTA_index) = 0
        Next bSTA_index
        'what's above still needs to be done if log file not written
    
        Exit Function '8-10-15
    End If
    '8-10-15 end #############


    If fScanDataFileOpened = False Then
        Dim fRetVal As Boolean
        Dim bFileStat As Byte
        bFileStat = SCANFILE_CREATE
        fRetVal = LogScan(bFileStat)
        If fRetVal = False Then
            Exit Function
        End If
    End If

    Dim bSubChanIndex As Byte
    Dim nowTimer
    nowTimer = Timer
    
'10-12-15 extended decimal places for timestamp in log file.
    Print #hLogFile, Format$((scanCnt) * (CDbl(frmChanSelect.txtUserReqScanInterval.Text)), "0000000.000") & vbTab;
    
    Dim bIndexSub As Byte
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan0Subs(bIndexSub).Value = vbChecked Then
            If dDRF_ChanVoltageArray(0) < 0 Then
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(0))), "-#.000000  ") & vbTab;
            Else
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(0))), " #.000000  ") & vbTab;
            End If
        End If
    Next bIndexSub
    
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan1Subs(bIndexSub).Value = vbChecked Then
            If dDRF_ChanVoltageArray(1) < 0 Then
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(1))), "-#.000000  ") & vbTab;
            Else
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(1))), " #.000000  ") & vbTab;
            End If
        End If
    Next bIndexSub
    
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan2Subs(bIndexSub).Value = vbChecked Then
            If dDRF_ChanVoltageArray(2) < 0 Then
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(2))), "-#.000000  ") & vbTab;
            Else
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(2))), " #.000000  ") & vbTab;
            End If
        End If
    Next bIndexSub
    
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan3Subs(bIndexSub).Value = vbChecked Then
            If dDRF_ChanVoltageArray(3) < 0 Then
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(3))), "-#.000000  ") & vbTab;
            Else
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(3))), " #.000000  ") & vbTab;
            End If
        End If
    Next bIndexSub
    
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan4Subs(bIndexSub).Value = vbChecked Then
            If dDRF_ChanVoltageArray(4) < 0 Then
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(4))), "-#.000000  ") & vbTab;
            Else
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(4))), " #.000000  ") & vbTab;
            End If
        End If
    Next bIndexSub
    
    For bIndexSub = 0 To 15
        If frmChanSelect.chkChan5Subs(bIndexSub).Value = vbChecked Then
            If dDRF_ChanVoltageArray(5) < 0 Then
                '8-10-15 Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(4))), "-#.000000  ") & vbTab;
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(5))), "-#.000000  ") & vbTab; '8-10-15
            Else
                '8-10-15 Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(4))), " #.000000  ") & vbTab;
                Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(5))), " #.000000  ") & vbTab; '8-10-15
            End If
        End If
    Next bIndexSub
    
    For bSTA_index = 0 To 5
        dDRF_ChanVoltageArray(bSTA_index) = 0
    Next bSTA_index
    
    
    '10-21-15c print chan7 to logfile and reset DRF chan7 offset value to 0
    If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
    
        If dDRF_ChanVoltageOffset < 0 Then
            '8-10-15 Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(4))), "-#.000000  ") & vbTab;
            Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageOffset)), "-#.000000  ") & vbTab; '8-10-15
        Else
            '8-10-15 Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageArray(4))), " #.000000  ") & vbTab;
            Print #hLogFile, Format$(str(Abs(dDRF_ChanVoltageOffset)), " #.000000  ") & vbTab; '8-10-15
        End If
        dDRF_ChanVoltageOffset = 0
    End If
    
    
    
SKIP_SUBS:

    If strScanLogfileComment <> "" Then
        Print #hLogFile, strScanLogfileComment;
        strScanLogfileComment = ""
    End If
    
    Print #hLogFile, ""
End Function
