Attribute VB_Name = "modScanSetup"
Option Explicit
Public Sub SetScanIntervalWithinNearestRange()
    If (m30x.tScan <> SINGLE_CHAN_DIGIN_SCAN) And (m30x.tScan <> SINGLE_CHAN_SCAN) Then 'multi-channel scan
       '10-26-15b m30x.scanInterval = 1# / ((m30x.rate / (m30x.numChannels * 5)))
       m30x.scanInterval = 1# / ((m30x.rate / ((m30x.numChannels + frmChanSelect.chkEnableCalScan.Value) * 5)))
    Else
       m30x.scanInterval = 1# / m30x.rate
    End If
    
    dblMinTime = m30x.scanInterval
    dblMaxTime = m30x.scanInterval
    frmChanSelect.txtValScanIntMin.Text = Format$(dblMinTime, "###.000")
    frmChanSelect.txtValScanIntMax.Text = Format$(dblMinTime, "###.000")
    frmChanSelect.txtUserReqScanInterval.Text = Format$(m30x.scanInterval, "##.00000")
    '8-1-15 line below is new
    frmChanSelect.textActualScanInterval.Text = CDbl(frmChanSelect.txtUserReqScanInterval.Text) * CDbl(frmChanSelect.intervalReductionText.Text) '8-1-15d
    frmChanSelect.txtScanDataRate.Text = Format$(1# / m30x.scanInterval, "###.000")
End Sub
Public Sub btnGetScanRateMax_Click_DoIt()
    'no longer used
End Sub
Public Sub CalculateScanChansAll()
'1   SINGLE_CHAN_SCAN
'2   MULTI_CHAN_SCAN
'3   MULTI_CHAN_CAL_SCAN
'4   SINGLE_CHAN_DIGIN_SCAN
'5   MULTI_CHAN_DIGIN_SCAN
'6   MULTI_CHAN_CAL_DIGIN_SCAN
    If frmGraph_EMF16.chkSimplifiedMode.Value = vbChecked Then
        If (m30x.tScan = SINGLE_CHAN_SCAN) Or (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Then
            m30x.numChannels = 1
            Exit Sub
        End If
    End If
    If m30x.tScan = 0 Then
        m30x.numChannels = 1
        Exit Sub
    End If

    Dim bChanCnt As Byte: bChanCnt = 0
    Dim bCurSubChanCnt As Byte: bCurSubChanCnt = 0

    Dim bIndex As Byte
    Dim bAny0ChanSelected As Byte: bAny0ChanSelected = 0
    Dim bAny1ChanSelected As Byte: bAny1ChanSelected = 0
    Dim bAny2ChanSelected As Byte: bAny2ChanSelected = 0
    Dim bAny3ChanSelected As Byte: bAny3ChanSelected = 0
    Dim bAny4ChanSelected As Byte: bAny4ChanSelected = 0
    Dim bAny5ChanSelected As Byte: bAny5ChanSelected = 0

    Dim bChan0Low As Integer: bChan0Low = 0
    Dim bChan1Low As Integer: bChan1Low = 0
    Dim bChan2Low As Integer: bChan2Low = 0
    Dim bChan3Low As Integer: bChan3Low = 0
    Dim bChan4Low As Integer: bChan4Low = 0
    Dim bChan5Low As Integer: bChan5Low = 0

    Dim bChan0Hi As Integer: bChan0Hi = 0
    Dim bChan1Hi As Integer: bChan1Hi = 0
    Dim bChan2Hi As Integer: bChan2Hi = 0
    Dim bChan3Hi As Integer: bChan3Hi = 0
    Dim bChan4Hi As Integer: bChan4Hi = 0
    Dim bChan5Hi As Integer: bChan5Hi = 0

    Dim bChan0GotLow As Integer: bChan0GotLow = 0
    Dim bChan1GotLow As Integer: bChan1GotLow = 0
    Dim bChan2GotLow As Integer: bChan2GotLow = 0
    Dim bChan3GotLow As Integer: bChan3GotLow = 0
    Dim bChan4GotLow As Integer: bChan4GotLow = 0
    Dim bChan5GotLow As Integer: bChan5GotLow = 0


    For bIndex = 0 To 5
        m30x.chan(bIndex) = 16
    Next bIndex


    For bIndex = 0 To 15
        If frmChanSelect.chkChan0Subs(bIndex).Value = vbChecked Then
            If bChan0GotLow = 0 Then
                m30x.chan(0) = (bIndex * 16) + bIndex
                bChan0GotLow = 1
            Else
                m30x.chan(0) = (m30x.chan(0) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny0ChanSelected = 1: frmGraph_EMF16.txtSub0Volts(bIndex).Text = " waiting": frmGraph_EMF16.txtSub0Volts(bIndex).Enabled = True
        Else
            frmGraph_EMF16.txtSub0Volts(bIndex).Text = "     ---": frmGraph_EMF16.txtSub0Volts(bIndex).Enabled = False
        End If
    Next
    For bIndex = 0 To 15
        If frmChanSelect.chkChan1Subs(bIndex).Value = vbChecked Then
            If bChan1GotLow = 0 Then
                m30x.chan(1) = (bIndex * 16) + bIndex
                bChan1GotLow = 1
            Else
                m30x.chan(1) = (m30x.chan(1) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny1ChanSelected = 1: frmGraph_EMF16.txtSub1Volts(bIndex).Text = " waiting": frmGraph_EMF16.txtSub1Volts(bIndex).Enabled = True
        Else
            frmGraph_EMF16.txtSub1Volts(bIndex).Text = "     ---": frmGraph_EMF16.txtSub1Volts(bIndex).Enabled = False
        End If
    Next
    For bIndex = 0 To 15
        If frmChanSelect.chkChan2Subs(bIndex).Value = vbChecked Then
            If bChan2GotLow = 0 Then
                m30x.chan(2) = (bIndex * 16) + bIndex
                bChan2GotLow = 1
            Else
                m30x.chan(2) = (m30x.chan(2) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny2ChanSelected = 1: frmGraph_EMF16.txtSub2Volts(bIndex).Text = " waiting": frmGraph_EMF16.txtSub2Volts(bIndex).Enabled = True
        Else
            frmGraph_EMF16.txtSub2Volts(bIndex).Text = "     ---": frmGraph_EMF16.txtSub2Volts(bIndex).Enabled = False
        End If
    Next
    For bIndex = 0 To 15
        If frmChanSelect.chkChan3Subs(bIndex).Value = vbChecked Then
            If bChan3GotLow = 0 Then
                m30x.chan(3) = (bIndex * 16) + bIndex
                bChan3GotLow = 1
            Else
                m30x.chan(3) = (m30x.chan(3) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny3ChanSelected = 1: frmGraph_EMF16.txtSub3Volts(bIndex).Text = " waiting": frmGraph_EMF16.txtSub3Volts(bIndex).Enabled = True
        Else
            frmGraph_EMF16.txtSub3Volts(bIndex).Text = "     ---": frmGraph_EMF16.txtSub3Volts(bIndex).Enabled = False
        End If
    Next
    For bIndex = 0 To 15
        If frmChanSelect.chkChan4Subs(bIndex).Value = vbChecked Then
            If bChan4GotLow = 0 Then
                m30x.chan(4) = (bIndex * 16) + bIndex
                bChan4GotLow = 1
            Else
                m30x.chan(4) = (m30x.chan(4) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny4ChanSelected = 1: frmGraph_EMF16.txtSub4Volts(bIndex).Text = " waiting": frmGraph_EMF16.txtSub4Volts(bIndex).Enabled = True
        Else
            frmGraph_EMF16.txtSub4Volts(bIndex).Text = "     ---": frmGraph_EMF16.txtSub4Volts(bIndex).Enabled = False
        End If
    Next
    For bIndex = 0 To 15
        If frmChanSelect.chkChan5Subs(bIndex).Value = vbChecked Then
            If bChan5GotLow = 0 Then
                m30x.chan(5) = (bIndex * 16) + bIndex
                bChan5GotLow = 1
            Else
                m30x.chan(5) = (m30x.chan(5) And &HF0) + bIndex
            End If
            bChanCnt = bChanCnt + 1: bAny5ChanSelected = 1: frmGraph_EMF16.txtSub5Volts(bIndex).Text = " waiting": frmGraph_EMF16.txtSub5Volts(bIndex).Enabled = True
        Else
            frmGraph_EMF16.txtSub5Volts(bIndex).Text = "     ---": frmGraph_EMF16.txtSub5Volts(bIndex).Enabled = False
        End If
    Next

    For bIndex = 0 To 5
        If m30x.chan(bIndex) <> 16 Then
            If ((m30x.chan(bIndex) And &HF0) \ 16) > (m30x.chan(bIndex) And &HF) Then
                m30x.chan(bIndex) = m30x.chan(bIndex) + ((m30x.chan(bIndex) And &HF0) \ 16)
            End If
        End If
    Next bIndex

    m30x.numChannels = bChanCnt
End Sub

