Attribute VB_Name = "graphic"
Option Explicit
Public bChanCode(6) As Byte

'BOOLEAN EX_ConnectAllDevices(BYTE* pbNumDevices, USHORT* pDevList, double* dblRates);
Declare Function EX_ConnectAllDevices Lib "LL_USB2k.DLL" (ByRef pbNumDevices As Byte, ByRef usDevIdList As Integer, _
            ByRef dblRates As Double) As Byte
''''''''''''''''''''
'f_SP_SignedOn = FALSE;





'BOOLEAN EX_Scan_EMF16_Setup(USHORT usDevID, BYTE* bChanCode, UINT uiTimeout);
Declare Function EX_Scan_EMF16_Setup Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByRef bChanCode As Byte, _
                ByVal uiTimeout As Long) As Byte

'BOOLEAN EX_Scan_EMF16_Run(USHORT usDevID);
Declare Function EX_Scan_EMF16_Run Lib "LL_USB2k.DLL" (ByVal usDevId As Integer) As Byte

'BOOLEAN EX_Scan_EMF16_StartDataThread(USHORT usDevID, USHORT usAvg, UINT uiUnused, BOOLEAN fUnused);
Declare Function EX_Scan_EMF16_StartDataThread Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, _
                    ByVal usAvg As Integer, ByVal uiUnused As Long, ByVal fUnused As Byte) As Byte

'BOOLEAN EX_Scan_EMF16_GetTemperature(USHORT usDevID, BYTE bChan, double* dblVoltages, BOOLEAN* pfDataReady, UINT* uiRetCode);
Declare Function EX_Scan_EMF16_GetTemperature Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByVal bChan As Byte, _
                    ByRef dblVoltages As Double, ByRef pfDataRead As Byte, ByRef uiRetCode As Long) As Byte

'BOOLEAN EX_Scan_EMF16_Stop(USHORT usDevID);
Declare Function EX_Scan_EMF16_Stop Lib "LL_USB2k.DLL" (ByVal usDevId As Integer) As Byte

'BOOLEAN EX_Scan_EMF16_EndDataThread(USHORT usDevID);
Declare Function EX_Scan_EMF16_EndDataThread Lib "LL_USB2k.DLL" (ByVal usDevId As Integer) As Byte
Private Sub DoScanAverage()
    If bVoltAvgArrayFirstTimeInFlag = 1 Then 'preload average array
        Dim usCurAvgArrayIndex_LOCAL As Integer
        
        '12-6-16 For usCurAvgArrayIndex_LOCAL = 0 To iScanAvg
        For usCurAvgArrayIndex_LOCAL = 0 To 127 '12-6-16
            dblVoltAvgArray(usCurAvgArrayIndex_LOCAL) = dVoltage(bCurScanDevIndex)
        Next usCurAvgArrayIndex_LOCAL
        
        dblVoltAvgTotal = dVoltage(bCurScanDevIndex) * iScanAvg
        '9-1-15 bVoltAvgArrayFirstTimeInFlag = 0
        
        '9-1-15 need to wait until array is initialized with all points before changing the flag below
        bFirstScanAvgLoadPointCnt = bFirstScanAvgLoadPointCnt - 1
        If bFirstScanAvgLoadPointCnt = 0 Then bVoltAvgArrayFirstTimeInFlag = 0
        usVoltAvgArrayIndex = 0 '12-7-16
        
    End If
    
    dblVoltAvgTotal = dblVoltAvgTotal + dVoltage(bCurScanDevIndex) - dblVoltAvgArray(usVoltAvgArrayIndex)
    dblVoltAvgArray(usVoltAvgArrayIndex) = dVoltage(bCurScanDevIndex)
    dVoltage(bCurScanDevIndex) = dblVoltAvgTotal / iScanAvg
    
    If usVoltAvgArrayIndex = iScanAvg Then usVoltAvgArrayIndex = 0
    usVoltAvgArrayIndex = usVoltAvgArrayIndex + 1
End Sub
Private Sub DoMultiChanScanAverage(ByVal bChan As Byte)

    If bVoltAvgArrayFirstTimeInFlag_MULTI(bChan) = 1 Then 'preload average array
        Dim usCurAvgArrayIndex_LOCAL As Integer
        '12-6-16b For usCurAvgArrayIndex_LOCAL = 0 To (iScanAvg - 1)
        For usCurAvgArrayIndex_LOCAL = 0 To 127
            dblVoltAvgArray_MULTI(bChan, usCurAvgArrayIndex_LOCAL) = dVoltage(0)
        Next usCurAvgArrayIndex_LOCAL
        
        dblVoltAvgTotal_MULTI(bChan) = dVoltage(0) * iScanAvg
        bVoltAvgArrayFirstTimeInFlag_MULTI(bChan) = 0
        sVoltAvgArrayIndex_MULTI(bChan) = 0 '12-7-16b
        GoTo EXIT1
    End If
    
    dblVoltAvgTotal_MULTI(bChan) = (dblVoltAvgTotal_MULTI(bChan) + dVoltage(0)) - dblVoltAvgArray_MULTI(bChan, sVoltAvgArrayIndex_MULTI(bChan))
    dblVoltAvgArray_MULTI(bChan, sVoltAvgArrayIndex_MULTI(bChan)) = dVoltage(0)
    dVoltage(0) = (dblVoltAvgTotal_MULTI(bChan)) / iScanAvg

    sVoltAvgArrayIndex_MULTI(bChan) = sVoltAvgArrayIndex_MULTI(bChan) + 1
    If sVoltAvgArrayIndex_MULTI(bChan) >= iScanAvg Then sVoltAvgArrayIndex_MULTI(bChan) = 0
    
EXIT1:
End Sub

'Private Sub DoMultiChanScanAverage_tried_butNewProblem(ByVal bChan As Byte)
'
'    If bVoltAvgArrayFirstTimeInFlag_MULTI(bChan) = 1 Then 'preload average array
'
''tot = da(n) * a       ' use x as avga pointer
'''''For X = 0 To a - 1
''For X = 0 To iScanAvg - 1
'''''avga(X) = da(n)       ' preload array with data n
''   dblVoltAvgArray_MULTI(bChan, X) = dVoltage(0) ' preload array with first point
''Next X
''X = 0             'initialize avga array ptr
''firsttime = 0     'clear firsttime flag
'        Dim usCurAvgArrayIndex_LOCAL As Integer
'        dblVoltAvgTotal_MULTI(bChan) = dVoltage(0) * iScanAvg
'        For usCurAvgArrayIndex_LOCAL = 0 To (iScanAvg - 1)
'            dblVoltAvgArray_MULTI(bChan, usCurAvgArrayIndex_LOCAL) = dVoltage(0)
'        Next usCurAvgArrayIndex_LOCAL
'        sVoltAvgArrayIndex_MULTI(bChan) = 0
'        bVoltAvgArrayFirstTimeInFlag_MULTI(bChan) = 0
'    End If
'
''tot = tot - avga(X)   ' subtract oldest point from tot
''avga(X) = da(n)       ' update avga with this data point
''tot = tot + avga(X)   ' add this point to total
''X = (X + 1) Mod a     ' increment circ buffer pointer
'    dblVoltAvgTotal_MULTI(bChan) = dblVoltAvgTotal_MULTI(bChan) - dblVoltAvgArray_MULTI(bChan, sVoltAvgArrayIndex_MULTI(bChan))
'    dblVoltAvgArray_MULTI(bChan, sVoltAvgArrayIndex_MULTI(bChan)) = dVoltage(0)
'    dblVoltAvgTotal_MULTI(bChan) = dblVoltAvgTotal_MULTI(bChan) + dblVoltAvgArray_MULTI(bChan, sVoltAvgArrayIndex_MULTI(bChan))
'    sVoltAvgArrayIndex_MULTI(bChan) = (sVoltAvgArrayIndex_MULTI(bChan) + 1) Mod iScanAvg
'
''avg = tot / a
'    dblVoltAvgArray_MULTI(bChan, sVoltAvgArrayIndex_MULTI(bChan)) = dblVoltAvgTotal_MULTI(bChan) / iScanAvg
'
'    dVoltage(0) = (dblVoltAvgTotal_MULTI(bChan)) / iScanAvg
'
'
'    'USE     Debug.Print for console output
'
'
'EXIT1:
'End Sub



''12-7-16 Tom sample code
'Public Sub DoMultiChanScanAverage_TOM_SAMPLE(ByVal bChan As Byte)
'    Dim da(1000)
'
'    Dim a As Integer 'tim - use iScanAvg
'    Dim n As Integer 'tim not use
'    Dim firsttime As Integer 'tim use bVoltAvgArrayFirstTimeInFlag_MULTI(bChan)
'    Dim X As Integer 'tim use this instead of:  sVoltAvgArrayIndex_MULTI(bChan)?
'    Dim Y As Integer 'tim not use
'    Dim avga() As Integer 'tim - use dblVoltAvgArray_MULTI(bChan, usCurAvgArrayIndex_LOCAL)
'    Dim tot As Double 'tim - use dblVoltAvgTotal_MULTI(bChan)
'    Dim avg As Double 'tim just to show test
'
'    For n = 0 To 1000
'        da(n) = 20 + (n Mod 4)
'    Next
'    n = 0
''    Cls         'prefill data array with noisy data
'
'restart1:         'entry point for changing avg
''    Print
''    Print "averaging? ";
'
''    a$ = INPUT$(2)
''    a = Val(a$)
'    a = 8 'tim
''    If a < 1 Then a = 1
''    Print a
'    ReDim avga(a)   '# put this where avg is changed?
'    firsttime = 1    'new avg, set flag
'
'cont:                'next data point
'
'    If firsttime = 1 Then
'        tot = da(n) * a       ' use x as avga pointer
'        'For X = 0 To a - 1
'        For X = 0 To iScanAvg - 1
'           'avga(X) = da(n)       ' preload array with data n
'           dblVoltAvgArray_MULTI(bChan, X) = dVoltage(0) ' preload array with first point
'        Next X
'        X = 0             'initialize avga array ptr
'        firsttime = 0     'clear firsttime flag
'    End If
'
'    tot = tot - avga(X)   ' subtract oldest point from tot
'    avga(X) = da(n)       ' update avga with this data point
'    tot = tot + avga(X)   ' add this point to total
'    X = (X + 1) Mod a     ' increment circ buffer pointer
'
'    avg = tot / a
''    Print "avg "; avg,      'print averaged data point
'    MsgBox "avg: " & avg  'tim
'    For Y = 0 To a - 1
''        Print avga(Y); " ";    'this loop is just to show operation
'        MsgBox avga(Y)  'tim
'    Next Y
''    Print
'
'    n = n + 1               ' simulate next data point
'
''    Print "n for next average, space to continue "
''    a$ = INPUT$(1)
''    If a$ = " " Then GoTo cont
''    If a$ <> Chr$(27) Then GoTo restart1
'    'End
'
'End Sub
'
'Private Sub DoMultiChanScanAverage_priorTo_12_7_16(ByVal bChan As Byte)
'        frmGraph_EMF16.frame5.Visible = True
'
'    If bVoltAvgArrayFirstTimeInFlag_MULTI(bChan) = 1 Then 'preload average array
'        Dim usCurAvgArrayIndex_LOCAL As Integer
'        '12-6-16b For usCurAvgArrayIndex_LOCAL = 0 To (iScanAvg - 1)
'        For usCurAvgArrayIndex_LOCAL = 0 To 127
'            dblVoltAvgArray_MULTI(bChan, usCurAvgArrayIndex_LOCAL) = dVoltage(0)
'        Next usCurAvgArrayIndex_LOCAL
'
'        dblVoltAvgTotal_MULTI(bChan) = dVoltage(0) * iScanAvg
'        bVoltAvgArrayFirstTimeInFlag_MULTI(bChan) = 0
'        GoTo TOM
'        GoTo EXIT1
'    End If
'
'    dblVoltAvgTotal_MULTI(bChan) = (dblVoltAvgTotal_MULTI(bChan) + dVoltage(0)) - dblVoltAvgArray_MULTI(bChan, sVoltAvgArrayIndex_MULTI(bChan))
'    dblVoltAvgArray_MULTI(bChan, sVoltAvgArrayIndex_MULTI(bChan)) = dVoltage(0)
'
'
'    frmGraph_EMF16.frame5.Visible = True
'
'    If bChan = 1 Then
'        frmGraph_EMF16.l10.Caption = dVoltage(0)
'    End If
'
'
'
'    dVoltage(0) = (dblVoltAvgTotal_MULTI(bChan)) / iScanAvg
'
'    sVoltAvgArrayIndex_MULTI(bChan) = sVoltAvgArrayIndex_MULTI(bChan) + 1
'    If sVoltAvgArrayIndex_MULTI(bChan) >= iScanAvg Then sVoltAvgArrayIndex_MULTI(bChan) = 0
'
'TOM:
'    If bChan = 1 Then
'        frmGraph_EMF16.l1.Caption = dblVoltAvgArray_MULTI(bChan, 0)
'        frmGraph_EMF16.l2.Caption = dblVoltAvgArray_MULTI(bChan, 1)
'        frmGraph_EMF16.l3.Caption = dblVoltAvgArray_MULTI(bChan, 2)
'        frmGraph_EMF16.l4.Caption = dblVoltAvgArray_MULTI(bChan, 3)
'        frmGraph_EMF16.l5.Caption = dblVoltAvgArray_MULTI(bChan, 4)
'        frmGraph_EMF16.l6.Caption = dblVoltAvgArray_MULTI(bChan, 5)
'        frmGraph_EMF16.l7.Caption = dblVoltAvgArray_MULTI(bChan, 6)
'        frmGraph_EMF16.l8.Caption = dblVoltAvgArray_MULTI(bChan, 7)
'        frmGraph_EMF16.l9.Caption = sVoltAvgArrayIndex_MULTI(bChan)
'        'frmGraph_EMF16.l9.Caption = iVoltAvgArrayIndex_MULTI
'        frmGraph_EMF16.l11.Caption = dVoltage(0)
'        frmGraph_EMF16.l11.Caption = dVoltage(0)
'    End If
'
'
'EXIT1:
'End Sub
'
''############################
''############################
''############################
''12-7-16 Tom sample code SAVE
'Public Sub DoMultiChanScanAverage_save(ByVal bChan As Byte)
'    Dim da(1000)
'
'    Dim a As Integer 'tim
'    Dim n As Integer 'tim
'    Dim firsttime As Integer 'tim use bVoltAvgArrayFirstTimeInFlag_MULTI(bChan)
'    Dim X As Integer 'tim
'    Dim Y As Integer 'tim
'    Dim avga() As Integer 'tim - use dblVoltAvgArray_MULTI(bChan, usCurAvgArrayIndex_LOCAL)
'    Dim tot As Double 'tim - use dblVoltAvgTotal_MULTI(bChan)
'    Dim avg As Double 'tim - use iScanAvg
'
'    For n = 0 To 1000
'        da(n) = 20 + (n Mod 4)
'    Next
'    n = 0
''    Cls         'prefill data array with noisy data
'
'restart1:         'entry point for changing avg
''    Print
''    Print "averaging? ";
'
''    a$ = INPUT$(2)
''    a = Val(a$)
'    a = 8 'tim
''    If a < 1 Then a = 1
''    Print a
'    ReDim avga(a)   '# put this where avg is changed?
'    firsttime = 1    'new avg, set flag
'
'cont:                'next data point
'
'    If firsttime = 1 Then
'        tot = da(n) * a       ' use x as avga pointer
'        For X = 0 To a - 1
'           avga(X) = da(n)       ' preload array with data n
'        Next X
'        X = 0             'initialize avga array ptr
'        firsttime = 0     'clear firsttime flag
'    End If
'
'    tot = tot - avga(X)   ' subtract oldest point from tot
'    avga(X) = da(n)       ' update avga with this data point
'    tot = tot + avga(X)   ' add this point to total
'    X = (X + 1) Mod a     ' increment circ buffer pointer
'
'    avg = tot / a
''    Print "avg "; avg,      'print averaged data point
'    MsgBox "avg: " & avg  'tim
'    For Y = 0 To a - 1
''        Print avga(Y); " ";    'this loop is just to show operation
'        MsgBox avga(Y)  'tim
'    Next Y
''    Print
'
'    n = n + 1               ' simulate next data point
'
''    Print "n for next average, space to continue "
''    a$ = INPUT$(1)
''    If a$ = " " Then GoTo cont
''    If a$ <> Chr$(27) Then GoTo restart1
'    'End
'
'End Sub



'4-23-14 note that this has been modified (following commented) as of 4-24-14 to support multiple
' devices and no longer use  the thermscan DLL functions
'  graphing type code without the multiplexer
Public Function Scan_EMF16_Setup(usDevId As Integer) As Byte
    If frmGraph_EMF16.chkSimplifiedMode.Value = vbChecked Then '4-25-14
         '5-5-14 Scan_EMF16_Setup = Scan_EMF16_Setup_Simp(usDevId) '4-25-14
         Scan_EMF16_Setup = Scan_EMF16_Setup_Simp(usDevId) '5-5-14
         Exit Function '5-5-14
    End If '4-25-14
    
    Dim bRetVal As Byte

    Dim i As Byte
    Dim uiTimeout As Long: uiTimeout = 5000

    '5-10-11 bChanCode(0) = &H4: bChanCode(1) = &HF0: bChanCode(2) = &HF0: bChanCode(3) = &HF0: bChanCode(4) = &HF0: bChanCode(5) = &HF0
    'fixed this: the DLL is looking for 0xF0 as non active channel, while this code seems to be using decimal 16 as inactive sub channel
    For i = 0 To 5
        bChanCode(i) = m30x.chan(i)
        If m30x.chan(i) = 16 Then bChanCode(i) = &HF0
    Next

    bRetVal = EX_Scan_EMF16_Setup(m30x.usDevId, bChanCode(0), uiTimeout)

    Scan_EMF16_Setup = bRetVal
End Function
'following form of this function is new as of 4-24-14 (old form for use with thermscan in DLL above
Public Function Scan_EMF16_Setup_Simp(usDevId As Integer) As Byte
    Dim bRetVal As Byte

'Declare Function EX_SetScanType Lib "LL_USB2k.DLL" (ByVal usDevId As Integer, ByVal bScanType As Double) As Byte
'1   SINGLE_CHAN_SCAN
'2   MULTI_CHAN_SCAN
'3   MULTI_CHAN_CAL_SCAN
'4   SINGLE_CHAN_DIGIN_SCAN
'5   MULTI_CHAN_DIGIN_SCAN
'6   MULTI_CHAN_CAL_DIGIN_SCAN
    '5-5-14 bRetVal = EX_SetScanType(usDevId, MULTI_CHAN_DIGIN_SCAN)
    'bRetVal = EX_SetScanType(usDevId, MULTI_CHAN_SCAN)
    'bRetVal = EX_SetScanType(usDevId, MULTI_CHAN_CAL_SCAN)
    '6-10-14 bRetval = EX_SetScanType(usDevId, SINGLE_CHAN_SCAN)
    bRetVal = EX_SetScanType(usDevId, m30x.tScan) '6-10-14

    If bRetVal = 0 Then
        If frmGraph_EMF16.txtMsgDisplay.Visible Then
            frmGraph_EMF16.txtMsgDisplay.Text = frmGraph_EMF16.txtMsgDisplay.Text & vbCrLf & "failed call to EX_SetScanType for: " & usDevId & vbCrLf
        End If
        Scan_EMF16_Setup_Simp = 0
        Exit Function
    End If

'10-21-15b    bRetval = EX_SetMultiChanScanChans(usDevId, m30x.numChannels)
    
    '10-21-15b START ###################
    If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
        bRetVal = EX_SetMultiChanScanChans(usDevId, m30x.numChannels - 1) '10-21-15b
    Else
        bRetVal = EX_SetMultiChanScanChans(usDevId, m30x.numChannels)
    End If
    '10-21-15b END #####################
    
    
    
    If bRetVal = 0 Then
        If frmGraph_EMF16.txtMsgDisplay.Visible Then
            frmGraph_EMF16.txtMsgDisplay.Text = frmGraph_EMF16.txtMsgDisplay.Text & vbCrLf & "failed call to EX_SetMultiChanScanChans for: " & usDevId & vbCrLf
        End If
        Scan_EMF16_Setup_Simp = 0
        Exit Function
    End If
    
'Public Const SCAN_USE_DATA_LOG_FILE = 1
'Public Const SCAN_USE_DATA_ARRAY = 2
'Public Const SCAN_STOP_ON_DATA_ARRAY_WRAP = 4
'Public Const SCAN_LIMIT_LOG_FILE_SIZE = 8
    If doDbgDLL Then '5-8-14
        bRetVal = EX_SetDataLogOptions(usDevId, SCAN_USE_DATA_ARRAY Or SCAN_USE_DATA_LOG_FILE, 0, 0)
    Else
        bRetVal = EX_SetDataLogOptions(usDevId, SCAN_USE_DATA_ARRAY, 0, 0)
    End If
    
    Scan_EMF16_Setup_Simp = 1
End Function
'4-23-14 note that this has been modified (following commented) as of 4-24-14 to support multiple
' devices and no longer use  the thermscan DLL functions
Public Function Scan_EMF16_Run(usDevId As Integer) As Byte
    If frmGraph_EMF16.chkSimplifiedMode.Value = vbChecked Then '4-25-14
        Scan_EMF16_Run = Scan_EMF16_Run_Simp(usDevId) '4-25-14
        Exit Function
    End If '4-25-14

    Dim bRetVal As Byte
    bRetVal = EX_Scan_EMF16_Run(m30x.usDevId)
    Scan_EMF16_Run = bRetVal
End Function
Public Function Scan_EMF16_Run_Simp(usDevId As Integer) As Byte
    Dim bRetVal As Byte
    bRetVal = EX_Run(usDevId)
    If bRetVal = 0 Then
        If frmGraph_EMF16.txtMsgDisplay.Visible Then
            frmGraph_EMF16.txtMsgDisplay.Text = frmGraph_EMF16.txtMsgDisplay.Text & vbCrLf & "failed call to EX_Run for: " & usDevId & vbCrLf
        End If
        Scan_EMF16_Run_Simp = 0
        Exit Function
    End If
    Scan_EMF16_Run_Simp = 1
End Function
'end of new copy of function on 4-24-14
Public Function Scan_EMF16_StartDataThread() As Byte
    Dim fUnused, bRetVal As Byte: Dim uiUnused As Long
    Dim usAvg As Integer
    
    usAvg = 4
    bRetVal = EX_Scan_EMF16_StartDataThread(m30x.usDevId, usAvg, uiUnused, fUnused)
    Scan_EMF16_StartDataThread = bRetVal
End Function
'7-30-15 Public Function Scan_EMF16_GetTemperature(ByRef pfDataReady As Byte) As Byte
Public Function Scan_EMF16_GetTemperature(ByRef pfDataReady As Byte) As Integer
    If frmGraph_EMF16.chkSimplifiedMode.Value = vbChecked Then
        Scan_EMF16_GetTemperature = Scan_EMF16_GetTemperature_simp(pfDataReady)
        Exit Function
    End If
    
    Dim bChan, bRetVal As Byte: Dim uiRetCode As Long
    Dim dVoltages(16) As Double
    uiRetCode = 0
    bChan = 0
    Const SCAN_STILL_RUNNING = 1
    Const SCAN_NOT_RUNNING = 0
    Const DEVICE_NOT_FOUND = &H1
    Const THREAD_NOT_ACTIVE = &H2
    Const DATA_NOT_READY = &H4
    Const OTHER_ERROR = &H8
    Const NON_DATA_READY_BITS = &HB '1011
    Dim fGotData As Boolean: fGotData = False

    Dim bChanIndexValidChk As Byte: Dim bSubChanIndexValidChk As Byte

    Dim bValidVoltChan(6) As Byte
    For bChanIndexValidChk = 0 To 5
        For bSubChanIndexValidChk = 0 To 15
            If dVoltageValid(bChanIndexValidChk, bSubChanIndexValidChk) = 1 Then
                bValidVoltChan(bChanIndexValidChk) = 1
                GoTo doNextNow
            End If
        Next
doNextNow:
    Next

    For bChanIndexValidChk = 0 To 5
        pfDataReady = False  '9-26-11
        If bValidVoltChan(bChanIndexValidChk) = 1 Then
            bRetVal = EX_Scan_EMF16_GetTemperature(m30x.usDevId, bChanIndexValidChk, dVoltages(0), pfDataReady, uiRetCode)

            If bRetVal = 0 Then
                'only concerned about error conditions. DATA_NOT_READY is not an error at all
                If uiRetCode And NON_DATA_READY_BITS = NON_DATA_READY_BITS Then
                    Scan_EMF16_GetTemperature = SCAN_NOT_RUNNING
                    Exit Function
                End If
            End If

            If pfDataReady = 1 Then
                fGotData = 1 'used to determing if log file needs written


                'log file prints each channel even without text form being displayed
                Dim bTextScrnEntrySub As Byte: Dim bVoltageArraySubIndex As Byte: bVoltageArraySubIndex = 0
                If bChanIndexValidChk = 0 Then
                    For bTextScrnEntrySub = 0 To 15
                        If dVoltageValid(bChanIndexValidChk, bTextScrnEntrySub) = 1 Then
                            If frmGraph_EMF16.frameTextScan.Visible = True Then
                                If dVoltage_EMF16(bChanIndexValidChk, bSubChanIndexValidChk) < 0 Then 'Just used to improve display of negative
                                    frmGraph_EMF16.txtSub0Volts(bTextScrnEntrySub) = Format$(str(Abs(dVoltages(bVoltageArraySubIndex))), "-#.000000")
                                Else
                                    frmGraph_EMF16.txtSub0Volts(bTextScrnEntrySub) = Format$(str(dVoltages(bVoltageArraySubIndex)), " #.000000")
                                End If
                            End If
                            dVoltage_EMF16_LOG(bChanIndexValidChk, bTextScrnEntrySub) = dVoltages(bVoltageArraySubIndex)
                            Debug.Print "("; bChanIndexValidChk; ", "; bTextScrnEntrySub; "): "; Format$(str(dVoltages(bVoltageArraySubIndex)))
                            bVoltageArraySubIndex = bVoltageArraySubIndex + 1
                        End If
                    Next
                End If
                If bChanIndexValidChk = 1 Then
                    For bTextScrnEntrySub = 0 To 15
                        If dVoltageValid(bChanIndexValidChk, bTextScrnEntrySub) = 1 Then
                            If frmGraph_EMF16.frameTextScan.Visible = True Then
                                If dVoltage_EMF16(bChanIndexValidChk, bSubChanIndexValidChk) < 0 Then 'Just used to improve display of negative
                                    frmGraph_EMF16.txtSub1Volts(bTextScrnEntrySub) = Format$(str(Abs(dVoltages(bVoltageArraySubIndex))), "-#.000000")
                                Else
                                    frmGraph_EMF16.txtSub1Volts(bTextScrnEntrySub) = Format$(str(dVoltages(bVoltageArraySubIndex)), " #.000000")
                                End If
                            End If
                            dVoltage_EMF16_LOG(bChanIndexValidChk, bTextScrnEntrySub) = dVoltages(bVoltageArraySubIndex)
                            Debug.Print "("; bChanIndexValidChk; ", "; bTextScrnEntrySub; "): "; Format$(str(dVoltages(bVoltageArraySubIndex)))
                            bVoltageArraySubIndex = bVoltageArraySubIndex + 1
                        End If
                    Next
                End If
                If bChanIndexValidChk = 2 Then
                    For bTextScrnEntrySub = 0 To 15
                        If dVoltageValid(bChanIndexValidChk, bTextScrnEntrySub) = 1 Then
                            If frmGraph_EMF16.frameTextScan.Visible = True Then
                                If dVoltage_EMF16(bChanIndexValidChk, bSubChanIndexValidChk) < 0 Then 'Just used to improve display of negative
                                    frmGraph_EMF16.txtSub2Volts(bTextScrnEntrySub) = Format$(str(Abs(dVoltages(bVoltageArraySubIndex))), "-#.000000")
                                Else
                                    frmGraph_EMF16.txtSub2Volts(bTextScrnEntrySub) = Format$(str(dVoltages(bVoltageArraySubIndex)), " #.000000")
                                End If
                            End If
                            dVoltage_EMF16_LOG(bChanIndexValidChk, bTextScrnEntrySub) = dVoltages(bVoltageArraySubIndex)
                            bVoltageArraySubIndex = bVoltageArraySubIndex + 1
                        End If
                    Next
                End If
                If bChanIndexValidChk = 3 Then
                    For bTextScrnEntrySub = 0 To 15
                        If dVoltageValid(bChanIndexValidChk, bTextScrnEntrySub) = 1 Then
                            If frmGraph_EMF16.frameTextScan.Visible = True Then
                                If dVoltage_EMF16(bChanIndexValidChk, bSubChanIndexValidChk) < 0 Then 'Just used to improve display of negative
                                    frmGraph_EMF16.txtSub3Volts(bTextScrnEntrySub) = Format$(str(Abs(dVoltages(bVoltageArraySubIndex))), "-#.000000")
                                Else
                                    frmGraph_EMF16.txtSub3Volts(bTextScrnEntrySub) = Format$(str(dVoltages(bVoltageArraySubIndex)), " #.000000")
                                End If
                            End If
                            dVoltage_EMF16_LOG(bChanIndexValidChk, bTextScrnEntrySub) = dVoltages(bVoltageArraySubIndex)
                            bVoltageArraySubIndex = bVoltageArraySubIndex + 1
                        End If
                    Next
                End If
                If bChanIndexValidChk = 4 Then
                    For bTextScrnEntrySub = 0 To 15
                        If dVoltageValid(bChanIndexValidChk, bTextScrnEntrySub) = 1 Then
                            If frmGraph_EMF16.frameTextScan.Visible = True Then
                                If dVoltage_EMF16(bChanIndexValidChk, bSubChanIndexValidChk) < 0 Then 'Just used to improve display of negative
                                    frmGraph_EMF16.txtSub4Volts(bTextScrnEntrySub) = Format$(str(Abs(dVoltages(bVoltageArraySubIndex))), "-#.000000")
                                Else
                                    frmGraph_EMF16.txtSub4Volts(bTextScrnEntrySub) = Format$(str(dVoltages(bVoltageArraySubIndex)), " #.000000")
                                End If
                            End If
                            dVoltage_EMF16_LOG(bChanIndexValidChk, bTextScrnEntrySub) = dVoltages(bVoltageArraySubIndex)
                            bVoltageArraySubIndex = bVoltageArraySubIndex + 1
                        End If
                    Next
                End If
                If bChanIndexValidChk = 5 Then
                    For bTextScrnEntrySub = 0 To 15
                        If dVoltageValid(bChanIndexValidChk, bTextScrnEntrySub) = 1 Then
                            If frmGraph_EMF16.frameTextScan.Visible = True Then
                                If dVoltage_EMF16(bChanIndexValidChk, bSubChanIndexValidChk) < 0 Then 'Just used to improve display of negative
                                    frmGraph_EMF16.txtSub5Volts(bTextScrnEntrySub) = Format$(str(Abs(dVoltages(bVoltageArraySubIndex))), "-#.000000")
                                Else
                                    frmGraph_EMF16.txtSub5Volts(bTextScrnEntrySub) = Format$(str(dVoltages(bVoltageArraySubIndex)), " #.000000")
                                End If
                            End If
                            dVoltage_EMF16_LOG(bChanIndexValidChk, bTextScrnEntrySub) = dVoltages(bVoltageArraySubIndex)
                            bVoltageArraySubIndex = bVoltageArraySubIndex + 1
                        End If
                    Next
                End If
                'End If
                'for graphic display
                If frmGraph_EMF16.frameTextScan.Visible = False Then

                    If bChanIndexValidChk = bCurMainChan_Global Then
                        Dim bFirstSubFind, bMainChan, bSubChanIndex As Byte: bMainChan = 0
                        Dim fAnySubFound As Boolean: fAnySubFound = False
                        For bFirstSubFind = 0 To 15
                            If frmGraph_EMF16.btnChans(bFirstSubFind).BackColor <> &H8000000F Then
                                fAnySubFound = True
                                Exit For
                            End If
                        Next bFirstSubFind

                        If fAnySubFound Then
                            For bSubChanIndex = 0 To 15
                                If dVoltageValid(bMainChan, bSubChanIndex) = 1 Then
                                    dVoltage_EMF16(bMainChan, bSubChanIndex) = dVoltages(bSubChanIndex)
                                End If
                            Next bSubChanIndex
                        End If

                        Dim iRetVal As Integer
                        iRetVal = Plot(0)
                        
                    End If
                End If
                GoTo NextChan
            End If
        End If

NextChan:

dblScanCntTemp = CDbl(scanCnt) * m30x.scanInterval
'dblScanCntTemp = CDbl(scanCnt - 1) * (1# / CDbl(frmGraph_EMF16.SecPerScrn.Text)) '7-28-15b

    Next

    frmGraph_EMF16.txtScanCnt.Text = Format$(scanCnt, "00000000")

    If fGotData Then
            If scanCnt = 0 Then frmGraphTextVolts.BtnClear_Click '5-12-14
            scanCnt = scanCnt + 1
            '8-10-15 If frmGraph_EMF16.CheckLogData.Value = vbChecked Then
                 fRetVal = WriteLogFileSubChanOnly(bCurChan) 'channel is ignored
            '8-10-15 End If
    End If

    Scan_EMF16_GetTemperature = SCAN_STILL_RUNNING
End Function
'4-24-14 START NEW for EMF16 without DLL thermscan functions
'Same name as above with _simp added to end of function name
Public Function Scan_EMF16_GetTemperature_simp(ByRef pfDataReady As Byte) As Long
    Dim bChan, bRetVal As Byte: Dim uiRetCode As Long
    Dim dVoltages(16) As Double
    uiRetCode = 0
    bChan = 0
    
    Dim usDevId As Integer: usDevId = m30x.usDevId
    Dim pbDiginBuff As Byte
    Dim uiNumScansToReturn As Long
    Dim fGetAllRequested As Byte: fGetAllRequested = 1
    Dim uiNumScansReturned As Long
    Dim uiNumScansRemainingInBuff As Long
    Dim fStillScanning As Byte
    Dim uiTotalBuffSize As Long
    Dim uiErrCode As Long
    
    Dim fGotData As Boolean: fGotData = False
    
    Dim bChanIndexValidChk As Byte: Dim bSubChanIndexValidChk As Byte
    
    Dim bIndex As Byte
    Dim dblDataBuff() As Double
    
    '4-7-17 TIM NOTE: bRetVal is not checked, nor are all flags such as buffer wrap.
    bRetVal = EX_CheckScanStatus(usDevId, uiNumScansRemainingInBuff, fStillScanning, uiErrCode)
    uiNumScansToReturn = uiNumScansRemainingInBuff
    
    If uiNumScansToReturn > 254 Then uiNumScansToReturn = 254  '12-8-16b
    
    Dim uiVal As Integer: uiVal = HALTED
    
    '4-7-17 wasn't checking this return code before which whould indicate no longer scanning
    If (bRetVal = 0) Then
        Scan_EMF16_GetTemperature_simp = HALTED
        frmGraph_EMF16.txtGraphScanStatus.Text = " scan HALTED"  '12-8-16b
        frmGraph_EMF16.FrameReadyColor.BackColor = &HFF&  '12-8-16b
        frmGraph_EMF16.txtGraphScanStatus.ForeColor = &HFF&  '12-9-16
        Exit Function
    End If
    
    
    If (uiErrCode And DISCONNECT) = DISCONNECT Then
        Scan_EMF16_GetTemperature_simp = DISCONNECT
        frmGraph_EMF16.txtGraphScanStatus.Text = " disconnected"  '12-8-16b
        frmGraph_EMF16.FrameReadyColor.BackColor = &HFF&  '12-8-16b
        frmGraph_EMF16.txtGraphScanStatus.ForeColor = &HFF&  '12-9-16
        Exit Function
    End If
    
    uiVal = uiErrCode And HALTED
    If (uiErrCode And HALTED) = HALTED Then
        Scan_EMF16_GetTemperature_simp = HALTED
        frmGraph_EMF16.txtGraphScanStatus.Text = " scan HALTED"  '12-8-16b
        frmGraph_EMF16.FrameReadyColor.BackColor = &HFF&  '12-8-16b
        frmGraph_EMF16.txtGraphScanStatus.ForeColor = &HFF&  '12-9-16
        
        '2-14-17 start
'        frmGraph_EMF16.frame_pleaseWait.Visible = True: frmGraph_EMF16.frame_pleaseWait.Left = 0
'        DoEvents
'        Sleep (3000)
'        frmGraph_EMF16.frame_pleaseWait.Visible = False
        '2-14-17 end
        
        Exit Function
    End If
    
'Form_Click()
    'Call frmGraph_EMF16.Command2.Click(0)
     'frmGraph_EMF16.Command2_Click
     'frmGraph_EMF16.btnFixThis_Click
     'btnFixThis_Click
     
    'frmGraphTextVolts.BtnClear_Click
     
    
    uiTotalBuffSize = uiNumScansToReturn * m30x.numChannels
    
    ReDim dblDataBuff(uiTotalBuffSize)
    
    Dim bIndex1 As Byte, bIndex2 As Byte

    bRetVal = EX_GetScanDataDbl(usDevId, dblDataBuff(0), uiNumScansToReturn, fGetAllRequested, _
        uiNumScansReturned, uiNumScansRemainingInBuff, fStillScanning, uiTotalBuffSize, uiErrCode)
        
    '7-29-15h check again after getting the scan data since it could have halted since getting the status
    If (uiErrCode And HALTED) = HALTED Then
        '12-8-16b Scan_EMF16_GetTemperature_simp = SCAN_STILL_RUNNING
        Scan_EMF16_GetTemperature_simp = HALTED  '12-8-16b
        frmGraph_EMF16.txtGraphScanStatus.Text = " scan HALTED"  '12-8-16b
        frmGraph_EMF16.FrameReadyColor.BackColor = &HFF&  '12-8-16b
        frmGraph_EMF16.txtGraphScanStatus.ForeColor = &HFF&  '12-9-16
        
        '2-14-17 start
'        frmGraph_EMF16.frame_pleaseWait.Visible = True: frmGraph_EMF16.frame_pleaseWait.Left = 0
'        DoEvents
'        Sleep (3000)
'        frmGraph_EMF16.frame_pleaseWait.Visible = False
        '2-14-17 end
        
        Exit Function
    End If
        
        
    'NOTE: 'NO_DATA (below) just means still scanning but no data so if function returns 0 and that
    ' flag isn't set, then other error flags are set so return those when this function returns. Note
    ' that in this case, pfStillScanning would also be set to zero
    If (bRetVal = 0) And (uiErrCode And NO_DATA = 0) Then
        Scan_EMF16_GetTemperature_simp = uiErrCode
        Exit Function
    End If
    
    If uiErrCode And NO_DATA = NO_DATA Then
        Scan_EMF16_GetTemperature_simp = SCAN_STILL_RUNNING
        Exit Function
    End If
    
    If uiNumScansReturned = 0 Then
        Scan_EMF16_GetTemperature_simp = SCAN_STILL_RUNNING
        Exit Function
    End If
        
    If pfDataReady = 1 Then
        fGotData = 1 'used to determing if log file needs written
    End If
    Dim bTempIndex As Byte
    Dim iScanIndex As Integer: iScanIndex = 0
    
    Dim numChanLocal As Byte
    numChanLocal = m30x.numChannels
'1   SINGLE_CHAN_SCAN
'2   MULTI_CHAN_SCAN
'3   MULTI_CHAN_CAL_SCAN
'4   SINGLE_CHAN_DIGIN_SCAN
'5   MULTI_CHAN_DIGIN_SCAN
'6   MULTI_CHAN_CAL_DIGIN_SCAN

    Dim fRecordOffsetStartFirstScan As Boolean: fRecordOffsetStartFirstScan = False
    If fRecordOffsetsNow Then
        fRecordOffsetStartFirstScan = True
        fRecordOffsetsNow = False
    End If


    '4-7-17 TIM NOTE: this is the ONLY place that can continue to plot data after the stop button is pressed
    '  since the scan can appear to stop, but doesn't actually return from it's loop until this returns.

    If (m30x.tScan = SINGLE_CHAN_SCAN) Or (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Then
        numChanLocal = 0
        For bIndex = 0 To 6  '5-11-14c
            If frmGraph_EMF16.btnChans(bIndex).BackColor <> &H8000000F Then
                numChanLocal = bIndex
            End If
        Next
        
        '4-7-17 TIM NOTE: when plot stops, we are NOT doing this so uiNumScansToReturn = 0
        For iScanIndex = 0 To uiNumScansToReturn - 1
            '###############################
            '4-7-17 START NEW ##############
            If fEMF16_IsRunning = False Then
                bRetVal = EX_CheckScanStatus(usDevId, uiNumScansRemainingInBuff, fStillScanning, uiErrCode)
                If (uiErrCode And DISCONNECT) = DISCONNECT Then
                    Scan_EMF16_GetTemperature_simp = DISCONNECT
                    frmGraph_EMF16.txtGraphScanStatus.Text = " disconnected"  '12-8-16b
                    frmGraph_EMF16.FrameReadyColor.BackColor = &HFF&  '12-8-16b
                    frmGraph_EMF16.txtGraphScanStatus.ForeColor = &HFF&  '12-9-16
                    Exit Function
                End If
                If (uiErrCode And HALTED) = HALTED Then
                    Scan_EMF16_GetTemperature_simp = HALTED
                    frmGraph_EMF16.txtGraphScanStatus.Text = " scan HALTED"  '12-8-16b
                    frmGraph_EMF16.FrameReadyColor.BackColor = &HFF&  '12-8-16b
                    frmGraph_EMF16.txtGraphScanStatus.ForeColor = &HFF&  '12-9-16
                    Exit Function
                End If
                If (bRetVal = 0) Then
                    Scan_EMF16_GetTemperature_simp = HALTED
                    frmGraph_EMF16.txtGraphScanStatus.Text = " scan HALTED"  '12-8-16b
                    frmGraph_EMF16.FrameReadyColor.BackColor = &HFF&  '12-8-16b
                    frmGraph_EMF16.txtGraphScanStatus.ForeColor = &HFF&  '12-9-16
                    Exit Function
                End If
                Scan_EMF16_GetTemperature_simp = SCAN_STILL_RUNNING
                Exit Function
                'the scan loop has exited, but endscan hasn't been called (waiting for this procedure to return,
                ' so there may still be data to take but since we no longer check buffer wrap flags, and we don't
                ' empty the buffer in the DLL, just return when the loop that called this procedure has exited.
            End If
            '4-7-17 END NEW ################
            '###############################
       
            If iScanAvg > 0 Then
                dVoltage(0) = dblDataBuff(iScanIndex)
                DoScanAverage
                dblDataBuff(iScanIndex) = dVoltage(0)
            End If
            
            If bUseOffsetVoltages = True Then
                dblDataBuff(iScanIndex) = dblDataBuff(iScanIndex) - dblOffsetVoltages(0, numChanLocal)
            End If

            If fRecordOffsetStartFirstScan = True Then
                Dim fRetVal As Boolean
                dblOffsetVoltages(0, numChanLocal) = dblDataBuff(iScanIndex)
                '11-30-16 fRetVal = WriteIniFileSpecs_CHoffsets_CurChan
                fRetVal = WriteAppDirOffsetFile  '11-30-16
                
            End If
            
            If frmGraph_EMF16.frameTextScan.Visible = True Then
                If numChanLocal = 0 Then
                    If dblDataBuff(iScanIndex) < 0 Then
                        frmGraph_EMF16.txtSub0Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub0Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), " #.000000")
                    End If
                End If
                If numChanLocal = 1 Then
                    If dblDataBuff(iScanIndex) < 0 Then
                        frmGraph_EMF16.txtSub1Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub1Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), " #.000000")
                    End If
                End If
                If numChanLocal = 2 Then
                    If dblDataBuff(iScanIndex) < 0 Then
                        frmGraph_EMF16.txtSub2Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub2Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), " #.000000")
                    End If
                End If
                If numChanLocal = 3 Then
                    If dblDataBuff(iScanIndex) < 0 Then
                        frmGraph_EMF16.txtSub3Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub3Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), " #.000000")
                    End If
                End If
                If numChanLocal = 4 Then
                    If dblDataBuff(iScanIndex) < 0 Then
                        frmGraph_EMF16.txtSub4Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub4Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), " #.000000")
                    End If
                End If
                If numChanLocal = 5 Then  '5-14-14
                    If dblDataBuff(iScanIndex) < 0 Then
                        frmGraph_EMF16.txtSub5Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub5Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex))), " #.000000")
                    End If
                End If
            Else
            
            
            
                dVoltage_EMF16(0, numChanLocal) = dblDataBuff(iScanIndex)
                
'If (m30x.tScan = SINGLE_CHAN_SCAN) Or (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Then numChanLocal = 0
                
                dVoltageValid(0, numChanLocal) = 1
                iRetVal = Plot(0) 'alwasy 0, bDisplayChan is the actual channel for display boxes
            End If
            
            scanCnt = scanCnt + 1
            
            frmGraph_EMF16.txtScanCnt.Text = Format$(scanCnt, "00000000")

            dblScanCntTemp = CDbl(scanCnt + 1) * m30x.scanInterval
'dblScanCntTemp = CDbl(scanCnt - 1) * (1# / CDbl(frmGraph_EMF16.SecPerScrn.Text)) '7-28-15b
            frmGraph_EMF16.txtElapsedTime.Text = Format$(dblScanCntTemp, " #####") '5-15-14
            
            frmGraph_EMF16.txtScans.Text = scanCnt '5-13-14
'2-20-18            frmGraph_EMF16.txtBuff.Text = uiNumScansRemainingInBuff '5-13-14
            dVoltage_EMF16_LOG(numChanLocal, 0) = dblDataBuff(iScanIndex) '5-13-14
            '8-10-15 If frmGraph_EMF16.CheckLogData.Value = vbChecked Then
                 fRetVal = WriteLogFileSubChanOnly(0) 'channel is ignored
            '8-10-15 End If
        Next
        
        ' this needs to be after first plotting of the offsetted channels
        If fRecordOffsetStartFirstScan = True Then
            frmGraphTextVolts.BtnClear_Click
            fRecordOffsetStartFirstScan = False
        Else
            If fFirstScan = True Then
                fFirstScan = False
            End If
        End If
        GoTo DONE_VOLTAGES
    End If
    For bIndex1 = 0 To 6
        For bIndex2 = 0 To 16
            dVoltageValid_EMF16(bIndex1, bIndex2) = 0
        Next
    Next
        
    Dim bScanIndex As Byte: bScanIndex = 0
    
    

        
    '2-6-15 For iScanIndex = 0 To (uiNumScansToReturn * m30x.numChannels) Step m30x.numChannels
    
'######################################################
'10-20-15 Need to get cal scan data if cal-scan enabled.
'######################################################

'10-20-15 START #############
'no subtract saved offsets from offset channel
Dim dblCalScanOffsetVolts As Double
dblCalScanOffsetVolts = 0  'will always subtract this from scans just to make it easier
Dim isCalScanChanCnt As Byte

If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
    isCalScanChanCnt = 1
    calScanOffsetVal_global = dblDataBuff(m30x.numChannels - 1)
    'frmGraph_EMF16.txtChan7.Text = Format$(str(Abs(calScanOffsetVal_global)), "-#.000000")
End If
'10-20-15 END ###############


'10-20-15    For iScanIndex = 0 To (uiNumScansReturned * m30x.numChannels) Step m30x.numChannels '2-6-15
'10-20-15        For bIndex = 0 To m30x.numChannels - 1
            
            
'10-21-15b
    For iScanIndex = 0 To (uiNumScansReturned * m30x.numChannels) Step m30x.numChannels '2-6-15
        For bIndex = 0 To m30x.numChannels - 1
        
'10-21-15b
'frmGraph_EMF16.txtScanCntTemp.Text = iScanIndex & ", " & bIndex & ", " & iScanIndex + bIndex & ", " & uiNumScansReturned * m30x.numChannels
            

            If frmGraph_EMF16.frameTextScan.Visible = True Then
            
            
                '10-20-15 START #############
                'no subtract saved offsets from offset channel
                If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
                    If bIndex = m30x.numChannels - 1 Then
                        calScanOffsetVal_global = dblDataBuff(iScanIndex + bIndex)
                        'frmGraph_EMF16.txtChan7.Text = Format$(str(Abs(calScanOffsetVal_global)), "-#.000000")
                        GoTo DO_NEXT '10-21-15
                    End If
                End If
                '10-20-15 END ###############
            
            
                If bUseOffsetVoltages = True Then
                    dblDataBuff(iScanIndex + bIndex) = dblDataBuff(iScanIndex + bIndex) - dblOffsetVoltages(0, bIndex)
                End If
                        
'SKIP_DO_OFFSET:
                        
                If bIndex = 0 Then
                    If dblDataBuff(iScanIndex + bIndex) < 0 Then
                        frmGraph_EMF16.txtSub0Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global)), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub0Volts(0) = Format$(str(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global), " #.000000")
                    End If
                End If
                
                If bIndex = 1 Then
                    If dblDataBuff(iScanIndex + bIndex) < 0 Then
                        frmGraph_EMF16.txtSub1Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global)), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub1Volts(0) = Format$(str(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global), " #.000000")
                    End If
                End If
                
                If bIndex = 2 Then
                    If dblDataBuff(iScanIndex + bIndex) < 0 Then
                        frmGraph_EMF16.txtSub2Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global)), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub2Volts(0) = Format$(str(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global), " #.000000")
                    End If
                End If
                
                If bIndex = 3 Then
                    If dblDataBuff(iScanIndex + bIndex) < 0 Then
                        frmGraph_EMF16.txtSub3Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global)), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub3Volts(0) = Format$(str(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global), " #.000000")
                    End If
                End If
                If bIndex = 4 Then
                    If dblDataBuff(iScanIndex + bIndex) < 0 Then
                        frmGraph_EMF16.txtSub4Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global)), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub4Volts(0) = Format$(str(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global), " #.000000")
                    End If
                End If
                If bIndex = 5 Then
                    If dblDataBuff(iScanIndex + bIndex) < 0 Then
                        frmGraph_EMF16.txtSub5Volts(0) = Format$(str(Abs(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global)), "-#.000000")
                    Else
                        frmGraph_EMF16.txtSub5Volts(0) = Format$(str(dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global), " #.000000")
                    End If
                End If
            Else
            
'10-21-15b look
                '10-20-15 START #############
                'no subtract saved offsets from offset channel
                If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
                    If bIndex = m30x.numChannels - 1 Then
                        calScanOffsetVal_global = dblDataBuff(iScanIndex + bIndex)
                        calScanOffsetVal_global = dblDataBuff(iScanIndex + bIndex)
                        'frmGraph_EMF16.txtChan7.Text = Format$(str(Abs(calScanOffsetVal_global)), "-#.000000")
                        'frmGraph_EMF16.txtIndex.Text = iScanIndex & ", " & bIndex & ", " & iScanIndex + bIndex
                        GoTo DO_NEXT '10-21-15b
                    End If
                End If
                '10-20-15 END ###############
                
                
                '2-6-15 start new ############
                ' prior to now, this was only in single chan scan for some reason?
                If fRecordOffsetStartFirstScan = True Then
                    '4-9-15 dblOffsetVoltages(0, numChanLocal) = dblDataBuff(iScanIndex + bIndex)
                    dblOffsetVoltages(0, bIndex) = dblDataBuff(iScanIndex + bIndex) '4-9-15
                    '11-30-16 fRetVal = WriteIniFileSpecs_CHoffsets_CurChan
                    fRetVal = WriteAppDirOffsetFile  '11-30-16
                End If
                '2-6-15 end new ##############
                
                
                '4-9-15 start new ##################################################
                If bUseOffsetVoltages = True Then
                    dblDataBuff(iScanIndex + bIndex) = dblDataBuff(iScanIndex + bIndex) - dblOffsetVoltages(0, bIndex)
                End If
                '4-9-15 end new ####################################################
                
'SKIP_DO_OFFSET_2:
            
                If frmGraph_EMF16.btnChans(bIndex).BackColor <> &H8000000F Then
                    'NOTE: since there are only main channels in this non 201EMF16 mode, the two-dimensional array used in the
                    '  plot function is reconfigured so the first dimension is always 0 and the second is the actual channels
                    '  instead of the first being the main channel and the second being sub-channels as in the 201EMF16 mode.
                    If iScanAvg > 1 Then
                        '10-20-15 dVoltage(0) = dblDataBuff(iScanIndex + bIndex)
                        dVoltage(0) = dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global '10-20-15
                        DoMultiChanScanAverage (bIndex)
                    End If
 
                    If iScanAvg > 1 Then
                        dVoltage_EMF16(0, bIndex) = dVoltage(0)
                    Else
                        '10-20-15 dVoltage_EMF16(0, bIndex) = dblDataBuff(iScanIndex + bIndex)
                        dVoltage_EMF16(0, bIndex) = dblDataBuff(iScanIndex + bIndex) - calScanOffsetVal_global '10-20-15
                    End If
                    
                    dVoltageValid(0, bIndex) = 1
    
                End If
            End If
            
'10-20-15 START ##############################
' need to deal with logging of cal-scan offset
'#############################################
            dVoltage_EMF16_LOG(bTempIndex, 0) = dblDataBuff(iScanIndex + bTempIndex) '5-6-14
            
           
            bTempIndex = bTempIndex + 1
            
            frmGraph_EMF16.frame5.Visible = False
            If frmGraph_EMF16.frame5.Visible = True Then
                frmGraph_EMF16.l1.Caption = "uiNumScansToReturn: " & uiNumScansToReturn
        
                frmGraph_EMF16.l2.Caption = "uiNumScansReturned: " & uiNumScansReturned
                frmGraph_EMF16.l3.Caption = "scanDataRedimSize_Last: " & scanDataRedimSize_Last
                frmGraph_EMF16.l5.Caption = "uiNumScansRemainingInBuff: " & uiNumScansRemainingInBuff
                frmGraph_EMF16.l6.Caption = "bTempIndex: " & bTempIndex
                frmGraph_EMF16.l7.Caption = "iScanIndex: " & iScanIndex
                frmGraph_EMF16.l8.Caption = "scanCnt: " & scanCnt
            End If
    
            dblScanCntTemp = CDbl(scanCnt + 1) * m30x.scanInterval
            'dblScanCntTemp = CDbl(scanCnt - 1) * (1# / CDbl(frmGraph_EMF16.SecPerScrn.Text)) '7-28-15b
            frmGraph_EMF16.txtElapsedTime.Text = Format$(dblScanCntTemp, " #####") '5-15-14
            frmGraph_EMF16.txtScans.Text = scanCnt + 1 '5-13-14
            
DO_NEXT: '10-21-15
            
        Next
        
        iRetVal = Plot(0) 'always 0, bDisplayChan is the actual channel for display boxes
        
        bTempIndex = 0
        '7-29-15g moved below frmGraph_EMF16.txtScans.Text = scanCnt
        
        '2-20-18 frmGraph_EMF16.txtBuff.Text = uiNumScansRemainingInBuff
        scanCnt = scanCnt + 1
        frmGraph_EMF16.txtScanCnt.Text = Format$(scanCnt, "00000000")
        
        frmGraph_EMF16.txtScans.Text = scanCnt  '7-29-15g
       
        '8-10-15 If frmGraph_EMF16.CheckLogData.Value = vbChecked Then
             fRetVal = WriteLogFileSubChanOnly(0) 'channel is ignored
        '8-10-15 End If
        
        bScanIndex = bScanIndex + 1
        If bScanIndex = uiNumScansToReturn Then Exit For
        
    Next
DONE_VOLTAGES:
                
    Scan_EMF16_GetTemperature_simp = SCAN_STILL_RUNNING
End Function
Public Sub Scan_EMF16_Stop()
    Dim bRetVal As Byte
    bRetVal = EX_Scan_EMF16_Stop(m30x.usDevId)
End Sub
Public Sub Scan_EMF16_EndDataThread()
    Dim bRetVal As Byte
    bRetVal = EX_Scan_EMF16_EndDataThread(m30x.usDevId)
End Sub
Public Sub ShowGraphicScreen()
    frmGraph_EMF16.frameGraphicScanBtns.Visible = True
    frmGraph_EMF16.frameTextScan.Visible = False
    frmGraph_EMF16.btnShowGraphicOrTextScan.Caption = "Text Scrn"
    frmGraph_EMF16.btnShowGraphicOrTextScan.Enabled = True
    frmGraph_EMF16.Frame1.Visible = True
    bChanCnt = 9   'Load this from .ini file at startup
    frmGraphTextVolts.Visible = True
    
'1   SINGLE_CHAN_SCAN
'2   MULTI_CHAN_SCAN
'3   MULTI_CHAN_CAL_SCAN
'4   SINGLE_CHAN_DIGIN_SCAN
'5   MULTI_CHAN_DIGIN_SCAN
'6   MULTI_CHAN_CAL_DIGIN_SCAN
'10-19-15 LOOK

'10-26-15 commented following
'    If (m30x.tScan = MULTI_CHAN_CAL_SCAN) Or (m30x.tScan = MULTI_CHAN_CAL_DIGIN_SCAN) Then
'        frmCalVlts.Visible = True
'        frmCalVlts.Left = frmGraphTextVolts.Left
'        frmCalVlts.Top = frmGraphTextVolts.Top + frmGraphTextVolts.Height
'        frmCalVlts.txtFocus.SetFocus
'    End If

    frmGraph_EMF16.Line6.Visible = True

    'TIME - Taken from form loading. This needs
    '   modified to use runtime values where appropriate.
    Dim bIndex As Byte

    '7-29-15 LXPixTotal = dblGlobalScreenWidth '7-8-14 'number of pixels on horizontal axis use these two to place the display
    '7-29-15 LXPixTotal = LXPixTotal - (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width)  'number of available pixels on horizontal axis
    
    
    HorizDivMainCalc

    dblLastX = (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width)

    Dim dblMax As Double
    dblMax = dblMaxFullScale
    Dim dblMin As Double
    dblMin = dblMinFullScale
    
    frmGraph_EMF16.txtPosFullScale = dblMax
    fRetVal = txtPosFullScale_KeyUp_DoIt(13, 0)
    frmGraph_EMF16.txtNegFullScale = dblMin
    fRetVal = txtNegFullScale_KeyUp_DoIt(13, 0)
    
'10-23-15f
'frmGraph_EMF16.txtTempT3 = dblMax
    
    

    dblZoomFactor = 1
    dblPercentFullScale = 100
    DrawScreen
    Dim bRetVal, bEnable, bSetupAllChansAndSubs As Byte: bEnable = 1: bSetupAllChansAndSubs = 0

    If fComingFromTextScreen = False Then         '4-10-15
        bRetVal = frmGraph_EMF16.SelectScanChanButtons(bEnable, bSetupAllChansAndSubs, 0)
    End If  '4-10-15
    fComingFromTextScreen = False '4-10-15
End Sub
Public Function txtPosFullScale_KeyUp_DoIt(KeyCode As Integer, Shift As Integer)
    If KeyCode = 189 Then                'got a minus
         bGraphFullScalePosIsNeg = 1: GoTo EXIT1
    End If
    If KeyCode = 187 Then                'got a plus
         bGraphFullScalePosIsNeg = 0: GoTo EXIT1
    End If
    
    If KeyCode = 13 Then                'got ENTER key
        If frmGraph_EMF16.txtPosFullScale.Text = "" Then GoTo EXIT1
        If frmGraph_EMF16.txtPosFullScale.Text = "." Then GoTo ExitErr
        On Error GoTo ExitErr
        HandlePostFullscaleUpdate
        GoTo EXIT1
    End If
    
    If KeyCode = 8 Then GoTo ExitErr
    If KeyCode > 57 Or KeyCode < 46 Then GoTo ExitErr
    GoTo EXIT1
    
ExitErr:
    If KeyCode = 190 Then GoTo EXIT1        'VB sees period (in text double) as 190
    frmGraph_EMF16.txtPosFullScale.Text = ""
    On Error GoTo 0
    
EXIT1:
End Function
Public Function txtNegFullScale_KeyUp_DoIt(KeyCode As Integer, Shift As Integer)
    If KeyCode = 189 Then                'got a minus
         bGraphFullScaleNegIsPos = 1: GoTo EXIT1
    End If
    If KeyCode = 187 Then                'got a plus
         bGraphFullScaleNegIsPos = 0: GoTo EXIT1
    End If

    If KeyCode = 13 Then                'got ENTER key
        If frmGraph_EMF16.txtNegFullScale.Text = "" Then GoTo EXIT1
        If frmGraph_EMF16.txtNegFullScale.Text = "." Then GoTo ExitErr
        On Error GoTo ExitErr
        
        If frmGraph_EMF16.txtNegFullScale.Text = "0" Then frmGraph_EMF16.txtNegFullScale.Text = ".00001"
    
        HandleNegFullscaleUpdate
        GoTo EXIT1
    End If
    
    If KeyCode = 8 Then GoTo ExitErr
    If KeyCode > 57 Or KeyCode < 46 Then GoTo ExitErr
    GoTo EXIT1
    
ExitErr:
    If KeyCode = 190 Then GoTo EXIT1        'VB sees period (in text double) as 190
    'MsgBox "Enter numeric values only  " & KeyCode, 0
    frmGraph_EMF16.txtNegFullScale.Text = ""
    On Error GoTo 0
    
EXIT1:
End Function
Public Sub UpdateGraphDisplay()
'10-23-15f look - maybe cause txtPosFullScale > 5.0?
    frmGraph_EMF16.txtPosFullScale.Text = Format$(dblYFS, "#.00000")
    frmGraph_EMF16.txtNegFullScale.Text = Format$(dblYFS - dblYRange, "#.00000")
End Sub
Public Sub UpdateZoomIndex()
    Select Case dblZoomFactor
       Case 1: dblYIndex = 1#: Case 2: dblYIndex = 0.5: Case 4: dblYIndex = 0.2: Case 8: dblYIndex = 0.1: Case 16: dblYIndex = 0.05: Case 32: dblYIndex = 0.02: Case 64: dblYIndex = 0.01: Case 128: dblYIndex = 0.005: Case 256: dblYIndex = 0.002: Case 512: dblYIndex = 0.001: Case 1024: dblYIndex = 0.0005: Case 2048: dblYIndex = 0.0002: Case 4096: dblYIndex = 0.0001: Case 8192: dblYIndex = 0.00005: Case 16384: dblYIndex = 0.00005: Case 32768: dblYIndex = 0.00002: Case Else: dblYIndex = 0.001
    End Select
End Sub
Public Sub BtnUnzoom_Click_DoIt()
    If dblZoomFactor < 2 Then GoTo EXIT1

    dblYRange = dblYRange * 2
    If dblYRange > 10 Then dblYRange = 10
    If dblYRange = 0 Then dblYRange = 0.001
    
    dblZoomFactor = 10 / dblYRange

    dblPercentFullScale = dblPercentFullScale * 2
    UpdateGraphDisplay
EXIT1:
End Sub
Public Sub BtnZoom_Click_DoIt()
    If dblZoomFactor < 1 Then dblZoomFactor = 1
    If dblZoomFactor >= 32768 Then dblZoomFactor = 32768: GoTo EXIT1

    dblYRange = dblYRange / 2
    If dblYRange = 0 Then dblYRange = 0.001
    
    If dblYRange < 0.0003 Then dblYRange = 10 / 32768
    dblZoomFactor = 10 / dblYRange

    dblPercentFullScale = dblPercentFullScale / 2#
    UpdateGraphDisplay
EXIT1:
End Sub
Public Sub BtnClear_Click_DoIt()
    frmGraph_EMF16.BackColor = &H1
    frmGraph_EMF16.BackColor = &H0&
    DrawScreen
    Dots
    
    
'7-29-15c
    frmGraph_EMF16.Line ((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), _
        LYPixTotal + 10)-(LXPixTotal + (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), _
        LYPixTotal + 10), RGB(80, 255, 80)   'horizontal axis
    
    
End Sub
Sub InitGraph()
    '7-29-15 LXPixTotal = dblGlobalScreenWidth '7-8-14 'number of pixels on horizontal axis use these two to place the display
    '7-29-15 LXPixTotal = LXPixTotal - (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width)  'number of available pixels on horizontal axis
    
    HorizDivMainCalc
    dblLastX = (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width)
    
    VertDivMainCalc
    
    dblZoomFactor = 1
    dblPercentFullScale = 100
    
    DrawScreen
    
    If fAnyScanRunning = True Then
        dblZoomFactor = 1
    Else
    End If
    DoEvents
    fGraphIsDisplayed = True
    
EXIT1:

End Sub
Public Function DoPlotWrap(bMainChan As Byte, dblPixPerPoint_local As Double) As Byte
    Dim bIndex, bVoltArrayIndex As Byte
    Dim LRedVal As Long: Dim bRedVal As Byte: Dim LGreenVal As Long: Dim bGreenVal As Byte: Dim LBlueVal As Long: Dim bBlueVal As Byte
    Dim bSubChanIndex As Byte
    
    bVoltArrayIndex = 0
    
    If fClearGraphicScreenNow Then
        fClearGraphicScreenNow = False
        dblLastX = (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width)
        dblScanCntTemp = (scanCnt - 1#) * m30x.scanInterval
'dblScanCntTemp = CDbl(scanCnt - 1) * (1# / CDbl(frmGraph_EMF16.SecPerScrn.Text)) '7-28-15b
         If dblScanCntTemp > 1 Then
            frmGraph_EMF16.txtGraphStartTime.Text = Format$(dblScanCntTemp, " ########")
        End If
        BtnClear_Click_DoIt
    End If
    
    frmGraphTextVolts.lblGraphChan = frmGraph_EMF16.comboMainChan.Text


    '#####################################
    'Erase Old Data ====================
    frmGraph_EMF16.DrawWidth = 1
'1-20-16    frmGraph_EMF16.Line (dblLastX, 0)-Step(dblPixPerPoint_local + 60#, frmGraph_EMF16.Height), RGB(255, 0, 0), BF
    
    frmGraph_EMF16.Line (dblLastX, 0)-Step(dblPixPerPoint_local + 60#, frmGraph_EMF16.Height - 2500), RGB(0, 0, 0), BF
    
    '===================================
    '#####################################

    '#####################################
    'Draw new dots if necessary ==========
    Dim XTemp As Integer
    
    For XTemp = ((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width) _
            + dblXIndexPix) To (LXPixTotal + (frmGraph_EMF16.frameLeftGraphMarker.Left _
            + frmGraph_EMF16.frameLeftGraphMarker.Width) + 1) Step dblXIndexPix
        LDotCol = Int(XTemp + 0.5)
        If (LDotCol > dblLastX) And (LDotCol < (dblLastX + (dblPixPerPoint_local + 20#))) Then
            Dots
        End If
    Next
    
DONE_DOT_CHK:
    
    frmGraph_EMF16.DrawWidth = 1
    Dim bFirstSubFind As Byte
    Dim fAnySubFound As Boolean: fAnySubFound = False '8-4-11
    For bFirstSubFind = 0 To 15
        If frmGraph_EMF16.btnChans(bFirstSubFind).BackColor <> &H8000000F Then
            fAnySubFound = True '8-4-11 if this isn't available, the loop below will use bFirstSubFound = 16 and crash,
                                ' while all other values 0 - 15 are actually valid values. However, note that this may
                                ' need moved elsewhere so the correct updates are made to everything else even when the
                                ' graph and associated text box doesn't update due to now sub button being selected.
            Exit For
        End If
    Next bFirstSubFind

    If fAnySubFound <> False Then
        For bSubChanIndex = 0 To 15
            If dVoltageValid(bMainChan, bSubChanIndex) = 1 Then
            
                If frmGraph_EMF16.btnChans(bSubChanIndex).BackColor <> &H8000000F Then '8-1-11
                    If dVoltage_EMF16(bMainChan, bSubChanIndex) < 0 Then 'Just used to improve display of negative
                        frmGraphTextVolts.txtGrTextVolts(bSubChanIndex) = Format$(str(Abs(dVoltage_EMF16(bMainChan, bSubChanIndex - bFirstSubFind))), "-#.000000")
                    Else
                        frmGraphTextVolts.txtGrTextVolts(bSubChanIndex) = Format$(str(dVoltage_EMF16(bMainChan, bSubChanIndex - bFirstSubFind)), " #.000000")
                    End If
                End If
    
                bCurGraphSubChan_Global = bSubChanIndex
    
                iY = (dblYFS - dVoltage_EMF16(bMainChan, bSubChanIndex)) * dblPixsPerVolt
                If iY >= LYPixTotal Then iY = LYPixTotal - 1
    
                If LLastY(bSubChanIndex) = -10 Then LLastY(bSubChanIndex) = iY    'if first point, then same iY
                If iY < 2 Then iY = 2
    
                LRedVal = lngScanChanColors(bSubChanIndex): bRedVal = LRedVal And &HFF
                LGreenVal = lngScanChanColors(bSubChanIndex): LGreenVal = LGreenVal \ 256: bGreenVal = LGreenVal And &HFF
                LBlueVal = lngScanChanColors(bSubChanIndex): LBlueVal = Int(LBlueVal \ 65536): bBlueVal = LBlueVal And &HFF
    
                If frmGraph_EMF16.btnChans(bSubChanIndex).BackColor <> &H8000000F Then
                    frmGraph_EMF16.Line (dblLastX, LLastY(bSubChanIndex))-(dblX, iY), RGB(bRedVal, bGreenVal, bBlueVal)
                End If
                
                LLastY(bSubChanIndex) = iY
    
            Else
                frmGraphTextVolts.txtGrTextVolts(bSubChanIndex).Text = "     ---"
            End If
        Next bSubChanIndex
    End If
    
    dblLastX = dblX
End Function
Public Function Plot(bMainChan As Byte)
    Dim bAutoScalePending As Byte:  bAutoScalePending = 0
    
    Dim bIndex, bSubChanIndex As Byte
    Dim LRedVal As Long: Dim bRedVal As Byte: Dim LGreenVal As Long: Dim bGreenVal As Byte: Dim LBlueVal As Long: Dim bBlueVal As Byte
    Dim dblVoltArraySave(6, 16) As Double
    Dim dblVoltArray_Local(6, 16) As Double
    Dim dVoltageNoOffset_Original(6, 16) As Double
    
    Dim bMainGraphChan As Byte
    bMainGraphChan = bCurMainChan_Global
    
    Dim dblTempVal As Double
    Dim dblYTemp As Double
    
    For bSubChanIndex = 0 To 15
        dVoltageNoOffset_Original(bMainChan, bSubChanIndex) = dVoltage_EMF16(bMainChan, bSubChanIndex)
    Next bSubChanIndex
    
    frmGraph_EMF16.DrawWidth = 1
    bMainChan = 0
    bCurMainChan_Global = 0
    bMainGraphChan = bCurMainChan_Global

    If fGraphicScreenClearPending = True Then
        BtnClear_Click_DoIt
        fGraphicScreenClearPending = False

        dblScanCntTemp = (scanCnt - 1#) * m30x.scanInterval
'dblScanCntTemp = CDbl(scanCnt - 1) * (1# / CDbl(frmGraph_EMF16.SecPerScrn.Text)) '7-28-15b
         If dblScanCntTemp > 1 Then
            frmGraph_EMF16.txtGraphStartTime.Text = Format$(dblScanCntTemp, " ########")
        End If

        If (frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)") Then bAutoScalePending = 1
    End If
    
    'if save-offset requested --- do it now ##########################
    If fRecordOffsetsNow Then
        fRecordOffsetsNow = False
        
        BtnClear_Click_DoIt
        
        If bLocalAvg > 1 Then
            fVoltageAvgArraysNeedsInit_Pending = True
        End If
    End If
    'end of saving offset voltage ####################################
    
    If bMainGraphChan = bMainChan Then
        For bSubChanIndex = 0 To 15
            dblVoltArraySave(bMainChan, bSubChanIndex) = dVoltage_EMF16(bMainChan, bSubChanIndex)
            dblVoltArray_Local(bMainChan, bSubChanIndex) = dVoltage_EMF16(bMainChan, bSubChanIndex)
        Next
    End If
        
    If bMainGraphChan = bMainChan Then
        '#####################################
        'Do autoscale first pass =============
'1-14-16 put this back in (was commented 10-23-15
'10-23-15f commented following
        '1-14-16 If (dblScanNum = 0) And ((dblLastX = (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width))) And (frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)") Then
       If (dblScanNum = 0) And (frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)") Then
        
            dblScanCntTemp = (scanCnt - 1#) * m30x.scanInterval
            If dblScanCntTemp > 1 Then
                frmGraph_EMF16.txtGraphStartTime.Text = Format$(dblScanCntTemp, " ########")
            End If

            bIndex = 0

            For bSubChanIndex = 0 To 15
                If (frmGraph_EMF16.btnChans(bSubChanIndex).Enabled = True) And (frmGraph_EMF16.btnChans(bSubChanIndex).BackColor <> &H8000000F) Then
                    dblAutoScaleVoltages(bIndex) = dVoltage_EMF16(bMainChan, bSubChanIndex)
                    
'1-14-16 start
dblGraphVoltsMax = -5
dblGraphVoltsMin = 5
If dVoltage_EMF16(bMainChan, bSubChanIndex) > dblGraphVoltsMax Then dblGraphVoltsMax = dVoltage_EMF16(bMainChan, bSubChanIndex)
If dVoltage_EMF16(bMainChan, bSubChanIndex) < dblGraphVoltsMin Then dblGraphVoltsMin = dVoltage_EMF16(bMainChan, bSubChanIndex)
'1-14-16 end
                    
                    
                    bIndex = bIndex + 1
                End If
            Next bSubChanIndex

            AutoScale (bIndex)
            
            For bSubChanIndex = 0 To 15
                dPrevVoltages(bMainChan, bSubChanIndex) = dVoltage_EMF16(bMainChan, bSubChanIndex)
            Next bSubChanIndex
            dblLastX = frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width
            For bSubChanIndex = 0 To 15
                dblYTemp = (dblYFS - dblVoltArray_Local(bMainChan, bSubChanIndex)) * dblPixsPerVolt
                If dblYTemp >= LYPixTotal Then dblYTemp = (LYPixTotal * 1#) - 1#
                iY = Int(dblYTemp)
                If LLastY(bSubChanIndex) = -10 Then LLastY(bSubChanIndex) = iY    'if first point, then same iY
                If iY < 2 Then iY = 2
                LLastY(bSubChanIndex) = iY
            Next
            dblScanNum = dblScanNum + 1
            BtnClear_Click_DoIt
            
            GoTo EXIT_SUB
        End If
        dblScanNum = dblScanNum + 1
        '===================================
        '#####################################
    End If
    
    Dim dblWrapPercent, dblPixPerPoint_part1, dblPixPerPoint_part2 As Double
    Dim fGotWrap As Byte: fGotWrap = 0
    
    dblPixPerPoint_part1 = dblPixPerDP
    
    If bMainGraphChan = bMainChan Then
        If fClearGraphicScreenNow Then
            fClearGraphicScreenNow = False
            dblLastX = frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width
            BtnClear_Click_DoIt
            If (frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)") Then bAutoScalePending = 1

            '9-4-04
            dblScanCntTemp = (scanCnt - 1#) * m30x.scanInterval
            If dblScanCntTemp > 1 Then
                frmGraph_EMF16.txtGraphStartTime.Text = Format$(dblScanCntTemp, " ########")
            End If
        End If
        dblX = dblLastX + dblPixPerDP   '1-12-11 looking at this
        
        
        
    End If
    
    If bMainGraphChan <> bMainChan Then
        Exit Function
    End If
    If (bAutoScalePending = 0) Then
    
'frmGraph_EMF16.txtTempT1.Text = dblX
    
        If dblX >= dblActualGraphRightEdge Then

            fGotWrap = 1
            
            dblPixPerPoint_part2 = dblX - dblActualGraphRightEdge
            dblPixPerPoint_part1 = dblPixPerDP - dblPixPerPoint_part2
            dblWrapPercent = dblPixPerPoint_part1 / dblPixPerDP
            'dblWrapPercent = 1
            
            For bSubChanIndex = 0 To 15
                If (dblWrapPercent * (dVoltage_EMF16(bMainChan, bSubChanIndex) - dPrevVoltages(bMainChan, bSubChanIndex))) < dPrevVoltages(bMainChan, bSubChanIndex) Then
                    dblVoltArray_Local(bMainChan, bSubChanIndex) = dPrevVoltages(bMainChan, bSubChanIndex) + (dblWrapPercent * (dVoltage_EMF16(bMainChan, bSubChanIndex) _
                        - dPrevVoltages(bMainChan, bSubChanIndex)))
                Else
                    dblVoltArray_Local(bMainChan, bSubChanIndex) = (dblWrapPercent * (dVoltage_EMF16(bMainChan, bSubChanIndex) - dPrevVoltages(bMainChan, bSubChanIndex)) _
                        + dPrevVoltages(bMainChan, bSubChanIndex))
                End If
            Next bSubChanIndex
            
        End If
    Else
        bAutoScalePending = 0
        bIndex = 0
        For bSubChanIndex = 0 To 15
            If (frmGraph_EMF16.btnChans(bSubChanIndex).Enabled = True) And (frmGraph_EMF16.btnChans(bSubChanIndex).BackColor <> &H8000000F) Then
                dblAutoScaleVoltages(bIndex) = dVoltage_EMF16(bMainChan, bSubChanIndex)
                bIndex = bIndex + 1
            End If
        Next bSubChanIndex
        AutoScale (bIndex)

        For bSubChanIndex = 0 To 15
            dblYTemp = (dblYFS - dblVoltArray_Local(bMainChan, bSubChanIndex)) * dblPixsPerVolt
            If dblYTemp >= LYPixTotal Then dblYTemp = (LYPixTotal * 1#) - 1#
            iY = Int(dblYTemp)
            If LLastY(bSubChanIndex) = -10 Then LLastY(bSubChanIndex) = iY    'if first point, then same iY
            If iY < 2 Then iY = 2
            LLastY(bSubChanIndex) = iY
        Next

        BtnClear_Click_DoIt
        dblLastX = frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width
        GoTo EXIT_SUB

    End If
        
    frmGraphTextVolts.lblGraphChan = frmGraph_EMF16.comboMainChan.Text

    Dim intXLast As Long
    Dim intXNow As Long
    intXLast = Int(dblLastX)
    intXNow = Int(dblX)
    
    'The lines above will round the double down each time for the current drawing, but the
    'saved values are saved as doubles and will grow as per the rate/per/screen which will
    'eventually increase the values of the integers.
    

    '#####################################
    'Erase Old Data ======================
    frmGraph_EMF16.DrawWidth = 1
    If intXNow > intXLast Then
       '7-29-15f frmGraph_EMF16.Line (intXLast + Screen.TwipsPerPixelX, 0)-(intXNow + Screen.TwipsPerPixelX + 10, LYPixTotal - (1 * Screen.TwipsPerPixelY)), RGB(0, 0, 0), BF
       '7-29-15f fixes erasing old data when near bottom of screen
       '7-29-15g frmGraph_EMF16.Line (intXLast + Screen.TwipsPerPixelX, 0)-(intXNow + Screen.TwipsPerPixelX + 10, 20 + LYPixTotal - (1 * Screen.TwipsPerPixelY)), RGB(0, 0, 0), BF
       '7-29-15g best fix
       frmGraph_EMF16.Line (intXLast + Screen.TwipsPerPixelX, 0)-(intXNow + Screen.TwipsPerPixelX + 10, LYPixTotal), RGB(0, 0, 0), BF
    End If
    '=====================================
    '#####################################


    '#####################################
    'Draw new dots if necessary ==========
    Dim XTemp As Integer

    'replace the doubles with the integers for the last-X
    For XTemp = ((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width) + dblXIndexPix) _
            To (LXPixTotal + (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width) + 1) Step dblXIndexPix
        LDotCol = Int(XTemp + 0.5)
        If (LDotCol > intXLast) And (LDotCol < (intXLast + (dblPixPerPoint_part1 + 60#))) Then
            Dots
         End If
    Next
    '===================================
    '#####################################
    
    
    
DONE_DOT_CHK:
    frmGraph_EMF16.DrawWidth = 1

    Dim bFirstSubFind As Byte
    Dim fAnySubFound As Boolean: fAnySubFound = False '8-4-11
    For bFirstSubFind = 0 To 15
        If frmGraph_EMF16.btnChans(bFirstSubFind).BackColor <> &H8000000F Then
            fAnySubFound = True '8-4-11 if this isn't available, the loop below will use bFirstSubFound = 16 and crash,
                                ' while all other values 0 - 15 are actually valid values. However, note that this may
                                ' need moved elsewhere so the correct updates are made to everything else even when the
                                ' graph and associated text box doesn't update due to now sub button being selected.
            Exit For
        End If
    Next bFirstSubFind

    '7-28-15c START ##################################################################################
    ' the following sets up bChanTestIndex to be used as the starting index in the IF statement below,
    ' so it starts at the right channel for single-chan scan mode when the single channel isn't zero
    ' as the IF conditional usually assumes it to be.
    Dim bChanTestIndex As Byte: bChanTestIndex = 0
    Dim bSingleChanNum As Byte
    Dim bSingChanIndex As Byte
    bSingleChanNum = 0
    If (m30x.tScan = SINGLE_CHAN_SCAN) Or (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Then
        For bSingChanIndex = 0 To 6  '5-11-14c
            If frmGraph_EMF16.btnChans(bSingChanIndex).BackColor <> &H8000000F Then
                bSingleChanNum = bSingChanIndex
                bChanTestIndex = bSingChanIndex
            End If
        Next
    End If
    '7-28-15c END #############################


    If fAnySubFound Then
        '7-28-15c For bSubChanIndex = 0 To 15
        For bSubChanIndex = bChanTestIndex To 15
            If dVoltageValid(bMainChan, bSubChanIndex) = 1 Then
                If frmGraph_EMF16.chkSimplifiedMode.Value = vbUnchecked Then
                    If dVoltage_EMF16(bMainChan, bSubChanIndex) < 0 Then 'Just used to improve display of negative
                        frmGraphTextVolts.txtGrTextVolts(bSubChanIndex) = Format$(str(Abs(dblVoltArray_Local(bMainChan, bSubChanIndex))), "-#.000000")
                    Else
                        frmGraphTextVolts.txtGrTextVolts(bSubChanIndex) = Format$(str(dblVoltArray_Local(bMainChan, bSubChanIndex)), " #.000000")
                    End If
                Else
                    '1   SINGLE_CHAN_SCAN
                    '2   MULTI_CHAN_SCAN
                    '3   MULTI_CHAN_CAL_SCAN
                    '4   SINGLE_CHAN_DIGIN_SCAN
                    '5   MULTI_CHAN_DIGIN_SCAN
                    '6   MULTI_CHAN_CAL_DIGIN_SCAN
                    
On Error GoTo SkipErr
                   
                    If (m30x.tScan = SINGLE_CHAN_SCAN) Or (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Then
                        
                        If dVoltage_EMF16(bMainChan, bSubChanIndex) < 0 Then 'Just used to improve display of negative
                            frmGraphTextVolts.txtGrTextVolts(bDisplayChan) = Format$(str(Abs(dblVoltArray_Local(0, bSubChanIndex))), "-#.000000")
                        Else
                            frmGraphTextVolts.txtGrTextVolts(bDisplayChan) = Format$(str(dblVoltArray_Local(0, bSubChanIndex)), " #.000000")
                        End If
                    Else
                        If dVoltage_EMF16(bMainChan, bSubChanIndex) < 0 Then 'Just used to improve display of negative
                            frmGraphTextVolts.txtGrTextVolts(bSubChanIndex) = Format$(str(Abs(dblVoltArray_Local(bMainChan, bSubChanIndex))), "-#.000000")
                        Else
                            frmGraphTextVolts.txtGrTextVolts(bSubChanIndex) = Format$(str(dblVoltArray_Local(bMainChan, bSubChanIndex)), " #.000000")
                        End If
                    End If

                End If

                Dim dblDegrees As Double
                dblDegrees = dblVoltArray_Local(bMainChan, bSubChanIndex) / ((5# - dblVoltArray_Local(bMainChan, bSubChanIndex)) / 10000#)
                dblDegrees = (dblDegrees - 100#) / 0.388
                If frmGraph_EMF16.chkSimplifiedMode.Value = vbUnchecked Then
                    frmGraph_EMF16.txtChan1Temp.Text = Format$(dblDegrees, "##.0")
                End If
SkipErr:
On Error GoTo 0
                
                dPrevVoltages(bMainChan, bSubChanIndex) = dblVoltArray_Local(bMainChan, bSubChanIndex)
    
                bCurGraphSubChan_Global = bSubChanIndex
    
                iY = ((dblYFS - dVoltage_EMF16(bMainChan, bSubChanIndex)) * dblPixsPerVolt) - 1
                
                If iY >= LYPixTotal Then iY = LYPixTotal - (1 * Screen.TwipsPerPixelY)
    
                If LLastY(bSubChanIndex) = -10 Then LLastY(bSubChanIndex) = iY    'if first point, then same iY
                If iY < 2 Then iY = 2
                
                
'10-23-15b
'10-23-15d If dVoltage_EMF16(bMainChan, bSubChanIndex) > dblGraphVoltsMax Then dblGraphVoltsMax = dVoltage_EMF16(bMainChan, bSubChanIndex)
'10-23-15d If dVoltage_EMF16(bMainChan, bSubChanIndex) < dblGraphVoltsMin Then dblGraphVoltsMin = dVoltage_EMF16(bMainChan, bSubChanIndex)
                
                
                LRedVal = lngScanChanColors(bSubChanIndex): bRedVal = LRedVal And &HFF
                LGreenVal = lngScanChanColors(bSubChanIndex): LGreenVal = LGreenVal \ 256: bGreenVal = LGreenVal And &HFF
                LBlueVal = lngScanChanColors(bSubChanIndex): LBlueVal = Int(LBlueVal \ 65536): bBlueVal = LBlueVal And &HFF
    
                If frmGraph_EMF16.btnChans(bSubChanIndex).BackColor <> &H8000000F Then
                
'10-23-15d do this on only enabled channels
If dVoltage_EMF16(bMainChan, bSubChanIndex) > dblGraphVoltsMax Then dblGraphVoltsMax = dVoltage_EMF16(bMainChan, bSubChanIndex)
If dVoltage_EMF16(bMainChan, bSubChanIndex) < dblGraphVoltsMin Then dblGraphVoltsMin = dVoltage_EMF16(bMainChan, bSubChanIndex)
                
                
                    frmGraph_EMF16.DrawWidth = 1
                    frmGraph_EMF16.Line (intXLast, LLastY(bSubChanIndex))-(intXNow, iY), RGB(bRedVal, bGreenVal, bBlueVal)
                End If
                LLastY(bSubChanIndex) = iY
            Else
                If frmGraph_EMF16.chkSimplifiedMode.Value = vbUnchecked Then '5-6-14
                    frmGraphTextVolts.txtGrTextVolts(bSubChanIndex).Text = "     ---"
                End If  '5-6-14
            End If
        Next bSubChanIndex
    End If
    
    
    If fGotWrap Then

        dblScanCntTemp = (scanCnt - 1#) * m30x.scanInterval
'dblScanCntTemp = CDbl(scanCnt - 1) * (1# / CDbl(frmGraph_EMF16.SecPerScrn.Text)) '7-28-15b
         If dblScanCntTemp > 1 Then
            frmGraph_EMF16.txtGraphStartTime.Text = Format$(dblScanCntTemp, " ########")
        End If

        For bSubChanIndex = 0 To 15
            dVoltage_EMF16(bMainChan, bSubChanIndex) = dblVoltArray_Local(bMainChan, bSubChanIndex)
        Next bSubChanIndex

        If (frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)") Then
            bIndex = 0
            For bSubChanIndex = 0 To 15
                If (frmGraph_EMF16.btnChans(bSubChanIndex).Enabled = True) And (frmGraph_EMF16.btnChans(bSubChanIndex).BackColor <> &H8000000F) Then
                    dblAutoScaleVoltages(bIndex) = dVoltage_EMF16(bMainChan, bSubChanIndex)
                    bIndex = bIndex + 1
                End If
            Next bSubChanIndex
            AutoScale (bIndex)
        End If

        For bSubChanIndex = 0 To 15
            dblYTemp = (dblYFS - dblVoltArray_Local(bMainChan, bSubChanIndex)) * dblPixsPerVolt
            If dblYTemp >= LYPixTotal Then dblYTemp = (LYPixTotal * 1#) - 1#
            iY = Int(dblYTemp)
            If LLastY(bSubChanIndex) = -10 Then LLastY(bSubChanIndex) = iY    'if first point, then same iY
            If iY < 2 Then iY = 2
            LLastY(bSubChanIndex) = iY
        Next

        dblX = dblPixPerPoint_part2 + (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width)
        dblLastX = (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width)

        For bSubChanIndex = 0 To 15
            dVoltage_EMF16(bMainChan, bSubChanIndex) = dblVoltArraySave(bMainChan, bSubChanIndex)
        Next bSubChanIndex

'1-14-16        Dim bRetVal As Byte
        bRetVal = DoPlotWrap(bMainChan, dblPixPerPoint_part2)

    Else
        dblLastX = dblX
    End If
EXIT_SUB: End Function
'Public Sub AutoScale(ByVal bNumVoltages As Byte)
'    Dim fRetVal As Boolean
'    Dim bSubChanIndex, bVoltArrayIndex As Byte: bVoltArrayIndex = 0
'    Dim bIndex As Byte
'
'    If bNumVoltages = 0 Then Exit Sub
'
'    For bIndex = 0 To (bNumVoltages - 1)
'        dblMinMaxSubVolts(bIndex) = dblAutoScaleVoltages(bIndex)
'    Next bIndex
'
'    Dim dblMin As Double
'    Dim dblMax As Double
'
'    Dim dblVoltRange As Double
'    Dim dblVoltCenter As Double
'
'    fRetVal = GetMinMaxVolts(bNumVoltages, dblMin, dblMax)
'
'    Dim dblMargin As Double
'    dblMargin = (dblMax - dblMin) / 5# 'get 20% or range
'    If dblMargin < 0.00005 Then
'        dblMargin = 0.00005
'    End If
'
'    dblMax = dblMax + dblMargin
'    dblMin = dblMin - dblMargin
'
'    If dblMax > 5# Then dblMax = 5#
'    If dblMin < -5# Then dblMin = -5#
'    frmGraph_EMF16.txtPosFullScale = dblMax
'    fRetVal = txtPosFullScale_KeyUp_DoIt(13, 0)
'    frmGraph_EMF16.txtNegFullScale = dblMin
'    fRetVal = txtNegFullScale_KeyUp_DoIt(13, 0)
'
'End Sub
Public Sub AutoScale(ByVal bNumVoltages As Byte)
    Dim fRetVal As Boolean
    Dim bSubChanIndex, bVoltArrayIndex As Byte: bVoltArrayIndex = 0
    Dim bIndex As Byte

    If bNumVoltages = 0 Then
        Exit Sub
    End If
    
'1-14-61 look at this - saw one voltage at 7 so array must not be initialized first call to this.
    For bIndex = 0 To (bNumVoltages - 1)
        dblMinMaxSubVolts(bIndex) = dblAutoScaleVoltages(bIndex)
    Next bIndex
    
    Dim dblMin As Double
    Dim dblMax As Double

    Dim dblVoltRange As Double
    Dim dblVoltCenter As Double

    fRetVal = GetMinMaxVolts(bNumVoltages, dblMin, dblMax)
    
'1-14-15 temp comment - to handle first scan only?
'    dblMax = dblGraphVoltsMax '10-23-15b
'    dblMin = dblGraphVoltsMin '10-23-15b
    
    
    Dim dblMargin As Double
    dblMargin = (dblMax - dblMin) / 5# 'get 20% or range
    If dblMargin < 0.00005 Then
        dblMargin = 0.00005
    End If
    
    dblMax = dblMax + dblMargin
    dblMin = dblMin - dblMargin
    
    
    If dblMax > 5# Then dblMax = 5#
    If dblMin < -5# Then dblMin = -5#
    frmGraph_EMF16.txtPosFullScale = dblMax
    fRetVal = txtPosFullScale_KeyUp_DoIt(13, 0)
    frmGraph_EMF16.txtNegFullScale = dblMin
    fRetVal = txtNegFullScale_KeyUp_DoIt(13, 0)
    
    
    dblGraphVoltsMax = -5#  '10-23-15b
    dblGraphVoltsMin = 5#   '10-23-15b
    
    
    
End Sub





'############################################
'############################################
Public Sub Dots()
'############################################
'############################################
    Dim LIndex As Long
    Dim LDrawWidth As Long: LDrawWidth = frmGraph_EMF16.DrawWidth
    
    Dim dblPosFullScale_TEMP, dblNegFullScale_TEMP, dblVoltsPerDivTemp As Double
    
    If (IsNumeric(frmGraph_EMF16.txtPosFullScale.Text)) And (IsNumeric(frmGraph_EMF16.txtNegFullScale.Text)) Then
        If (CDbl(frmGraph_EMF16.txtPosFullScale.Text) <> 0) And (CDbl(frmGraph_EMF16.txtNegFullScale.Text) <> 0) Then
            dblPosFullScale_TEMP = CDbl(frmGraph_EMF16.txtPosFullScale.Text)
            dblNegFullScale_TEMP = CDbl(frmGraph_EMF16.txtNegFullScale.Text)
            dblPosFullScale_TEMP = Abs(dblPosFullScale_TEMP)
            dblNegFullScale_TEMP = Abs(dblNegFullScale_TEMP)
           
            dblVoltsPerDivTemp = (dblPosFullScale_TEMP + dblNegFullScale_TEMP) / 10#
            If dblYIndex > 5# Then
                frmGraph_EMF16.VoltsPerDiv.Text = Format$(dblYIndex, "#.0")
            Else
                frmGraph_EMF16.VoltsPerDiv.Text = Format$(dblYIndex, "#.00000")
            End If
        End If
    End If
    
    sDotColorChange = 255
'    frmGraph_EMF16.DrawWidth = 1
    
    '7-29-15c
    frmGraph_EMF16.Line ((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), _
        LYPixTotal + 10)-(LXPixTotal + (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), _
        LYPixTotal + 10), RGB(80, 255, 80)   'horizontal axis
        
    For LIndex = dblYIndexPix To (LYPixTotal - 1) Step dblYIndexPix
        If LDotCol > frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width + 20 Then
            frmGraph_EMF16.Line (LDotCol, LIndex)-(LDotCol, LIndex + 15), RGB(80, sDotColorChange, 80)
        End If
    Next LIndex
    
 '   frmGraph_EMF16.DrawWidth = LDrawWidth
    
End Sub
Public Sub DrawScreen()
    Dim LIndex As Long
    Dim DC As Double
    
'7-29-15e     Dim LDrawWidth As Long: LDrawWidth = frmGraph_EMF16.DrawWidth
'7-29-15e     frmGraph_EMF16.DrawWidth = 1
'7-29-15b    frmGraph_EMF16.Line ((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), 0)-((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), LYPixTotal), RGB(0, 0, 0)
    
'7-29-15e    frmGraph_EMF16.DrawWidth = 1
    
'7-29-15d   For LIndex = 0 To (LYPixTotal - 1) Step Int(dblYIndexPix)
'7-29-15d        frmGraph_EMF16.Line ((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), LIndex - 1)-((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), LIndex + 1), RGB(80, 255, 80)
'7-29-15d    Next LIndex
    
'7-29-15b    frmGraph_EMF16.Line ((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), LYPixTotal)-(LXPixTotal + (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), LYPixTotal), RGB(80, 255, 80)  'horizontal axis
'    frmGraph_EMF16.Line ((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width), _
        LYPixTotal)-(LXPixTotal + (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width) - 30, _
        LYPixTotal), RGB(80, 255, 80)  'horizontal axis
    
    
    
    For DC = ((frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width) + dblXIndexPix) To (LXPixTotal + (frmGraph_EMF16.frameLeftGraphMarker.Left + frmGraph_EMF16.frameLeftGraphMarker.Width) + 1) Step dblXIndexPix
        LDotCol = Int(DC + 0.5)
        Dots
'7-29-15b        frmGraph_EMF16.Line (LDotCol - 1, LYPixTotal)-(LDotCol + 1, LYPixTotal), RGB(80, 255, 80)
    Next
    
    
'7-29-15e     frmGraph_EMF16.DrawWidth = LDrawWidth
    
End Sub
Public Sub HorizDivMainCalc()
    dblPixsPerSecond = (LXPixTotal - 1#) / dblXRange
    dblXIndexPix = dblXIndex * dblPixsPerSecond
    dblPixPerDP = dblPixsPerSecond / (m30x.rate / (m30x.numChannels * 5))
    
'frmGraph_EMF16.txtTempT1.Text = m30x.numChannels
'frmGraph_EMF16.txtTempT2.Text = dblPixPerDP
    
    
    '7-28-15c START ###############
    If (m30x.tScan = SINGLE_CHAN_SCAN) Or (m30x.tScan = SINGLE_CHAN_DIGIN_SCAN) Then
        dblPixPerDP = dblPixsPerSecond / m30x.rate
    End If
    '7-28-15c  END ###############
    
    '7-28-15c dblPixPerDP = dblPixPerDP * 0.9935 'almost perfect still teensie bit fast
    
    dblPixPerDP = dblPixPerDP  'just for debugging
End Sub
Public Sub RecalcHorizDiv()
    ' Currently, this function only called when value is
    ' entered in sec/screen box
    Dim dblHorizDiv As Double
    
    dblHorizDiv = frmGraph_EMF16.SecPerScrn.Text
    
    dblXRange = dblHorizDiv                         'dblXRange time for one screen
    
    '10-23-15 commented following
'    If dblXRange <= 0.1 Then
'       dblXIndex = 0.01: GoTo CalcXPix              'dblXIndex index interval in seconds
'    End If
'    If dblXRange <= 2 Then
'        dblXIndex = 0.1: GoTo CalcXPix
'    End If
'    dblXIndex = Int(dblXRange / 10 + 0.9)

    dblXIndex = dblXRange / 10  '10-23-15

    
    '10-22-15 this could make it 0 since Int makes less than zero, zero
    '10-22-15 dblXIndex = Int(dblXRange / 10)
        
CalcXPix:
    HorizDivMainCalc
    
    DrawScreen
End Sub
Public Sub VertDivMainCalc()
    '7-27-15 Dim bIndex As Byte
    '7-27-15 frmGraph_EMF16.frameYbaseLocator.Height = frmGraph_EMF16.frameYbaseLocator.Height
    '7-27-15 LYPixTotal = frmGraph_EMF16.ScaleHeight         'number of pixels on vertical axis
    '7-27-15 sVFrame = frmGraph_EMF16.frameYbaseLocator.Height

    '7-27-15 LYPixTotal = LYPixTotal - sVFrame               'number of available pixels on vertical axis
    
    LYPixTotal = frmGraph_EMF16.frameYbaseLocator.Top    '7-27-15
    
    dblYRange = dblMaxFullScale                     'default voltage range, changed by zoom/unzoom

    Dim dblTemp As Double
    dblTemp = dblMinFullScale

    dblYIndex = dblYRange - dblTemp
    dblYFS = dblYIndex / 10                       'default Full Scale voltage, changed by autocenter
    
    
    '10-23-15f
    'changed mind If dblYFS > 5# Then dblYFS = 5#

    dblPixsPerVolt = (LYPixTotal - 1) / dblYRange
    dblYIndexPix = dblYIndex * dblPixsPerVolt    'pixels per index tick
    If dblYIndexPix < 1# Then dblYIndexPix = 1#

End Sub
Public Function SecPerScrn_KeyUp_DoIt(KeyCode As Integer, Shift As Integer)
    If KeyCode = 13 Then                'got ENTER key
        If frmGraph_EMF16.SecPerScrn.Text = "" Then GoTo EXIT1
        If frmGraph_EMF16.SecPerScrn.Text = "0" Then GoTo ExitErr
        If frmGraph_EMF16.SecPerScrn.Text = "." Then GoTo ExitErr
        On Error GoTo ExitErr
        RecalcHorizDiv
        DrawScreen
        frmGraph_EMF16.SecPerScrn.BackColor = &H0&
        frmGraph_EMF16.SecPerScrn.ForeColor = &HFF00&
        frmGraph_EMF16.txtGraphKeyEntry.SetFocus
        GoTo EXIT1
    End If
    
    If KeyCode = 8 Then GoTo ExitErr
    If KeyCode > 57 Or KeyCode < 46 Then GoTo ExitErr
    GoTo EXIT1
    
ExitErr:
    If KeyCode = 190 Then GoTo EXIT1        'VB sees period (in text double) as 190
    frmGraph_EMF16.SecPerScrn.Text = ""
    On Error GoTo 0
    
EXIT1:
End Function
Public Function GetMinMaxVolts(ByVal bNumValidVoltages As Byte, ByRef dblMin As Double, ByRef dblMax As Double) As Boolean
    Dim bIndex, bIndex2 As Byte
    Dim minTEMP, maxTEMP As Double
    minTEMP = 5#
    maxTEMP = -5#
    
    frmGraph_EMF16.Text8Neg = 0 & " " & minTEMP
    frmGraph_EMF16.Text5Pos = 0 & " " & maxTEMP
    
'1-14-16 look at this - are these arrays anitialized yet?
    For bIndex = 0 To (bNumValidVoltages - 1)
        If dblMinMaxSubVolts(bIndex) < minTEMP Then
            minTEMP = dblMinMaxSubVolts(bIndex)
        End If
    Next bIndex
    
    For bIndex = 0 To (bNumValidVoltages - 1)
        If dblMinMaxSubVolts(bIndex) > (maxTEMP) Then
            maxTEMP = dblMinMaxSubVolts(bIndex)
        End If
    Next bIndex
    
    dblMin = minTEMP
    dblMax = maxTEMP
End Function
Public Sub HandlePostFullscaleUpdate()
    Dim dblMaxVolts As Double: dblMaxVolts = frmGraph_EMF16.txtPosFullScale.Text
    Dim dblMinVolts As Double: dblMinVolts = frmGraph_EMF16.txtNegFullScale.Text
    If dblMinVolts > dblMaxVolts Then dblMinVolts = dblMaxVolts - 0.0001
    
    frmGraph_EMF16.txtNegFullScale.Text = Format$(dblMinVolts, "##.00000")
    frmGraph_EMF16.txtPosFullScale.Text = Format$(dblMaxVolts, "##.00000")
    
'10-23-15f
'frmGraph_EMF16.txtTempT1 = Format$(dblMaxVolts, "#.00000")
    
    Dim dblVoltageRange As Double: dblVoltageRange = dblMaxVolts - dblMinVolts
    If dblVoltageRange < 0# Then
        dblVoltageRange = 0# - dblVoltageRange
    End If
    
    If dblVoltageRange < 0.00001 Then
        dblVoltageRange = 0.00001
    End If
    
    LYPixTotal = frmGraph_EMF16.ScaleHeight         'number of pixels on vertical axis
    sVFrame = frmGraph_EMF16.frameYbaseLocator.Height
    
    LYPixTotal = LYPixTotal - sVFrame  'number of available pixels on vertical axis
    
    dblYRange = dblVoltageRange
    
    dblYIndex = dblMaxVolts / 10#
    dblYFS = dblMaxVolts                        'default Full Scale voltage, changed by autocenter
    If dblYRange = 0 Then dblYRange = 0.001
    dblPixsPerVolt = (LYPixTotal - 1) / dblYRange
    dblYIndexPix = dblYIndex * dblPixsPerVolt    'pixels per index tick
    If dblYIndexPix < 1# Then dblYIndexPix = 1#
    
    Dim bIndex As Byte
    For bIndex = 0 To 15
        LLastY(bIndex) = -10                     'flag first time
    Next bIndex
End Sub
Public Sub HandleNegFullscaleUpdate()
    Dim dblMaxVolts As Double: dblMaxVolts = frmGraph_EMF16.txtPosFullScale.Text
    Dim dblMinVolts As Double: dblMinVolts = frmGraph_EMF16.txtNegFullScale.Text
    
    If dblMinVolts > dblMaxVolts Then dblMaxVolts = dblMinVolts + 0.001
    
    frmGraph_EMF16.txtPosFullScale.Text = Format$(dblMaxVolts, "##.00000"): frmGraph_EMF16.txtNegFullScale.Text = Format$(dblMinVolts, "##.00000")
    
    Dim dblVoltageRange As Double: dblVoltageRange = dblMaxVolts - dblMinVolts
    If dblVoltageRange < 0# Then dblVoltageRange = 0# - dblVoltageRange
    
        
    Dim bIndex As Byte
    
    LYPixTotal = frmGraph_EMF16.ScaleHeight     'number of pixels on vertical axis
    sVFrame = frmGraph_EMF16.frameYbaseLocator.Height
    
    LYPixTotal = LYPixTotal - sVFrame           'number of available pixels on vertical axis
    dblYRange = dblVoltageRange                 'default voltage range, changed by zoom/unzoom
    If dblYRange = 0 Then dblYRange = 0.001
    
    dblYIndex = dblVoltageRange / 10#
    
    dblYFS = dblMaxVolts                        'default Full Scale voltage, changed by autocenter
    dblPixsPerVolt = (LYPixTotal - 1) / dblYRange
    dblYIndexPix = dblYIndex * dblPixsPerVolt    'pixels per index tick
    If dblYIndexPix < 1# Then dblYIndexPix = 1#
    
    For bIndex = 0 To 15
        LLastY(bIndex) = -10                     'flag first time
    Next bIndex
    
End Sub


